#ifndef PRECOMPOSEDMAPPINGS_H
#define PRECOMPOSEDMAPPINGS_H
/*
 *  Copyright (c) 2018 International Characters, Inc.
 *  This software is licensed to the public under the Open Software License 3.0.
 *  icgrep is a trademark of International Characters, Inc.
 *
 *  This file is generated by UCD_equivalence.py - manual edits may be lost.
 */

#include <unicode/core/unicode_set.h>
#include <map>
#include <string>
#include <vector>

namespace UCD {
class Trie;
typedef std::map<codepoint_t, Trie> BranchMap;

class Trie {
public:
    // Interior Node constructors
    Trie(const codepoint_t p, BranchMap b) : precomposed(p), branches(b) {}
    Trie(BranchMap b) : precomposed(0x110000), branches(b) {}
    // Leaf constructor with a UnicodeSet
    Trie(const codepoint_t p) : precomposed(p) {}
    codepoint_t getPrecomposed() const { return precomposed; }
    void getMatches(std::u32string s, unsigned pos, std::vector<codepoint_t> & matches, std::vector<unsigned> & lgths) const;
    void getClusterMatches(std::u32string s, unsigned pos, std::vector<codepoint_t> & matches) const;
    codepoint_t precomposed;
    BranchMap branches;
};

const static Trie NFD_3C_338(0x226E);
const static BranchMap NFD_3C_map {
    {0x338, NFD_3C_338}};
const static Trie NFD_3C(NFD_3C_map);
const static Trie NFD_3D_338(0x2260);
const static BranchMap NFD_3D_map {
    {0x338, NFD_3D_338}};
const static Trie NFD_3D(NFD_3D_map);
const static Trie NFD_3E_338(0x226F);
const static BranchMap NFD_3E_map {
    {0x338, NFD_3E_338}};
const static Trie NFD_3E(NFD_3E_map);
const static Trie NFD_41_300(0xC0);
const static Trie NFD_41_301(0xC1);
const static Trie NFD_41_302_300(0x1EA6);
const static Trie NFD_41_302_301(0x1EA4);
const static Trie NFD_41_302_303(0x1EAA);
const static Trie NFD_41_302_309(0x1EA8);
const static BranchMap NFD_41_302_map {
    {0x300, NFD_41_302_300},
    {0x301, NFD_41_302_301},
    {0x303, NFD_41_302_303},
    {0x309, NFD_41_302_309}};
const static Trie NFD_41_302(0xC2, NFD_41_302_map);
const static Trie NFD_41_303(0xC3);
const static Trie NFD_41_304(0x100);
const static Trie NFD_41_306_300(0x1EB0);
const static Trie NFD_41_306_301(0x1EAE);
const static Trie NFD_41_306_303(0x1EB4);
const static Trie NFD_41_306_309(0x1EB2);
const static BranchMap NFD_41_306_map {
    {0x300, NFD_41_306_300},
    {0x301, NFD_41_306_301},
    {0x303, NFD_41_306_303},
    {0x309, NFD_41_306_309}};
const static Trie NFD_41_306(0x102, NFD_41_306_map);
const static Trie NFD_41_307_304(0x1E0);
const static BranchMap NFD_41_307_map {
    {0x304, NFD_41_307_304}};
const static Trie NFD_41_307(0x226, NFD_41_307_map);
const static Trie NFD_41_308_304(0x1DE);
const static BranchMap NFD_41_308_map {
    {0x304, NFD_41_308_304}};
const static Trie NFD_41_308(0xC4, NFD_41_308_map);
const static Trie NFD_41_309(0x1EA2);
const static Trie NFD_41_30A_301(0x1FA);
const static BranchMap NFD_41_30A_map {
    {0x301, NFD_41_30A_301}};
const static Trie NFD_41_30A(0xC5, NFD_41_30A_map);
const static Trie NFD_41_30C(0x1CD);
const static Trie NFD_41_30F(0x200);
const static Trie NFD_41_311(0x202);
const static Trie NFD_41_323_302(0x1EAC);
const static Trie NFD_41_323_306(0x1EB6);
const static BranchMap NFD_41_323_map {
    {0x302, NFD_41_323_302},
    {0x306, NFD_41_323_306}};
const static Trie NFD_41_323(0x1EA0, NFD_41_323_map);
const static Trie NFD_41_325(0x1E00);
const static Trie NFD_41_328(0x104);
const static BranchMap NFD_41_map {
    {0x300, NFD_41_300},
    {0x301, NFD_41_301},
    {0x302, NFD_41_302},
    {0x303, NFD_41_303},
    {0x304, NFD_41_304},
    {0x306, NFD_41_306},
    {0x307, NFD_41_307},
    {0x308, NFD_41_308},
    {0x309, NFD_41_309},
    {0x30A, NFD_41_30A},
    {0x30C, NFD_41_30C},
    {0x30F, NFD_41_30F},
    {0x311, NFD_41_311},
    {0x323, NFD_41_323},
    {0x325, NFD_41_325},
    {0x328, NFD_41_328}};
const static Trie NFD_41(NFD_41_map);
const static Trie NFD_42_307(0x1E02);
const static Trie NFD_42_323(0x1E04);
const static Trie NFD_42_331(0x1E06);
const static BranchMap NFD_42_map {
    {0x307, NFD_42_307},
    {0x323, NFD_42_323},
    {0x331, NFD_42_331}};
const static Trie NFD_42(NFD_42_map);
const static Trie NFD_43_301(0x106);
const static Trie NFD_43_302(0x108);
const static Trie NFD_43_307(0x10A);
const static Trie NFD_43_30C(0x10C);
const static Trie NFD_43_327_301(0x1E08);
const static BranchMap NFD_43_327_map {
    {0x301, NFD_43_327_301}};
const static Trie NFD_43_327(0xC7, NFD_43_327_map);
const static BranchMap NFD_43_map {
    {0x301, NFD_43_301},
    {0x302, NFD_43_302},
    {0x307, NFD_43_307},
    {0x30C, NFD_43_30C},
    {0x327, NFD_43_327}};
const static Trie NFD_43(NFD_43_map);
const static Trie NFD_44_307(0x1E0A);
const static Trie NFD_44_30C(0x10E);
const static Trie NFD_44_323(0x1E0C);
const static Trie NFD_44_327(0x1E10);
const static Trie NFD_44_32D(0x1E12);
const static Trie NFD_44_331(0x1E0E);
const static BranchMap NFD_44_map {
    {0x307, NFD_44_307},
    {0x30C, NFD_44_30C},
    {0x323, NFD_44_323},
    {0x327, NFD_44_327},
    {0x32D, NFD_44_32D},
    {0x331, NFD_44_331}};
const static Trie NFD_44(NFD_44_map);
const static Trie NFD_45_300(0xC8);
const static Trie NFD_45_301(0xC9);
const static Trie NFD_45_302_300(0x1EC0);
const static Trie NFD_45_302_301(0x1EBE);
const static Trie NFD_45_302_303(0x1EC4);
const static Trie NFD_45_302_309(0x1EC2);
const static BranchMap NFD_45_302_map {
    {0x300, NFD_45_302_300},
    {0x301, NFD_45_302_301},
    {0x303, NFD_45_302_303},
    {0x309, NFD_45_302_309}};
const static Trie NFD_45_302(0xCA, NFD_45_302_map);
const static Trie NFD_45_303(0x1EBC);
const static Trie NFD_45_304_300(0x1E14);
const static Trie NFD_45_304_301(0x1E16);
const static BranchMap NFD_45_304_map {
    {0x300, NFD_45_304_300},
    {0x301, NFD_45_304_301}};
const static Trie NFD_45_304(0x112, NFD_45_304_map);
const static Trie NFD_45_306(0x114);
const static Trie NFD_45_307(0x116);
const static Trie NFD_45_308(0xCB);
const static Trie NFD_45_309(0x1EBA);
const static Trie NFD_45_30C(0x11A);
const static Trie NFD_45_30F(0x204);
const static Trie NFD_45_311(0x206);
const static Trie NFD_45_323_302(0x1EC6);
const static BranchMap NFD_45_323_map {
    {0x302, NFD_45_323_302}};
const static Trie NFD_45_323(0x1EB8, NFD_45_323_map);
const static Trie NFD_45_327_306(0x1E1C);
const static BranchMap NFD_45_327_map {
    {0x306, NFD_45_327_306}};
const static Trie NFD_45_327(0x228, NFD_45_327_map);
const static Trie NFD_45_328(0x118);
const static Trie NFD_45_32D(0x1E18);
const static Trie NFD_45_330(0x1E1A);
const static BranchMap NFD_45_map {
    {0x300, NFD_45_300},
    {0x301, NFD_45_301},
    {0x302, NFD_45_302},
    {0x303, NFD_45_303},
    {0x304, NFD_45_304},
    {0x306, NFD_45_306},
    {0x307, NFD_45_307},
    {0x308, NFD_45_308},
    {0x309, NFD_45_309},
    {0x30C, NFD_45_30C},
    {0x30F, NFD_45_30F},
    {0x311, NFD_45_311},
    {0x323, NFD_45_323},
    {0x327, NFD_45_327},
    {0x328, NFD_45_328},
    {0x32D, NFD_45_32D},
    {0x330, NFD_45_330}};
const static Trie NFD_45(NFD_45_map);
const static Trie NFD_46_307(0x1E1E);
const static BranchMap NFD_46_map {
    {0x307, NFD_46_307}};
const static Trie NFD_46(NFD_46_map);
const static Trie NFD_47_301(0x1F4);
const static Trie NFD_47_302(0x11C);
const static Trie NFD_47_304(0x1E20);
const static Trie NFD_47_306(0x11E);
const static Trie NFD_47_307(0x120);
const static Trie NFD_47_30C(0x1E6);
const static Trie NFD_47_327(0x122);
const static BranchMap NFD_47_map {
    {0x301, NFD_47_301},
    {0x302, NFD_47_302},
    {0x304, NFD_47_304},
    {0x306, NFD_47_306},
    {0x307, NFD_47_307},
    {0x30C, NFD_47_30C},
    {0x327, NFD_47_327}};
const static Trie NFD_47(NFD_47_map);
const static Trie NFD_48_302(0x124);
const static Trie NFD_48_307(0x1E22);
const static Trie NFD_48_308(0x1E26);
const static Trie NFD_48_30C(0x21E);
const static Trie NFD_48_323(0x1E24);
const static Trie NFD_48_327(0x1E28);
const static Trie NFD_48_32E(0x1E2A);
const static BranchMap NFD_48_map {
    {0x302, NFD_48_302},
    {0x307, NFD_48_307},
    {0x308, NFD_48_308},
    {0x30C, NFD_48_30C},
    {0x323, NFD_48_323},
    {0x327, NFD_48_327},
    {0x32E, NFD_48_32E}};
const static Trie NFD_48(NFD_48_map);
const static Trie NFD_49_300(0xCC);
const static Trie NFD_49_301(0xCD);
const static Trie NFD_49_302(0xCE);
const static Trie NFD_49_303(0x128);
const static Trie NFD_49_304(0x12A);
const static Trie NFD_49_306(0x12C);
const static Trie NFD_49_307(0x130);
const static Trie NFD_49_308_301(0x1E2E);
const static BranchMap NFD_49_308_map {
    {0x301, NFD_49_308_301}};
const static Trie NFD_49_308(0xCF, NFD_49_308_map);
const static Trie NFD_49_309(0x1EC8);
const static Trie NFD_49_30C(0x1CF);
const static Trie NFD_49_30F(0x208);
const static Trie NFD_49_311(0x20A);
const static Trie NFD_49_323(0x1ECA);
const static Trie NFD_49_328(0x12E);
const static Trie NFD_49_330(0x1E2C);
const static BranchMap NFD_49_map {
    {0x300, NFD_49_300},
    {0x301, NFD_49_301},
    {0x302, NFD_49_302},
    {0x303, NFD_49_303},
    {0x304, NFD_49_304},
    {0x306, NFD_49_306},
    {0x307, NFD_49_307},
    {0x308, NFD_49_308},
    {0x309, NFD_49_309},
    {0x30C, NFD_49_30C},
    {0x30F, NFD_49_30F},
    {0x311, NFD_49_311},
    {0x323, NFD_49_323},
    {0x328, NFD_49_328},
    {0x330, NFD_49_330}};
const static Trie NFD_49(NFD_49_map);
const static Trie NFD_4A_302(0x134);
const static BranchMap NFD_4A_map {
    {0x302, NFD_4A_302}};
const static Trie NFD_4A(NFD_4A_map);
const static Trie NFD_4B_301(0x1E30);
const static Trie NFD_4B_30C(0x1E8);
const static Trie NFD_4B_323(0x1E32);
const static Trie NFD_4B_327(0x136);
const static Trie NFD_4B_331(0x1E34);
const static BranchMap NFD_4B_map {
    {0x301, NFD_4B_301},
    {0x30C, NFD_4B_30C},
    {0x323, NFD_4B_323},
    {0x327, NFD_4B_327},
    {0x331, NFD_4B_331}};
const static Trie NFD_4B(NFD_4B_map);
const static Trie NFD_4C_301(0x139);
const static Trie NFD_4C_30C(0x13D);
const static Trie NFD_4C_323_304(0x1E38);
const static BranchMap NFD_4C_323_map {
    {0x304, NFD_4C_323_304}};
const static Trie NFD_4C_323(0x1E36, NFD_4C_323_map);
const static Trie NFD_4C_327(0x13B);
const static Trie NFD_4C_32D(0x1E3C);
const static Trie NFD_4C_331(0x1E3A);
const static BranchMap NFD_4C_map {
    {0x301, NFD_4C_301},
    {0x30C, NFD_4C_30C},
    {0x323, NFD_4C_323},
    {0x327, NFD_4C_327},
    {0x32D, NFD_4C_32D},
    {0x331, NFD_4C_331}};
const static Trie NFD_4C(NFD_4C_map);
const static Trie NFD_4D_301(0x1E3E);
const static Trie NFD_4D_307(0x1E40);
const static Trie NFD_4D_323(0x1E42);
const static BranchMap NFD_4D_map {
    {0x301, NFD_4D_301},
    {0x307, NFD_4D_307},
    {0x323, NFD_4D_323}};
const static Trie NFD_4D(NFD_4D_map);
const static Trie NFD_4E_300(0x1F8);
const static Trie NFD_4E_301(0x143);
const static Trie NFD_4E_303(0xD1);
const static Trie NFD_4E_307(0x1E44);
const static Trie NFD_4E_30C(0x147);
const static Trie NFD_4E_323(0x1E46);
const static Trie NFD_4E_327(0x145);
const static Trie NFD_4E_32D(0x1E4A);
const static Trie NFD_4E_331(0x1E48);
const static BranchMap NFD_4E_map {
    {0x300, NFD_4E_300},
    {0x301, NFD_4E_301},
    {0x303, NFD_4E_303},
    {0x307, NFD_4E_307},
    {0x30C, NFD_4E_30C},
    {0x323, NFD_4E_323},
    {0x327, NFD_4E_327},
    {0x32D, NFD_4E_32D},
    {0x331, NFD_4E_331}};
const static Trie NFD_4E(NFD_4E_map);
const static Trie NFD_4F_300(0xD2);
const static Trie NFD_4F_301(0xD3);
const static Trie NFD_4F_302_300(0x1ED2);
const static Trie NFD_4F_302_301(0x1ED0);
const static Trie NFD_4F_302_303(0x1ED6);
const static Trie NFD_4F_302_309(0x1ED4);
const static BranchMap NFD_4F_302_map {
    {0x300, NFD_4F_302_300},
    {0x301, NFD_4F_302_301},
    {0x303, NFD_4F_302_303},
    {0x309, NFD_4F_302_309}};
const static Trie NFD_4F_302(0xD4, NFD_4F_302_map);
const static Trie NFD_4F_303_301(0x1E4C);
const static Trie NFD_4F_303_304(0x22C);
const static Trie NFD_4F_303_308(0x1E4E);
const static BranchMap NFD_4F_303_map {
    {0x301, NFD_4F_303_301},
    {0x304, NFD_4F_303_304},
    {0x308, NFD_4F_303_308}};
const static Trie NFD_4F_303(0xD5, NFD_4F_303_map);
const static Trie NFD_4F_304_300(0x1E50);
const static Trie NFD_4F_304_301(0x1E52);
const static BranchMap NFD_4F_304_map {
    {0x300, NFD_4F_304_300},
    {0x301, NFD_4F_304_301}};
const static Trie NFD_4F_304(0x14C, NFD_4F_304_map);
const static Trie NFD_4F_306(0x14E);
const static Trie NFD_4F_307_304(0x230);
const static BranchMap NFD_4F_307_map {
    {0x304, NFD_4F_307_304}};
const static Trie NFD_4F_307(0x22E, NFD_4F_307_map);
const static Trie NFD_4F_308_304(0x22A);
const static BranchMap NFD_4F_308_map {
    {0x304, NFD_4F_308_304}};
const static Trie NFD_4F_308(0xD6, NFD_4F_308_map);
const static Trie NFD_4F_309(0x1ECE);
const static Trie NFD_4F_30B(0x150);
const static Trie NFD_4F_30C(0x1D1);
const static Trie NFD_4F_30F(0x20C);
const static Trie NFD_4F_311(0x20E);
const static Trie NFD_4F_31B_300(0x1EDC);
const static Trie NFD_4F_31B_301(0x1EDA);
const static Trie NFD_4F_31B_303(0x1EE0);
const static Trie NFD_4F_31B_309(0x1EDE);
const static Trie NFD_4F_31B_323(0x1EE2);
const static BranchMap NFD_4F_31B_map {
    {0x300, NFD_4F_31B_300},
    {0x301, NFD_4F_31B_301},
    {0x303, NFD_4F_31B_303},
    {0x309, NFD_4F_31B_309},
    {0x323, NFD_4F_31B_323}};
const static Trie NFD_4F_31B(0x1A0, NFD_4F_31B_map);
const static Trie NFD_4F_323_302(0x1ED8);
const static BranchMap NFD_4F_323_map {
    {0x302, NFD_4F_323_302}};
const static Trie NFD_4F_323(0x1ECC, NFD_4F_323_map);
const static Trie NFD_4F_328_304(0x1EC);
const static BranchMap NFD_4F_328_map {
    {0x304, NFD_4F_328_304}};
const static Trie NFD_4F_328(0x1EA, NFD_4F_328_map);
const static BranchMap NFD_4F_map {
    {0x300, NFD_4F_300},
    {0x301, NFD_4F_301},
    {0x302, NFD_4F_302},
    {0x303, NFD_4F_303},
    {0x304, NFD_4F_304},
    {0x306, NFD_4F_306},
    {0x307, NFD_4F_307},
    {0x308, NFD_4F_308},
    {0x309, NFD_4F_309},
    {0x30B, NFD_4F_30B},
    {0x30C, NFD_4F_30C},
    {0x30F, NFD_4F_30F},
    {0x311, NFD_4F_311},
    {0x31B, NFD_4F_31B},
    {0x323, NFD_4F_323},
    {0x328, NFD_4F_328}};
const static Trie NFD_4F(NFD_4F_map);
const static Trie NFD_50_301(0x1E54);
const static Trie NFD_50_307(0x1E56);
const static BranchMap NFD_50_map {
    {0x301, NFD_50_301},
    {0x307, NFD_50_307}};
const static Trie NFD_50(NFD_50_map);
const static Trie NFD_52_301(0x154);
const static Trie NFD_52_307(0x1E58);
const static Trie NFD_52_30C(0x158);
const static Trie NFD_52_30F(0x210);
const static Trie NFD_52_311(0x212);
const static Trie NFD_52_323_304(0x1E5C);
const static BranchMap NFD_52_323_map {
    {0x304, NFD_52_323_304}};
const static Trie NFD_52_323(0x1E5A, NFD_52_323_map);
const static Trie NFD_52_327(0x156);
const static Trie NFD_52_331(0x1E5E);
const static BranchMap NFD_52_map {
    {0x301, NFD_52_301},
    {0x307, NFD_52_307},
    {0x30C, NFD_52_30C},
    {0x30F, NFD_52_30F},
    {0x311, NFD_52_311},
    {0x323, NFD_52_323},
    {0x327, NFD_52_327},
    {0x331, NFD_52_331}};
const static Trie NFD_52(NFD_52_map);
const static Trie NFD_53_301_307(0x1E64);
const static BranchMap NFD_53_301_map {
    {0x307, NFD_53_301_307}};
const static Trie NFD_53_301(0x15A, NFD_53_301_map);
const static Trie NFD_53_302(0x15C);
const static Trie NFD_53_307(0x1E60);
const static Trie NFD_53_30C_307(0x1E66);
const static BranchMap NFD_53_30C_map {
    {0x307, NFD_53_30C_307}};
const static Trie NFD_53_30C(0x160, NFD_53_30C_map);
const static Trie NFD_53_323_307(0x1E68);
const static BranchMap NFD_53_323_map {
    {0x307, NFD_53_323_307}};
const static Trie NFD_53_323(0x1E62, NFD_53_323_map);
const static Trie NFD_53_326(0x218);
const static Trie NFD_53_327(0x15E);
const static BranchMap NFD_53_map {
    {0x301, NFD_53_301},
    {0x302, NFD_53_302},
    {0x307, NFD_53_307},
    {0x30C, NFD_53_30C},
    {0x323, NFD_53_323},
    {0x326, NFD_53_326},
    {0x327, NFD_53_327}};
const static Trie NFD_53(NFD_53_map);
const static Trie NFD_54_307(0x1E6A);
const static Trie NFD_54_30C(0x164);
const static Trie NFD_54_323(0x1E6C);
const static Trie NFD_54_326(0x21A);
const static Trie NFD_54_327(0x162);
const static Trie NFD_54_32D(0x1E70);
const static Trie NFD_54_331(0x1E6E);
const static BranchMap NFD_54_map {
    {0x307, NFD_54_307},
    {0x30C, NFD_54_30C},
    {0x323, NFD_54_323},
    {0x326, NFD_54_326},
    {0x327, NFD_54_327},
    {0x32D, NFD_54_32D},
    {0x331, NFD_54_331}};
const static Trie NFD_54(NFD_54_map);
const static Trie NFD_55_300(0xD9);
const static Trie NFD_55_301(0xDA);
const static Trie NFD_55_302(0xDB);
const static Trie NFD_55_303_301(0x1E78);
const static BranchMap NFD_55_303_map {
    {0x301, NFD_55_303_301}};
const static Trie NFD_55_303(0x168, NFD_55_303_map);
const static Trie NFD_55_304_308(0x1E7A);
const static BranchMap NFD_55_304_map {
    {0x308, NFD_55_304_308}};
const static Trie NFD_55_304(0x16A, NFD_55_304_map);
const static Trie NFD_55_306(0x16C);
const static Trie NFD_55_308_300(0x1DB);
const static Trie NFD_55_308_301(0x1D7);
const static Trie NFD_55_308_304(0x1D5);
const static Trie NFD_55_308_30C(0x1D9);
const static BranchMap NFD_55_308_map {
    {0x300, NFD_55_308_300},
    {0x301, NFD_55_308_301},
    {0x304, NFD_55_308_304},
    {0x30C, NFD_55_308_30C}};
const static Trie NFD_55_308(0xDC, NFD_55_308_map);
const static Trie NFD_55_309(0x1EE6);
const static Trie NFD_55_30A(0x16E);
const static Trie NFD_55_30B(0x170);
const static Trie NFD_55_30C(0x1D3);
const static Trie NFD_55_30F(0x214);
const static Trie NFD_55_311(0x216);
const static Trie NFD_55_31B_300(0x1EEA);
const static Trie NFD_55_31B_301(0x1EE8);
const static Trie NFD_55_31B_303(0x1EEE);
const static Trie NFD_55_31B_309(0x1EEC);
const static Trie NFD_55_31B_323(0x1EF0);
const static BranchMap NFD_55_31B_map {
    {0x300, NFD_55_31B_300},
    {0x301, NFD_55_31B_301},
    {0x303, NFD_55_31B_303},
    {0x309, NFD_55_31B_309},
    {0x323, NFD_55_31B_323}};
const static Trie NFD_55_31B(0x1AF, NFD_55_31B_map);
const static Trie NFD_55_323(0x1EE4);
const static Trie NFD_55_324(0x1E72);
const static Trie NFD_55_328(0x172);
const static Trie NFD_55_32D(0x1E76);
const static Trie NFD_55_330(0x1E74);
const static BranchMap NFD_55_map {
    {0x300, NFD_55_300},
    {0x301, NFD_55_301},
    {0x302, NFD_55_302},
    {0x303, NFD_55_303},
    {0x304, NFD_55_304},
    {0x306, NFD_55_306},
    {0x308, NFD_55_308},
    {0x309, NFD_55_309},
    {0x30A, NFD_55_30A},
    {0x30B, NFD_55_30B},
    {0x30C, NFD_55_30C},
    {0x30F, NFD_55_30F},
    {0x311, NFD_55_311},
    {0x31B, NFD_55_31B},
    {0x323, NFD_55_323},
    {0x324, NFD_55_324},
    {0x328, NFD_55_328},
    {0x32D, NFD_55_32D},
    {0x330, NFD_55_330}};
const static Trie NFD_55(NFD_55_map);
const static Trie NFD_56_303(0x1E7C);
const static Trie NFD_56_323(0x1E7E);
const static BranchMap NFD_56_map {
    {0x303, NFD_56_303},
    {0x323, NFD_56_323}};
const static Trie NFD_56(NFD_56_map);
const static Trie NFD_57_300(0x1E80);
const static Trie NFD_57_301(0x1E82);
const static Trie NFD_57_302(0x174);
const static Trie NFD_57_307(0x1E86);
const static Trie NFD_57_308(0x1E84);
const static Trie NFD_57_323(0x1E88);
const static BranchMap NFD_57_map {
    {0x300, NFD_57_300},
    {0x301, NFD_57_301},
    {0x302, NFD_57_302},
    {0x307, NFD_57_307},
    {0x308, NFD_57_308},
    {0x323, NFD_57_323}};
const static Trie NFD_57(NFD_57_map);
const static Trie NFD_58_307(0x1E8A);
const static Trie NFD_58_308(0x1E8C);
const static BranchMap NFD_58_map {
    {0x307, NFD_58_307},
    {0x308, NFD_58_308}};
const static Trie NFD_58(NFD_58_map);
const static Trie NFD_59_300(0x1EF2);
const static Trie NFD_59_301(0xDD);
const static Trie NFD_59_302(0x176);
const static Trie NFD_59_303(0x1EF8);
const static Trie NFD_59_304(0x232);
const static Trie NFD_59_307(0x1E8E);
const static Trie NFD_59_308(0x178);
const static Trie NFD_59_309(0x1EF6);
const static Trie NFD_59_323(0x1EF4);
const static BranchMap NFD_59_map {
    {0x300, NFD_59_300},
    {0x301, NFD_59_301},
    {0x302, NFD_59_302},
    {0x303, NFD_59_303},
    {0x304, NFD_59_304},
    {0x307, NFD_59_307},
    {0x308, NFD_59_308},
    {0x309, NFD_59_309},
    {0x323, NFD_59_323}};
const static Trie NFD_59(NFD_59_map);
const static Trie NFD_5A_301(0x179);
const static Trie NFD_5A_302(0x1E90);
const static Trie NFD_5A_307(0x17B);
const static Trie NFD_5A_30C(0x17D);
const static Trie NFD_5A_323(0x1E92);
const static Trie NFD_5A_331(0x1E94);
const static BranchMap NFD_5A_map {
    {0x301, NFD_5A_301},
    {0x302, NFD_5A_302},
    {0x307, NFD_5A_307},
    {0x30C, NFD_5A_30C},
    {0x323, NFD_5A_323},
    {0x331, NFD_5A_331}};
const static Trie NFD_5A(NFD_5A_map);
const static Trie NFD_61_300(0xE0);
const static Trie NFD_61_301(0xE1);
const static Trie NFD_61_302_300(0x1EA7);
const static Trie NFD_61_302_301(0x1EA5);
const static Trie NFD_61_302_303(0x1EAB);
const static Trie NFD_61_302_309(0x1EA9);
const static BranchMap NFD_61_302_map {
    {0x300, NFD_61_302_300},
    {0x301, NFD_61_302_301},
    {0x303, NFD_61_302_303},
    {0x309, NFD_61_302_309}};
const static Trie NFD_61_302(0xE2, NFD_61_302_map);
const static Trie NFD_61_303(0xE3);
const static Trie NFD_61_304(0x101);
const static Trie NFD_61_306_300(0x1EB1);
const static Trie NFD_61_306_301(0x1EAF);
const static Trie NFD_61_306_303(0x1EB5);
const static Trie NFD_61_306_309(0x1EB3);
const static BranchMap NFD_61_306_map {
    {0x300, NFD_61_306_300},
    {0x301, NFD_61_306_301},
    {0x303, NFD_61_306_303},
    {0x309, NFD_61_306_309}};
const static Trie NFD_61_306(0x103, NFD_61_306_map);
const static Trie NFD_61_307_304(0x1E1);
const static BranchMap NFD_61_307_map {
    {0x304, NFD_61_307_304}};
const static Trie NFD_61_307(0x227, NFD_61_307_map);
const static Trie NFD_61_308_304(0x1DF);
const static BranchMap NFD_61_308_map {
    {0x304, NFD_61_308_304}};
const static Trie NFD_61_308(0xE4, NFD_61_308_map);
const static Trie NFD_61_309(0x1EA3);
const static Trie NFD_61_30A_301(0x1FB);
const static BranchMap NFD_61_30A_map {
    {0x301, NFD_61_30A_301}};
const static Trie NFD_61_30A(0xE5, NFD_61_30A_map);
const static Trie NFD_61_30C(0x1CE);
const static Trie NFD_61_30F(0x201);
const static Trie NFD_61_311(0x203);
const static Trie NFD_61_323_302(0x1EAD);
const static Trie NFD_61_323_306(0x1EB7);
const static BranchMap NFD_61_323_map {
    {0x302, NFD_61_323_302},
    {0x306, NFD_61_323_306}};
const static Trie NFD_61_323(0x1EA1, NFD_61_323_map);
const static Trie NFD_61_325(0x1E01);
const static Trie NFD_61_328(0x105);
const static BranchMap NFD_61_map {
    {0x300, NFD_61_300},
    {0x301, NFD_61_301},
    {0x302, NFD_61_302},
    {0x303, NFD_61_303},
    {0x304, NFD_61_304},
    {0x306, NFD_61_306},
    {0x307, NFD_61_307},
    {0x308, NFD_61_308},
    {0x309, NFD_61_309},
    {0x30A, NFD_61_30A},
    {0x30C, NFD_61_30C},
    {0x30F, NFD_61_30F},
    {0x311, NFD_61_311},
    {0x323, NFD_61_323},
    {0x325, NFD_61_325},
    {0x328, NFD_61_328}};
const static Trie NFD_61(NFD_61_map);
const static Trie NFD_62_307(0x1E03);
const static Trie NFD_62_323(0x1E05);
const static Trie NFD_62_331(0x1E07);
const static BranchMap NFD_62_map {
    {0x307, NFD_62_307},
    {0x323, NFD_62_323},
    {0x331, NFD_62_331}};
const static Trie NFD_62(NFD_62_map);
const static Trie NFD_63_301(0x107);
const static Trie NFD_63_302(0x109);
const static Trie NFD_63_307(0x10B);
const static Trie NFD_63_30C(0x10D);
const static Trie NFD_63_327_301(0x1E09);
const static BranchMap NFD_63_327_map {
    {0x301, NFD_63_327_301}};
const static Trie NFD_63_327(0xE7, NFD_63_327_map);
const static BranchMap NFD_63_map {
    {0x301, NFD_63_301},
    {0x302, NFD_63_302},
    {0x307, NFD_63_307},
    {0x30C, NFD_63_30C},
    {0x327, NFD_63_327}};
const static Trie NFD_63(NFD_63_map);
const static Trie NFD_64_307(0x1E0B);
const static Trie NFD_64_30C(0x10F);
const static Trie NFD_64_323(0x1E0D);
const static Trie NFD_64_327(0x1E11);
const static Trie NFD_64_32D(0x1E13);
const static Trie NFD_64_331(0x1E0F);
const static BranchMap NFD_64_map {
    {0x307, NFD_64_307},
    {0x30C, NFD_64_30C},
    {0x323, NFD_64_323},
    {0x327, NFD_64_327},
    {0x32D, NFD_64_32D},
    {0x331, NFD_64_331}};
const static Trie NFD_64(NFD_64_map);
const static Trie NFD_65_300(0xE8);
const static Trie NFD_65_301(0xE9);
const static Trie NFD_65_302_300(0x1EC1);
const static Trie NFD_65_302_301(0x1EBF);
const static Trie NFD_65_302_303(0x1EC5);
const static Trie NFD_65_302_309(0x1EC3);
const static BranchMap NFD_65_302_map {
    {0x300, NFD_65_302_300},
    {0x301, NFD_65_302_301},
    {0x303, NFD_65_302_303},
    {0x309, NFD_65_302_309}};
const static Trie NFD_65_302(0xEA, NFD_65_302_map);
const static Trie NFD_65_303(0x1EBD);
const static Trie NFD_65_304_300(0x1E15);
const static Trie NFD_65_304_301(0x1E17);
const static BranchMap NFD_65_304_map {
    {0x300, NFD_65_304_300},
    {0x301, NFD_65_304_301}};
const static Trie NFD_65_304(0x113, NFD_65_304_map);
const static Trie NFD_65_306(0x115);
const static Trie NFD_65_307(0x117);
const static Trie NFD_65_308(0xEB);
const static Trie NFD_65_309(0x1EBB);
const static Trie NFD_65_30C(0x11B);
const static Trie NFD_65_30F(0x205);
const static Trie NFD_65_311(0x207);
const static Trie NFD_65_323_302(0x1EC7);
const static BranchMap NFD_65_323_map {
    {0x302, NFD_65_323_302}};
const static Trie NFD_65_323(0x1EB9, NFD_65_323_map);
const static Trie NFD_65_327_306(0x1E1D);
const static BranchMap NFD_65_327_map {
    {0x306, NFD_65_327_306}};
const static Trie NFD_65_327(0x229, NFD_65_327_map);
const static Trie NFD_65_328(0x119);
const static Trie NFD_65_32D(0x1E19);
const static Trie NFD_65_330(0x1E1B);
const static BranchMap NFD_65_map {
    {0x300, NFD_65_300},
    {0x301, NFD_65_301},
    {0x302, NFD_65_302},
    {0x303, NFD_65_303},
    {0x304, NFD_65_304},
    {0x306, NFD_65_306},
    {0x307, NFD_65_307},
    {0x308, NFD_65_308},
    {0x309, NFD_65_309},
    {0x30C, NFD_65_30C},
    {0x30F, NFD_65_30F},
    {0x311, NFD_65_311},
    {0x323, NFD_65_323},
    {0x327, NFD_65_327},
    {0x328, NFD_65_328},
    {0x32D, NFD_65_32D},
    {0x330, NFD_65_330}};
const static Trie NFD_65(NFD_65_map);
const static Trie NFD_66_307(0x1E1F);
const static BranchMap NFD_66_map {
    {0x307, NFD_66_307}};
const static Trie NFD_66(NFD_66_map);
const static Trie NFD_67_301(0x1F5);
const static Trie NFD_67_302(0x11D);
const static Trie NFD_67_304(0x1E21);
const static Trie NFD_67_306(0x11F);
const static Trie NFD_67_307(0x121);
const static Trie NFD_67_30C(0x1E7);
const static Trie NFD_67_327(0x123);
const static BranchMap NFD_67_map {
    {0x301, NFD_67_301},
    {0x302, NFD_67_302},
    {0x304, NFD_67_304},
    {0x306, NFD_67_306},
    {0x307, NFD_67_307},
    {0x30C, NFD_67_30C},
    {0x327, NFD_67_327}};
const static Trie NFD_67(NFD_67_map);
const static Trie NFD_68_302(0x125);
const static Trie NFD_68_307(0x1E23);
const static Trie NFD_68_308(0x1E27);
const static Trie NFD_68_30C(0x21F);
const static Trie NFD_68_323(0x1E25);
const static Trie NFD_68_327(0x1E29);
const static Trie NFD_68_32E(0x1E2B);
const static Trie NFD_68_331(0x1E96);
const static BranchMap NFD_68_map {
    {0x302, NFD_68_302},
    {0x307, NFD_68_307},
    {0x308, NFD_68_308},
    {0x30C, NFD_68_30C},
    {0x323, NFD_68_323},
    {0x327, NFD_68_327},
    {0x32E, NFD_68_32E},
    {0x331, NFD_68_331}};
const static Trie NFD_68(NFD_68_map);
const static Trie NFD_69_300(0xEC);
const static Trie NFD_69_301(0xED);
const static Trie NFD_69_302(0xEE);
const static Trie NFD_69_303(0x129);
const static Trie NFD_69_304(0x12B);
const static Trie NFD_69_306(0x12D);
const static Trie NFD_69_308_301(0x1E2F);
const static BranchMap NFD_69_308_map {
    {0x301, NFD_69_308_301}};
const static Trie NFD_69_308(0xEF, NFD_69_308_map);
const static Trie NFD_69_309(0x1EC9);
const static Trie NFD_69_30C(0x1D0);
const static Trie NFD_69_30F(0x209);
const static Trie NFD_69_311(0x20B);
const static Trie NFD_69_323(0x1ECB);
const static Trie NFD_69_328(0x12F);
const static Trie NFD_69_330(0x1E2D);
const static BranchMap NFD_69_map {
    {0x300, NFD_69_300},
    {0x301, NFD_69_301},
    {0x302, NFD_69_302},
    {0x303, NFD_69_303},
    {0x304, NFD_69_304},
    {0x306, NFD_69_306},
    {0x308, NFD_69_308},
    {0x309, NFD_69_309},
    {0x30C, NFD_69_30C},
    {0x30F, NFD_69_30F},
    {0x311, NFD_69_311},
    {0x323, NFD_69_323},
    {0x328, NFD_69_328},
    {0x330, NFD_69_330}};
const static Trie NFD_69(NFD_69_map);
const static Trie NFD_6A_302(0x135);
const static Trie NFD_6A_30C(0x1F0);
const static BranchMap NFD_6A_map {
    {0x302, NFD_6A_302},
    {0x30C, NFD_6A_30C}};
const static Trie NFD_6A(NFD_6A_map);
const static Trie NFD_6B_301(0x1E31);
const static Trie NFD_6B_30C(0x1E9);
const static Trie NFD_6B_323(0x1E33);
const static Trie NFD_6B_327(0x137);
const static Trie NFD_6B_331(0x1E35);
const static BranchMap NFD_6B_map {
    {0x301, NFD_6B_301},
    {0x30C, NFD_6B_30C},
    {0x323, NFD_6B_323},
    {0x327, NFD_6B_327},
    {0x331, NFD_6B_331}};
const static Trie NFD_6B(NFD_6B_map);
const static Trie NFD_6C_301(0x13A);
const static Trie NFD_6C_30C(0x13E);
const static Trie NFD_6C_323_304(0x1E39);
const static BranchMap NFD_6C_323_map {
    {0x304, NFD_6C_323_304}};
const static Trie NFD_6C_323(0x1E37, NFD_6C_323_map);
const static Trie NFD_6C_327(0x13C);
const static Trie NFD_6C_32D(0x1E3D);
const static Trie NFD_6C_331(0x1E3B);
const static BranchMap NFD_6C_map {
    {0x301, NFD_6C_301},
    {0x30C, NFD_6C_30C},
    {0x323, NFD_6C_323},
    {0x327, NFD_6C_327},
    {0x32D, NFD_6C_32D},
    {0x331, NFD_6C_331}};
const static Trie NFD_6C(NFD_6C_map);
const static Trie NFD_6D_301(0x1E3F);
const static Trie NFD_6D_307(0x1E41);
const static Trie NFD_6D_323(0x1E43);
const static BranchMap NFD_6D_map {
    {0x301, NFD_6D_301},
    {0x307, NFD_6D_307},
    {0x323, NFD_6D_323}};
const static Trie NFD_6D(NFD_6D_map);
const static Trie NFD_6E_300(0x1F9);
const static Trie NFD_6E_301(0x144);
const static Trie NFD_6E_303(0xF1);
const static Trie NFD_6E_307(0x1E45);
const static Trie NFD_6E_30C(0x148);
const static Trie NFD_6E_323(0x1E47);
const static Trie NFD_6E_327(0x146);
const static Trie NFD_6E_32D(0x1E4B);
const static Trie NFD_6E_331(0x1E49);
const static BranchMap NFD_6E_map {
    {0x300, NFD_6E_300},
    {0x301, NFD_6E_301},
    {0x303, NFD_6E_303},
    {0x307, NFD_6E_307},
    {0x30C, NFD_6E_30C},
    {0x323, NFD_6E_323},
    {0x327, NFD_6E_327},
    {0x32D, NFD_6E_32D},
    {0x331, NFD_6E_331}};
const static Trie NFD_6E(NFD_6E_map);
const static Trie NFD_6F_300(0xF2);
const static Trie NFD_6F_301(0xF3);
const static Trie NFD_6F_302_300(0x1ED3);
const static Trie NFD_6F_302_301(0x1ED1);
const static Trie NFD_6F_302_303(0x1ED7);
const static Trie NFD_6F_302_309(0x1ED5);
const static BranchMap NFD_6F_302_map {
    {0x300, NFD_6F_302_300},
    {0x301, NFD_6F_302_301},
    {0x303, NFD_6F_302_303},
    {0x309, NFD_6F_302_309}};
const static Trie NFD_6F_302(0xF4, NFD_6F_302_map);
const static Trie NFD_6F_303_301(0x1E4D);
const static Trie NFD_6F_303_304(0x22D);
const static Trie NFD_6F_303_308(0x1E4F);
const static BranchMap NFD_6F_303_map {
    {0x301, NFD_6F_303_301},
    {0x304, NFD_6F_303_304},
    {0x308, NFD_6F_303_308}};
const static Trie NFD_6F_303(0xF5, NFD_6F_303_map);
const static Trie NFD_6F_304_300(0x1E51);
const static Trie NFD_6F_304_301(0x1E53);
const static BranchMap NFD_6F_304_map {
    {0x300, NFD_6F_304_300},
    {0x301, NFD_6F_304_301}};
const static Trie NFD_6F_304(0x14D, NFD_6F_304_map);
const static Trie NFD_6F_306(0x14F);
const static Trie NFD_6F_307_304(0x231);
const static BranchMap NFD_6F_307_map {
    {0x304, NFD_6F_307_304}};
const static Trie NFD_6F_307(0x22F, NFD_6F_307_map);
const static Trie NFD_6F_308_304(0x22B);
const static BranchMap NFD_6F_308_map {
    {0x304, NFD_6F_308_304}};
const static Trie NFD_6F_308(0xF6, NFD_6F_308_map);
const static Trie NFD_6F_309(0x1ECF);
const static Trie NFD_6F_30B(0x151);
const static Trie NFD_6F_30C(0x1D2);
const static Trie NFD_6F_30F(0x20D);
const static Trie NFD_6F_311(0x20F);
const static Trie NFD_6F_31B_300(0x1EDD);
const static Trie NFD_6F_31B_301(0x1EDB);
const static Trie NFD_6F_31B_303(0x1EE1);
const static Trie NFD_6F_31B_309(0x1EDF);
const static Trie NFD_6F_31B_323(0x1EE3);
const static BranchMap NFD_6F_31B_map {
    {0x300, NFD_6F_31B_300},
    {0x301, NFD_6F_31B_301},
    {0x303, NFD_6F_31B_303},
    {0x309, NFD_6F_31B_309},
    {0x323, NFD_6F_31B_323}};
const static Trie NFD_6F_31B(0x1A1, NFD_6F_31B_map);
const static Trie NFD_6F_323_302(0x1ED9);
const static BranchMap NFD_6F_323_map {
    {0x302, NFD_6F_323_302}};
const static Trie NFD_6F_323(0x1ECD, NFD_6F_323_map);
const static Trie NFD_6F_328_304(0x1ED);
const static BranchMap NFD_6F_328_map {
    {0x304, NFD_6F_328_304}};
const static Trie NFD_6F_328(0x1EB, NFD_6F_328_map);
const static BranchMap NFD_6F_map {
    {0x300, NFD_6F_300},
    {0x301, NFD_6F_301},
    {0x302, NFD_6F_302},
    {0x303, NFD_6F_303},
    {0x304, NFD_6F_304},
    {0x306, NFD_6F_306},
    {0x307, NFD_6F_307},
    {0x308, NFD_6F_308},
    {0x309, NFD_6F_309},
    {0x30B, NFD_6F_30B},
    {0x30C, NFD_6F_30C},
    {0x30F, NFD_6F_30F},
    {0x311, NFD_6F_311},
    {0x31B, NFD_6F_31B},
    {0x323, NFD_6F_323},
    {0x328, NFD_6F_328}};
const static Trie NFD_6F(NFD_6F_map);
const static Trie NFD_70_301(0x1E55);
const static Trie NFD_70_307(0x1E57);
const static BranchMap NFD_70_map {
    {0x301, NFD_70_301},
    {0x307, NFD_70_307}};
const static Trie NFD_70(NFD_70_map);
const static Trie NFD_72_301(0x155);
const static Trie NFD_72_307(0x1E59);
const static Trie NFD_72_30C(0x159);
const static Trie NFD_72_30F(0x211);
const static Trie NFD_72_311(0x213);
const static Trie NFD_72_323_304(0x1E5D);
const static BranchMap NFD_72_323_map {
    {0x304, NFD_72_323_304}};
const static Trie NFD_72_323(0x1E5B, NFD_72_323_map);
const static Trie NFD_72_327(0x157);
const static Trie NFD_72_331(0x1E5F);
const static BranchMap NFD_72_map {
    {0x301, NFD_72_301},
    {0x307, NFD_72_307},
    {0x30C, NFD_72_30C},
    {0x30F, NFD_72_30F},
    {0x311, NFD_72_311},
    {0x323, NFD_72_323},
    {0x327, NFD_72_327},
    {0x331, NFD_72_331}};
const static Trie NFD_72(NFD_72_map);
const static Trie NFD_73_301_307(0x1E65);
const static BranchMap NFD_73_301_map {
    {0x307, NFD_73_301_307}};
const static Trie NFD_73_301(0x15B, NFD_73_301_map);
const static Trie NFD_73_302(0x15D);
const static Trie NFD_73_307(0x1E61);
const static Trie NFD_73_30C_307(0x1E67);
const static BranchMap NFD_73_30C_map {
    {0x307, NFD_73_30C_307}};
const static Trie NFD_73_30C(0x161, NFD_73_30C_map);
const static Trie NFD_73_323_307(0x1E69);
const static BranchMap NFD_73_323_map {
    {0x307, NFD_73_323_307}};
const static Trie NFD_73_323(0x1E63, NFD_73_323_map);
const static Trie NFD_73_326(0x219);
const static Trie NFD_73_327(0x15F);
const static BranchMap NFD_73_map {
    {0x301, NFD_73_301},
    {0x302, NFD_73_302},
    {0x307, NFD_73_307},
    {0x30C, NFD_73_30C},
    {0x323, NFD_73_323},
    {0x326, NFD_73_326},
    {0x327, NFD_73_327}};
const static Trie NFD_73(NFD_73_map);
const static Trie NFD_74_307(0x1E6B);
const static Trie NFD_74_308(0x1E97);
const static Trie NFD_74_30C(0x165);
const static Trie NFD_74_323(0x1E6D);
const static Trie NFD_74_326(0x21B);
const static Trie NFD_74_327(0x163);
const static Trie NFD_74_32D(0x1E71);
const static Trie NFD_74_331(0x1E6F);
const static BranchMap NFD_74_map {
    {0x307, NFD_74_307},
    {0x308, NFD_74_308},
    {0x30C, NFD_74_30C},
    {0x323, NFD_74_323},
    {0x326, NFD_74_326},
    {0x327, NFD_74_327},
    {0x32D, NFD_74_32D},
    {0x331, NFD_74_331}};
const static Trie NFD_74(NFD_74_map);
const static Trie NFD_75_300(0xF9);
const static Trie NFD_75_301(0xFA);
const static Trie NFD_75_302(0xFB);
const static Trie NFD_75_303_301(0x1E79);
const static BranchMap NFD_75_303_map {
    {0x301, NFD_75_303_301}};
const static Trie NFD_75_303(0x169, NFD_75_303_map);
const static Trie NFD_75_304_308(0x1E7B);
const static BranchMap NFD_75_304_map {
    {0x308, NFD_75_304_308}};
const static Trie NFD_75_304(0x16B, NFD_75_304_map);
const static Trie NFD_75_306(0x16D);
const static Trie NFD_75_308_300(0x1DC);
const static Trie NFD_75_308_301(0x1D8);
const static Trie NFD_75_308_304(0x1D6);
const static Trie NFD_75_308_30C(0x1DA);
const static BranchMap NFD_75_308_map {
    {0x300, NFD_75_308_300},
    {0x301, NFD_75_308_301},
    {0x304, NFD_75_308_304},
    {0x30C, NFD_75_308_30C}};
const static Trie NFD_75_308(0xFC, NFD_75_308_map);
const static Trie NFD_75_309(0x1EE7);
const static Trie NFD_75_30A(0x16F);
const static Trie NFD_75_30B(0x171);
const static Trie NFD_75_30C(0x1D4);
const static Trie NFD_75_30F(0x215);
const static Trie NFD_75_311(0x217);
const static Trie NFD_75_31B_300(0x1EEB);
const static Trie NFD_75_31B_301(0x1EE9);
const static Trie NFD_75_31B_303(0x1EEF);
const static Trie NFD_75_31B_309(0x1EED);
const static Trie NFD_75_31B_323(0x1EF1);
const static BranchMap NFD_75_31B_map {
    {0x300, NFD_75_31B_300},
    {0x301, NFD_75_31B_301},
    {0x303, NFD_75_31B_303},
    {0x309, NFD_75_31B_309},
    {0x323, NFD_75_31B_323}};
const static Trie NFD_75_31B(0x1B0, NFD_75_31B_map);
const static Trie NFD_75_323(0x1EE5);
const static Trie NFD_75_324(0x1E73);
const static Trie NFD_75_328(0x173);
const static Trie NFD_75_32D(0x1E77);
const static Trie NFD_75_330(0x1E75);
const static BranchMap NFD_75_map {
    {0x300, NFD_75_300},
    {0x301, NFD_75_301},
    {0x302, NFD_75_302},
    {0x303, NFD_75_303},
    {0x304, NFD_75_304},
    {0x306, NFD_75_306},
    {0x308, NFD_75_308},
    {0x309, NFD_75_309},
    {0x30A, NFD_75_30A},
    {0x30B, NFD_75_30B},
    {0x30C, NFD_75_30C},
    {0x30F, NFD_75_30F},
    {0x311, NFD_75_311},
    {0x31B, NFD_75_31B},
    {0x323, NFD_75_323},
    {0x324, NFD_75_324},
    {0x328, NFD_75_328},
    {0x32D, NFD_75_32D},
    {0x330, NFD_75_330}};
const static Trie NFD_75(NFD_75_map);
const static Trie NFD_76_303(0x1E7D);
const static Trie NFD_76_323(0x1E7F);
const static BranchMap NFD_76_map {
    {0x303, NFD_76_303},
    {0x323, NFD_76_323}};
const static Trie NFD_76(NFD_76_map);
const static Trie NFD_77_300(0x1E81);
const static Trie NFD_77_301(0x1E83);
const static Trie NFD_77_302(0x175);
const static Trie NFD_77_307(0x1E87);
const static Trie NFD_77_308(0x1E85);
const static Trie NFD_77_30A(0x1E98);
const static Trie NFD_77_323(0x1E89);
const static BranchMap NFD_77_map {
    {0x300, NFD_77_300},
    {0x301, NFD_77_301},
    {0x302, NFD_77_302},
    {0x307, NFD_77_307},
    {0x308, NFD_77_308},
    {0x30A, NFD_77_30A},
    {0x323, NFD_77_323}};
const static Trie NFD_77(NFD_77_map);
const static Trie NFD_78_307(0x1E8B);
const static Trie NFD_78_308(0x1E8D);
const static BranchMap NFD_78_map {
    {0x307, NFD_78_307},
    {0x308, NFD_78_308}};
const static Trie NFD_78(NFD_78_map);
const static Trie NFD_79_300(0x1EF3);
const static Trie NFD_79_301(0xFD);
const static Trie NFD_79_302(0x177);
const static Trie NFD_79_303(0x1EF9);
const static Trie NFD_79_304(0x233);
const static Trie NFD_79_307(0x1E8F);
const static Trie NFD_79_308(0xFF);
const static Trie NFD_79_309(0x1EF7);
const static Trie NFD_79_30A(0x1E99);
const static Trie NFD_79_323(0x1EF5);
const static BranchMap NFD_79_map {
    {0x300, NFD_79_300},
    {0x301, NFD_79_301},
    {0x302, NFD_79_302},
    {0x303, NFD_79_303},
    {0x304, NFD_79_304},
    {0x307, NFD_79_307},
    {0x308, NFD_79_308},
    {0x309, NFD_79_309},
    {0x30A, NFD_79_30A},
    {0x323, NFD_79_323}};
const static Trie NFD_79(NFD_79_map);
const static Trie NFD_7A_301(0x17A);
const static Trie NFD_7A_302(0x1E91);
const static Trie NFD_7A_307(0x17C);
const static Trie NFD_7A_30C(0x17E);
const static Trie NFD_7A_323(0x1E93);
const static Trie NFD_7A_331(0x1E95);
const static BranchMap NFD_7A_map {
    {0x301, NFD_7A_301},
    {0x302, NFD_7A_302},
    {0x307, NFD_7A_307},
    {0x30C, NFD_7A_30C},
    {0x323, NFD_7A_323},
    {0x331, NFD_7A_331}};
const static Trie NFD_7A(NFD_7A_map);
const static Trie NFD_A8_300(0x1FED);
const static Trie NFD_A8_301(0x385);
const static Trie NFD_A8_342(0x1FC1);
const static BranchMap NFD_A8_map {
    {0x300, NFD_A8_300},
    {0x301, NFD_A8_301},
    {0x342, NFD_A8_342}};
const static Trie NFD_A8(NFD_A8_map);
const static Trie NFD_C6_301(0x1FC);
const static Trie NFD_C6_304(0x1E2);
const static BranchMap NFD_C6_map {
    {0x301, NFD_C6_301},
    {0x304, NFD_C6_304}};
const static Trie NFD_C6(NFD_C6_map);
const static Trie NFD_D8_301(0x1FE);
const static BranchMap NFD_D8_map {
    {0x301, NFD_D8_301}};
const static Trie NFD_D8(NFD_D8_map);
const static Trie NFD_E6_301(0x1FD);
const static Trie NFD_E6_304(0x1E3);
const static BranchMap NFD_E6_map {
    {0x301, NFD_E6_301},
    {0x304, NFD_E6_304}};
const static Trie NFD_E6(NFD_E6_map);
const static Trie NFD_F8_301(0x1FF);
const static BranchMap NFD_F8_map {
    {0x301, NFD_F8_301}};
const static Trie NFD_F8(NFD_F8_map);
const static Trie NFD_17F_307(0x1E9B);
const static BranchMap NFD_17F_map {
    {0x307, NFD_17F_307}};
const static Trie NFD_17F(NFD_17F_map);
const static Trie NFD_1B7_30C(0x1EE);
const static BranchMap NFD_1B7_map {
    {0x30C, NFD_1B7_30C}};
const static Trie NFD_1B7(NFD_1B7_map);
const static Trie NFD_292_30C(0x1EF);
const static BranchMap NFD_292_map {
    {0x30C, NFD_292_30C}};
const static Trie NFD_292(NFD_292_map);
const static Trie NFD_308_301(0x344);
const static BranchMap NFD_308_map {
    {0x301, NFD_308_301}};
const static Trie NFD_308(NFD_308_map);
const static Trie NFD_391_300(0x1FBA);
const static Trie NFD_391_301(0x386);
const static Trie NFD_391_304(0x1FB9);
const static Trie NFD_391_306(0x1FB8);
const static Trie NFD_391_313_300_345(0x1F8A);
const static BranchMap NFD_391_313_300_map {
    {0x345, NFD_391_313_300_345}};
const static Trie NFD_391_313_300(0x1F0A, NFD_391_313_300_map);
const static Trie NFD_391_313_301_345(0x1F8C);
const static BranchMap NFD_391_313_301_map {
    {0x345, NFD_391_313_301_345}};
const static Trie NFD_391_313_301(0x1F0C, NFD_391_313_301_map);
const static Trie NFD_391_313_342_345(0x1F8E);
const static BranchMap NFD_391_313_342_map {
    {0x345, NFD_391_313_342_345}};
const static Trie NFD_391_313_342(0x1F0E, NFD_391_313_342_map);
const static Trie NFD_391_313_345(0x1F88);
const static BranchMap NFD_391_313_map {
    {0x300, NFD_391_313_300},
    {0x301, NFD_391_313_301},
    {0x342, NFD_391_313_342},
    {0x345, NFD_391_313_345}};
const static Trie NFD_391_313(0x1F08, NFD_391_313_map);
const static Trie NFD_391_314_300_345(0x1F8B);
const static BranchMap NFD_391_314_300_map {
    {0x345, NFD_391_314_300_345}};
const static Trie NFD_391_314_300(0x1F0B, NFD_391_314_300_map);
const static Trie NFD_391_314_301_345(0x1F8D);
const static BranchMap NFD_391_314_301_map {
    {0x345, NFD_391_314_301_345}};
const static Trie NFD_391_314_301(0x1F0D, NFD_391_314_301_map);
const static Trie NFD_391_314_342_345(0x1F8F);
const static BranchMap NFD_391_314_342_map {
    {0x345, NFD_391_314_342_345}};
const static Trie NFD_391_314_342(0x1F0F, NFD_391_314_342_map);
const static Trie NFD_391_314_345(0x1F89);
const static BranchMap NFD_391_314_map {
    {0x300, NFD_391_314_300},
    {0x301, NFD_391_314_301},
    {0x342, NFD_391_314_342},
    {0x345, NFD_391_314_345}};
const static Trie NFD_391_314(0x1F09, NFD_391_314_map);
const static Trie NFD_391_345(0x1FBC);
const static BranchMap NFD_391_map {
    {0x300, NFD_391_300},
    {0x301, NFD_391_301},
    {0x304, NFD_391_304},
    {0x306, NFD_391_306},
    {0x313, NFD_391_313},
    {0x314, NFD_391_314},
    {0x345, NFD_391_345}};
const static Trie NFD_391(NFD_391_map);
const static Trie NFD_395_300(0x1FC8);
const static Trie NFD_395_301(0x388);
const static Trie NFD_395_313_300(0x1F1A);
const static Trie NFD_395_313_301(0x1F1C);
const static BranchMap NFD_395_313_map {
    {0x300, NFD_395_313_300},
    {0x301, NFD_395_313_301}};
const static Trie NFD_395_313(0x1F18, NFD_395_313_map);
const static Trie NFD_395_314_300(0x1F1B);
const static Trie NFD_395_314_301(0x1F1D);
const static BranchMap NFD_395_314_map {
    {0x300, NFD_395_314_300},
    {0x301, NFD_395_314_301}};
const static Trie NFD_395_314(0x1F19, NFD_395_314_map);
const static BranchMap NFD_395_map {
    {0x300, NFD_395_300},
    {0x301, NFD_395_301},
    {0x313, NFD_395_313},
    {0x314, NFD_395_314}};
const static Trie NFD_395(NFD_395_map);
const static Trie NFD_397_300(0x1FCA);
const static Trie NFD_397_301(0x389);
const static Trie NFD_397_313_300_345(0x1F9A);
const static BranchMap NFD_397_313_300_map {
    {0x345, NFD_397_313_300_345}};
const static Trie NFD_397_313_300(0x1F2A, NFD_397_313_300_map);
const static Trie NFD_397_313_301_345(0x1F9C);
const static BranchMap NFD_397_313_301_map {
    {0x345, NFD_397_313_301_345}};
const static Trie NFD_397_313_301(0x1F2C, NFD_397_313_301_map);
const static Trie NFD_397_313_342_345(0x1F9E);
const static BranchMap NFD_397_313_342_map {
    {0x345, NFD_397_313_342_345}};
const static Trie NFD_397_313_342(0x1F2E, NFD_397_313_342_map);
const static Trie NFD_397_313_345(0x1F98);
const static BranchMap NFD_397_313_map {
    {0x300, NFD_397_313_300},
    {0x301, NFD_397_313_301},
    {0x342, NFD_397_313_342},
    {0x345, NFD_397_313_345}};
const static Trie NFD_397_313(0x1F28, NFD_397_313_map);
const static Trie NFD_397_314_300_345(0x1F9B);
const static BranchMap NFD_397_314_300_map {
    {0x345, NFD_397_314_300_345}};
const static Trie NFD_397_314_300(0x1F2B, NFD_397_314_300_map);
const static Trie NFD_397_314_301_345(0x1F9D);
const static BranchMap NFD_397_314_301_map {
    {0x345, NFD_397_314_301_345}};
const static Trie NFD_397_314_301(0x1F2D, NFD_397_314_301_map);
const static Trie NFD_397_314_342_345(0x1F9F);
const static BranchMap NFD_397_314_342_map {
    {0x345, NFD_397_314_342_345}};
const static Trie NFD_397_314_342(0x1F2F, NFD_397_314_342_map);
const static Trie NFD_397_314_345(0x1F99);
const static BranchMap NFD_397_314_map {
    {0x300, NFD_397_314_300},
    {0x301, NFD_397_314_301},
    {0x342, NFD_397_314_342},
    {0x345, NFD_397_314_345}};
const static Trie NFD_397_314(0x1F29, NFD_397_314_map);
const static Trie NFD_397_345(0x1FCC);
const static BranchMap NFD_397_map {
    {0x300, NFD_397_300},
    {0x301, NFD_397_301},
    {0x313, NFD_397_313},
    {0x314, NFD_397_314},
    {0x345, NFD_397_345}};
const static Trie NFD_397(NFD_397_map);
const static Trie NFD_399_300(0x1FDA);
const static Trie NFD_399_301(0x38A);
const static Trie NFD_399_304(0x1FD9);
const static Trie NFD_399_306(0x1FD8);
const static Trie NFD_399_308(0x3AA);
const static Trie NFD_399_313_300(0x1F3A);
const static Trie NFD_399_313_301(0x1F3C);
const static Trie NFD_399_313_342(0x1F3E);
const static BranchMap NFD_399_313_map {
    {0x300, NFD_399_313_300},
    {0x301, NFD_399_313_301},
    {0x342, NFD_399_313_342}};
const static Trie NFD_399_313(0x1F38, NFD_399_313_map);
const static Trie NFD_399_314_300(0x1F3B);
const static Trie NFD_399_314_301(0x1F3D);
const static Trie NFD_399_314_342(0x1F3F);
const static BranchMap NFD_399_314_map {
    {0x300, NFD_399_314_300},
    {0x301, NFD_399_314_301},
    {0x342, NFD_399_314_342}};
const static Trie NFD_399_314(0x1F39, NFD_399_314_map);
const static BranchMap NFD_399_map {
    {0x300, NFD_399_300},
    {0x301, NFD_399_301},
    {0x304, NFD_399_304},
    {0x306, NFD_399_306},
    {0x308, NFD_399_308},
    {0x313, NFD_399_313},
    {0x314, NFD_399_314}};
const static Trie NFD_399(NFD_399_map);
const static Trie NFD_39F_300(0x1FF8);
const static Trie NFD_39F_301(0x38C);
const static Trie NFD_39F_313_300(0x1F4A);
const static Trie NFD_39F_313_301(0x1F4C);
const static BranchMap NFD_39F_313_map {
    {0x300, NFD_39F_313_300},
    {0x301, NFD_39F_313_301}};
const static Trie NFD_39F_313(0x1F48, NFD_39F_313_map);
const static Trie NFD_39F_314_300(0x1F4B);
const static Trie NFD_39F_314_301(0x1F4D);
const static BranchMap NFD_39F_314_map {
    {0x300, NFD_39F_314_300},
    {0x301, NFD_39F_314_301}};
const static Trie NFD_39F_314(0x1F49, NFD_39F_314_map);
const static BranchMap NFD_39F_map {
    {0x300, NFD_39F_300},
    {0x301, NFD_39F_301},
    {0x313, NFD_39F_313},
    {0x314, NFD_39F_314}};
const static Trie NFD_39F(NFD_39F_map);
const static Trie NFD_3A1_314(0x1FEC);
const static BranchMap NFD_3A1_map {
    {0x314, NFD_3A1_314}};
const static Trie NFD_3A1(NFD_3A1_map);
const static Trie NFD_3A5_300(0x1FEA);
const static Trie NFD_3A5_301(0x38E);
const static Trie NFD_3A5_304(0x1FE9);
const static Trie NFD_3A5_306(0x1FE8);
const static Trie NFD_3A5_308(0x3AB);
const static Trie NFD_3A5_314_300(0x1F5B);
const static Trie NFD_3A5_314_301(0x1F5D);
const static Trie NFD_3A5_314_342(0x1F5F);
const static BranchMap NFD_3A5_314_map {
    {0x300, NFD_3A5_314_300},
    {0x301, NFD_3A5_314_301},
    {0x342, NFD_3A5_314_342}};
const static Trie NFD_3A5_314(0x1F59, NFD_3A5_314_map);
const static BranchMap NFD_3A5_map {
    {0x300, NFD_3A5_300},
    {0x301, NFD_3A5_301},
    {0x304, NFD_3A5_304},
    {0x306, NFD_3A5_306},
    {0x308, NFD_3A5_308},
    {0x314, NFD_3A5_314}};
const static Trie NFD_3A5(NFD_3A5_map);
const static Trie NFD_3A9_300(0x1FFA);
const static Trie NFD_3A9_301(0x38F);
const static Trie NFD_3A9_313_300_345(0x1FAA);
const static BranchMap NFD_3A9_313_300_map {
    {0x345, NFD_3A9_313_300_345}};
const static Trie NFD_3A9_313_300(0x1F6A, NFD_3A9_313_300_map);
const static Trie NFD_3A9_313_301_345(0x1FAC);
const static BranchMap NFD_3A9_313_301_map {
    {0x345, NFD_3A9_313_301_345}};
const static Trie NFD_3A9_313_301(0x1F6C, NFD_3A9_313_301_map);
const static Trie NFD_3A9_313_342_345(0x1FAE);
const static BranchMap NFD_3A9_313_342_map {
    {0x345, NFD_3A9_313_342_345}};
const static Trie NFD_3A9_313_342(0x1F6E, NFD_3A9_313_342_map);
const static Trie NFD_3A9_313_345(0x1FA8);
const static BranchMap NFD_3A9_313_map {
    {0x300, NFD_3A9_313_300},
    {0x301, NFD_3A9_313_301},
    {0x342, NFD_3A9_313_342},
    {0x345, NFD_3A9_313_345}};
const static Trie NFD_3A9_313(0x1F68, NFD_3A9_313_map);
const static Trie NFD_3A9_314_300_345(0x1FAB);
const static BranchMap NFD_3A9_314_300_map {
    {0x345, NFD_3A9_314_300_345}};
const static Trie NFD_3A9_314_300(0x1F6B, NFD_3A9_314_300_map);
const static Trie NFD_3A9_314_301_345(0x1FAD);
const static BranchMap NFD_3A9_314_301_map {
    {0x345, NFD_3A9_314_301_345}};
const static Trie NFD_3A9_314_301(0x1F6D, NFD_3A9_314_301_map);
const static Trie NFD_3A9_314_342_345(0x1FAF);
const static BranchMap NFD_3A9_314_342_map {
    {0x345, NFD_3A9_314_342_345}};
const static Trie NFD_3A9_314_342(0x1F6F, NFD_3A9_314_342_map);
const static Trie NFD_3A9_314_345(0x1FA9);
const static BranchMap NFD_3A9_314_map {
    {0x300, NFD_3A9_314_300},
    {0x301, NFD_3A9_314_301},
    {0x342, NFD_3A9_314_342},
    {0x345, NFD_3A9_314_345}};
const static Trie NFD_3A9_314(0x1F69, NFD_3A9_314_map);
const static Trie NFD_3A9_345(0x1FFC);
const static BranchMap NFD_3A9_map {
    {0x300, NFD_3A9_300},
    {0x301, NFD_3A9_301},
    {0x313, NFD_3A9_313},
    {0x314, NFD_3A9_314},
    {0x345, NFD_3A9_345}};
const static Trie NFD_3A9(NFD_3A9_map);
const static Trie NFD_3B1_300_345(0x1FB2);
const static BranchMap NFD_3B1_300_map {
    {0x345, NFD_3B1_300_345}};
const static Trie NFD_3B1_300(0x1F70, NFD_3B1_300_map);
const static Trie NFD_3B1_301_345(0x1FB4);
const static BranchMap NFD_3B1_301_map {
    {0x345, NFD_3B1_301_345}};
const static Trie NFD_3B1_301(0x3AC, NFD_3B1_301_map);
const static Trie NFD_3B1_304(0x1FB1);
const static Trie NFD_3B1_306(0x1FB0);
const static Trie NFD_3B1_313_300_345(0x1F82);
const static BranchMap NFD_3B1_313_300_map {
    {0x345, NFD_3B1_313_300_345}};
const static Trie NFD_3B1_313_300(0x1F02, NFD_3B1_313_300_map);
const static Trie NFD_3B1_313_301_345(0x1F84);
const static BranchMap NFD_3B1_313_301_map {
    {0x345, NFD_3B1_313_301_345}};
const static Trie NFD_3B1_313_301(0x1F04, NFD_3B1_313_301_map);
const static Trie NFD_3B1_313_342_345(0x1F86);
const static BranchMap NFD_3B1_313_342_map {
    {0x345, NFD_3B1_313_342_345}};
const static Trie NFD_3B1_313_342(0x1F06, NFD_3B1_313_342_map);
const static Trie NFD_3B1_313_345(0x1F80);
const static BranchMap NFD_3B1_313_map {
    {0x300, NFD_3B1_313_300},
    {0x301, NFD_3B1_313_301},
    {0x342, NFD_3B1_313_342},
    {0x345, NFD_3B1_313_345}};
const static Trie NFD_3B1_313(0x1F00, NFD_3B1_313_map);
const static Trie NFD_3B1_314_300_345(0x1F83);
const static BranchMap NFD_3B1_314_300_map {
    {0x345, NFD_3B1_314_300_345}};
const static Trie NFD_3B1_314_300(0x1F03, NFD_3B1_314_300_map);
const static Trie NFD_3B1_314_301_345(0x1F85);
const static BranchMap NFD_3B1_314_301_map {
    {0x345, NFD_3B1_314_301_345}};
const static Trie NFD_3B1_314_301(0x1F05, NFD_3B1_314_301_map);
const static Trie NFD_3B1_314_342_345(0x1F87);
const static BranchMap NFD_3B1_314_342_map {
    {0x345, NFD_3B1_314_342_345}};
const static Trie NFD_3B1_314_342(0x1F07, NFD_3B1_314_342_map);
const static Trie NFD_3B1_314_345(0x1F81);
const static BranchMap NFD_3B1_314_map {
    {0x300, NFD_3B1_314_300},
    {0x301, NFD_3B1_314_301},
    {0x342, NFD_3B1_314_342},
    {0x345, NFD_3B1_314_345}};
const static Trie NFD_3B1_314(0x1F01, NFD_3B1_314_map);
const static Trie NFD_3B1_342_345(0x1FB7);
const static BranchMap NFD_3B1_342_map {
    {0x345, NFD_3B1_342_345}};
const static Trie NFD_3B1_342(0x1FB6, NFD_3B1_342_map);
const static Trie NFD_3B1_345(0x1FB3);
const static BranchMap NFD_3B1_map {
    {0x300, NFD_3B1_300},
    {0x301, NFD_3B1_301},
    {0x304, NFD_3B1_304},
    {0x306, NFD_3B1_306},
    {0x313, NFD_3B1_313},
    {0x314, NFD_3B1_314},
    {0x342, NFD_3B1_342},
    {0x345, NFD_3B1_345}};
const static Trie NFD_3B1(NFD_3B1_map);
const static Trie NFD_3B5_300(0x1F72);
const static Trie NFD_3B5_301(0x3AD);
const static Trie NFD_3B5_313_300(0x1F12);
const static Trie NFD_3B5_313_301(0x1F14);
const static BranchMap NFD_3B5_313_map {
    {0x300, NFD_3B5_313_300},
    {0x301, NFD_3B5_313_301}};
const static Trie NFD_3B5_313(0x1F10, NFD_3B5_313_map);
const static Trie NFD_3B5_314_300(0x1F13);
const static Trie NFD_3B5_314_301(0x1F15);
const static BranchMap NFD_3B5_314_map {
    {0x300, NFD_3B5_314_300},
    {0x301, NFD_3B5_314_301}};
const static Trie NFD_3B5_314(0x1F11, NFD_3B5_314_map);
const static BranchMap NFD_3B5_map {
    {0x300, NFD_3B5_300},
    {0x301, NFD_3B5_301},
    {0x313, NFD_3B5_313},
    {0x314, NFD_3B5_314}};
const static Trie NFD_3B5(NFD_3B5_map);
const static Trie NFD_3B7_300_345(0x1FC2);
const static BranchMap NFD_3B7_300_map {
    {0x345, NFD_3B7_300_345}};
const static Trie NFD_3B7_300(0x1F74, NFD_3B7_300_map);
const static Trie NFD_3B7_301_345(0x1FC4);
const static BranchMap NFD_3B7_301_map {
    {0x345, NFD_3B7_301_345}};
const static Trie NFD_3B7_301(0x3AE, NFD_3B7_301_map);
const static Trie NFD_3B7_313_300_345(0x1F92);
const static BranchMap NFD_3B7_313_300_map {
    {0x345, NFD_3B7_313_300_345}};
const static Trie NFD_3B7_313_300(0x1F22, NFD_3B7_313_300_map);
const static Trie NFD_3B7_313_301_345(0x1F94);
const static BranchMap NFD_3B7_313_301_map {
    {0x345, NFD_3B7_313_301_345}};
const static Trie NFD_3B7_313_301(0x1F24, NFD_3B7_313_301_map);
const static Trie NFD_3B7_313_342_345(0x1F96);
const static BranchMap NFD_3B7_313_342_map {
    {0x345, NFD_3B7_313_342_345}};
const static Trie NFD_3B7_313_342(0x1F26, NFD_3B7_313_342_map);
const static Trie NFD_3B7_313_345(0x1F90);
const static BranchMap NFD_3B7_313_map {
    {0x300, NFD_3B7_313_300},
    {0x301, NFD_3B7_313_301},
    {0x342, NFD_3B7_313_342},
    {0x345, NFD_3B7_313_345}};
const static Trie NFD_3B7_313(0x1F20, NFD_3B7_313_map);
const static Trie NFD_3B7_314_300_345(0x1F93);
const static BranchMap NFD_3B7_314_300_map {
    {0x345, NFD_3B7_314_300_345}};
const static Trie NFD_3B7_314_300(0x1F23, NFD_3B7_314_300_map);
const static Trie NFD_3B7_314_301_345(0x1F95);
const static BranchMap NFD_3B7_314_301_map {
    {0x345, NFD_3B7_314_301_345}};
const static Trie NFD_3B7_314_301(0x1F25, NFD_3B7_314_301_map);
const static Trie NFD_3B7_314_342_345(0x1F97);
const static BranchMap NFD_3B7_314_342_map {
    {0x345, NFD_3B7_314_342_345}};
const static Trie NFD_3B7_314_342(0x1F27, NFD_3B7_314_342_map);
const static Trie NFD_3B7_314_345(0x1F91);
const static BranchMap NFD_3B7_314_map {
    {0x300, NFD_3B7_314_300},
    {0x301, NFD_3B7_314_301},
    {0x342, NFD_3B7_314_342},
    {0x345, NFD_3B7_314_345}};
const static Trie NFD_3B7_314(0x1F21, NFD_3B7_314_map);
const static Trie NFD_3B7_342_345(0x1FC7);
const static BranchMap NFD_3B7_342_map {
    {0x345, NFD_3B7_342_345}};
const static Trie NFD_3B7_342(0x1FC6, NFD_3B7_342_map);
const static Trie NFD_3B7_345(0x1FC3);
const static BranchMap NFD_3B7_map {
    {0x300, NFD_3B7_300},
    {0x301, NFD_3B7_301},
    {0x313, NFD_3B7_313},
    {0x314, NFD_3B7_314},
    {0x342, NFD_3B7_342},
    {0x345, NFD_3B7_345}};
const static Trie NFD_3B7(NFD_3B7_map);
const static Trie NFD_3B9_300(0x1F76);
const static Trie NFD_3B9_301(0x3AF);
const static Trie NFD_3B9_304(0x1FD1);
const static Trie NFD_3B9_306(0x1FD0);
const static Trie NFD_3B9_308_300(0x1FD2);
const static Trie NFD_3B9_308_301(0x390);
const static Trie NFD_3B9_308_342(0x1FD7);
const static BranchMap NFD_3B9_308_map {
    {0x300, NFD_3B9_308_300},
    {0x301, NFD_3B9_308_301},
    {0x342, NFD_3B9_308_342}};
const static Trie NFD_3B9_308(0x3CA, NFD_3B9_308_map);
const static Trie NFD_3B9_313_300(0x1F32);
const static Trie NFD_3B9_313_301(0x1F34);
const static Trie NFD_3B9_313_342(0x1F36);
const static BranchMap NFD_3B9_313_map {
    {0x300, NFD_3B9_313_300},
    {0x301, NFD_3B9_313_301},
    {0x342, NFD_3B9_313_342}};
const static Trie NFD_3B9_313(0x1F30, NFD_3B9_313_map);
const static Trie NFD_3B9_314_300(0x1F33);
const static Trie NFD_3B9_314_301(0x1F35);
const static Trie NFD_3B9_314_342(0x1F37);
const static BranchMap NFD_3B9_314_map {
    {0x300, NFD_3B9_314_300},
    {0x301, NFD_3B9_314_301},
    {0x342, NFD_3B9_314_342}};
const static Trie NFD_3B9_314(0x1F31, NFD_3B9_314_map);
const static Trie NFD_3B9_342(0x1FD6);
const static BranchMap NFD_3B9_map {
    {0x300, NFD_3B9_300},
    {0x301, NFD_3B9_301},
    {0x304, NFD_3B9_304},
    {0x306, NFD_3B9_306},
    {0x308, NFD_3B9_308},
    {0x313, NFD_3B9_313},
    {0x314, NFD_3B9_314},
    {0x342, NFD_3B9_342}};
const static Trie NFD_3B9(NFD_3B9_map);
const static Trie NFD_3BF_300(0x1F78);
const static Trie NFD_3BF_301(0x3CC);
const static Trie NFD_3BF_313_300(0x1F42);
const static Trie NFD_3BF_313_301(0x1F44);
const static BranchMap NFD_3BF_313_map {
    {0x300, NFD_3BF_313_300},
    {0x301, NFD_3BF_313_301}};
const static Trie NFD_3BF_313(0x1F40, NFD_3BF_313_map);
const static Trie NFD_3BF_314_300(0x1F43);
const static Trie NFD_3BF_314_301(0x1F45);
const static BranchMap NFD_3BF_314_map {
    {0x300, NFD_3BF_314_300},
    {0x301, NFD_3BF_314_301}};
const static Trie NFD_3BF_314(0x1F41, NFD_3BF_314_map);
const static BranchMap NFD_3BF_map {
    {0x300, NFD_3BF_300},
    {0x301, NFD_3BF_301},
    {0x313, NFD_3BF_313},
    {0x314, NFD_3BF_314}};
const static Trie NFD_3BF(NFD_3BF_map);
const static Trie NFD_3C1_313(0x1FE4);
const static Trie NFD_3C1_314(0x1FE5);
const static BranchMap NFD_3C1_map {
    {0x313, NFD_3C1_313},
    {0x314, NFD_3C1_314}};
const static Trie NFD_3C1(NFD_3C1_map);
const static Trie NFD_3C5_300(0x1F7A);
const static Trie NFD_3C5_301(0x3CD);
const static Trie NFD_3C5_304(0x1FE1);
const static Trie NFD_3C5_306(0x1FE0);
const static Trie NFD_3C5_308_300(0x1FE2);
const static Trie NFD_3C5_308_301(0x3B0);
const static Trie NFD_3C5_308_342(0x1FE7);
const static BranchMap NFD_3C5_308_map {
    {0x300, NFD_3C5_308_300},
    {0x301, NFD_3C5_308_301},
    {0x342, NFD_3C5_308_342}};
const static Trie NFD_3C5_308(0x3CB, NFD_3C5_308_map);
const static Trie NFD_3C5_313_300(0x1F52);
const static Trie NFD_3C5_313_301(0x1F54);
const static Trie NFD_3C5_313_342(0x1F56);
const static BranchMap NFD_3C5_313_map {
    {0x300, NFD_3C5_313_300},
    {0x301, NFD_3C5_313_301},
    {0x342, NFD_3C5_313_342}};
const static Trie NFD_3C5_313(0x1F50, NFD_3C5_313_map);
const static Trie NFD_3C5_314_300(0x1F53);
const static Trie NFD_3C5_314_301(0x1F55);
const static Trie NFD_3C5_314_342(0x1F57);
const static BranchMap NFD_3C5_314_map {
    {0x300, NFD_3C5_314_300},
    {0x301, NFD_3C5_314_301},
    {0x342, NFD_3C5_314_342}};
const static Trie NFD_3C5_314(0x1F51, NFD_3C5_314_map);
const static Trie NFD_3C5_342(0x1FE6);
const static BranchMap NFD_3C5_map {
    {0x300, NFD_3C5_300},
    {0x301, NFD_3C5_301},
    {0x304, NFD_3C5_304},
    {0x306, NFD_3C5_306},
    {0x308, NFD_3C5_308},
    {0x313, NFD_3C5_313},
    {0x314, NFD_3C5_314},
    {0x342, NFD_3C5_342}};
const static Trie NFD_3C5(NFD_3C5_map);
const static Trie NFD_3C9_300_345(0x1FF2);
const static BranchMap NFD_3C9_300_map {
    {0x345, NFD_3C9_300_345}};
const static Trie NFD_3C9_300(0x1F7C, NFD_3C9_300_map);
const static Trie NFD_3C9_301_345(0x1FF4);
const static BranchMap NFD_3C9_301_map {
    {0x345, NFD_3C9_301_345}};
const static Trie NFD_3C9_301(0x3CE, NFD_3C9_301_map);
const static Trie NFD_3C9_313_300_345(0x1FA2);
const static BranchMap NFD_3C9_313_300_map {
    {0x345, NFD_3C9_313_300_345}};
const static Trie NFD_3C9_313_300(0x1F62, NFD_3C9_313_300_map);
const static Trie NFD_3C9_313_301_345(0x1FA4);
const static BranchMap NFD_3C9_313_301_map {
    {0x345, NFD_3C9_313_301_345}};
const static Trie NFD_3C9_313_301(0x1F64, NFD_3C9_313_301_map);
const static Trie NFD_3C9_313_342_345(0x1FA6);
const static BranchMap NFD_3C9_313_342_map {
    {0x345, NFD_3C9_313_342_345}};
const static Trie NFD_3C9_313_342(0x1F66, NFD_3C9_313_342_map);
const static Trie NFD_3C9_313_345(0x1FA0);
const static BranchMap NFD_3C9_313_map {
    {0x300, NFD_3C9_313_300},
    {0x301, NFD_3C9_313_301},
    {0x342, NFD_3C9_313_342},
    {0x345, NFD_3C9_313_345}};
const static Trie NFD_3C9_313(0x1F60, NFD_3C9_313_map);
const static Trie NFD_3C9_314_300_345(0x1FA3);
const static BranchMap NFD_3C9_314_300_map {
    {0x345, NFD_3C9_314_300_345}};
const static Trie NFD_3C9_314_300(0x1F63, NFD_3C9_314_300_map);
const static Trie NFD_3C9_314_301_345(0x1FA5);
const static BranchMap NFD_3C9_314_301_map {
    {0x345, NFD_3C9_314_301_345}};
const static Trie NFD_3C9_314_301(0x1F65, NFD_3C9_314_301_map);
const static Trie NFD_3C9_314_342_345(0x1FA7);
const static BranchMap NFD_3C9_314_342_map {
    {0x345, NFD_3C9_314_342_345}};
const static Trie NFD_3C9_314_342(0x1F67, NFD_3C9_314_342_map);
const static Trie NFD_3C9_314_345(0x1FA1);
const static BranchMap NFD_3C9_314_map {
    {0x300, NFD_3C9_314_300},
    {0x301, NFD_3C9_314_301},
    {0x342, NFD_3C9_314_342},
    {0x345, NFD_3C9_314_345}};
const static Trie NFD_3C9_314(0x1F61, NFD_3C9_314_map);
const static Trie NFD_3C9_342_345(0x1FF7);
const static BranchMap NFD_3C9_342_map {
    {0x345, NFD_3C9_342_345}};
const static Trie NFD_3C9_342(0x1FF6, NFD_3C9_342_map);
const static Trie NFD_3C9_345(0x1FF3);
const static BranchMap NFD_3C9_map {
    {0x300, NFD_3C9_300},
    {0x301, NFD_3C9_301},
    {0x313, NFD_3C9_313},
    {0x314, NFD_3C9_314},
    {0x342, NFD_3C9_342},
    {0x345, NFD_3C9_345}};
const static Trie NFD_3C9(NFD_3C9_map);
const static Trie NFD_3D2_301(0x3D3);
const static Trie NFD_3D2_308(0x3D4);
const static BranchMap NFD_3D2_map {
    {0x301, NFD_3D2_301},
    {0x308, NFD_3D2_308}};
const static Trie NFD_3D2(NFD_3D2_map);
const static Trie NFD_406_308(0x407);
const static BranchMap NFD_406_map {
    {0x308, NFD_406_308}};
const static Trie NFD_406(NFD_406_map);
const static Trie NFD_410_306(0x4D0);
const static Trie NFD_410_308(0x4D2);
const static BranchMap NFD_410_map {
    {0x306, NFD_410_306},
    {0x308, NFD_410_308}};
const static Trie NFD_410(NFD_410_map);
const static Trie NFD_413_301(0x403);
const static BranchMap NFD_413_map {
    {0x301, NFD_413_301}};
const static Trie NFD_413(NFD_413_map);
const static Trie NFD_415_300(0x400);
const static Trie NFD_415_306(0x4D6);
const static Trie NFD_415_308(0x401);
const static BranchMap NFD_415_map {
    {0x300, NFD_415_300},
    {0x306, NFD_415_306},
    {0x308, NFD_415_308}};
const static Trie NFD_415(NFD_415_map);
const static Trie NFD_416_306(0x4C1);
const static Trie NFD_416_308(0x4DC);
const static BranchMap NFD_416_map {
    {0x306, NFD_416_306},
    {0x308, NFD_416_308}};
const static Trie NFD_416(NFD_416_map);
const static Trie NFD_417_308(0x4DE);
const static BranchMap NFD_417_map {
    {0x308, NFD_417_308}};
const static Trie NFD_417(NFD_417_map);
const static Trie NFD_418_300(0x40D);
const static Trie NFD_418_304(0x4E2);
const static Trie NFD_418_306(0x419);
const static Trie NFD_418_308(0x4E4);
const static BranchMap NFD_418_map {
    {0x300, NFD_418_300},
    {0x304, NFD_418_304},
    {0x306, NFD_418_306},
    {0x308, NFD_418_308}};
const static Trie NFD_418(NFD_418_map);
const static Trie NFD_41A_301(0x40C);
const static BranchMap NFD_41A_map {
    {0x301, NFD_41A_301}};
const static Trie NFD_41A(NFD_41A_map);
const static Trie NFD_41E_308(0x4E6);
const static BranchMap NFD_41E_map {
    {0x308, NFD_41E_308}};
const static Trie NFD_41E(NFD_41E_map);
const static Trie NFD_423_304(0x4EE);
const static Trie NFD_423_306(0x40E);
const static Trie NFD_423_308(0x4F0);
const static Trie NFD_423_30B(0x4F2);
const static BranchMap NFD_423_map {
    {0x304, NFD_423_304},
    {0x306, NFD_423_306},
    {0x308, NFD_423_308},
    {0x30B, NFD_423_30B}};
const static Trie NFD_423(NFD_423_map);
const static Trie NFD_427_308(0x4F4);
const static BranchMap NFD_427_map {
    {0x308, NFD_427_308}};
const static Trie NFD_427(NFD_427_map);
const static Trie NFD_42B_308(0x4F8);
const static BranchMap NFD_42B_map {
    {0x308, NFD_42B_308}};
const static Trie NFD_42B(NFD_42B_map);
const static Trie NFD_42D_308(0x4EC);
const static BranchMap NFD_42D_map {
    {0x308, NFD_42D_308}};
const static Trie NFD_42D(NFD_42D_map);
const static Trie NFD_430_306(0x4D1);
const static Trie NFD_430_308(0x4D3);
const static BranchMap NFD_430_map {
    {0x306, NFD_430_306},
    {0x308, NFD_430_308}};
const static Trie NFD_430(NFD_430_map);
const static Trie NFD_433_301(0x453);
const static BranchMap NFD_433_map {
    {0x301, NFD_433_301}};
const static Trie NFD_433(NFD_433_map);
const static Trie NFD_435_300(0x450);
const static Trie NFD_435_306(0x4D7);
const static Trie NFD_435_308(0x451);
const static BranchMap NFD_435_map {
    {0x300, NFD_435_300},
    {0x306, NFD_435_306},
    {0x308, NFD_435_308}};
const static Trie NFD_435(NFD_435_map);
const static Trie NFD_436_306(0x4C2);
const static Trie NFD_436_308(0x4DD);
const static BranchMap NFD_436_map {
    {0x306, NFD_436_306},
    {0x308, NFD_436_308}};
const static Trie NFD_436(NFD_436_map);
const static Trie NFD_437_308(0x4DF);
const static BranchMap NFD_437_map {
    {0x308, NFD_437_308}};
const static Trie NFD_437(NFD_437_map);
const static Trie NFD_438_300(0x45D);
const static Trie NFD_438_304(0x4E3);
const static Trie NFD_438_306(0x439);
const static Trie NFD_438_308(0x4E5);
const static BranchMap NFD_438_map {
    {0x300, NFD_438_300},
    {0x304, NFD_438_304},
    {0x306, NFD_438_306},
    {0x308, NFD_438_308}};
const static Trie NFD_438(NFD_438_map);
const static Trie NFD_43A_301(0x45C);
const static BranchMap NFD_43A_map {
    {0x301, NFD_43A_301}};
const static Trie NFD_43A(NFD_43A_map);
const static Trie NFD_43E_308(0x4E7);
const static BranchMap NFD_43E_map {
    {0x308, NFD_43E_308}};
const static Trie NFD_43E(NFD_43E_map);
const static Trie NFD_443_304(0x4EF);
const static Trie NFD_443_306(0x45E);
const static Trie NFD_443_308(0x4F1);
const static Trie NFD_443_30B(0x4F3);
const static BranchMap NFD_443_map {
    {0x304, NFD_443_304},
    {0x306, NFD_443_306},
    {0x308, NFD_443_308},
    {0x30B, NFD_443_30B}};
const static Trie NFD_443(NFD_443_map);
const static Trie NFD_447_308(0x4F5);
const static BranchMap NFD_447_map {
    {0x308, NFD_447_308}};
const static Trie NFD_447(NFD_447_map);
const static Trie NFD_44B_308(0x4F9);
const static BranchMap NFD_44B_map {
    {0x308, NFD_44B_308}};
const static Trie NFD_44B(NFD_44B_map);
const static Trie NFD_44D_308(0x4ED);
const static BranchMap NFD_44D_map {
    {0x308, NFD_44D_308}};
const static Trie NFD_44D(NFD_44D_map);
const static Trie NFD_456_308(0x457);
const static BranchMap NFD_456_map {
    {0x308, NFD_456_308}};
const static Trie NFD_456(NFD_456_map);
const static Trie NFD_474_30F(0x476);
const static BranchMap NFD_474_map {
    {0x30F, NFD_474_30F}};
const static Trie NFD_474(NFD_474_map);
const static Trie NFD_475_30F(0x477);
const static BranchMap NFD_475_map {
    {0x30F, NFD_475_30F}};
const static Trie NFD_475(NFD_475_map);
const static Trie NFD_4D8_308(0x4DA);
const static BranchMap NFD_4D8_map {
    {0x308, NFD_4D8_308}};
const static Trie NFD_4D8(NFD_4D8_map);
const static Trie NFD_4D9_308(0x4DB);
const static BranchMap NFD_4D9_map {
    {0x308, NFD_4D9_308}};
const static Trie NFD_4D9(NFD_4D9_map);
const static Trie NFD_4E8_308(0x4EA);
const static BranchMap NFD_4E8_map {
    {0x308, NFD_4E8_308}};
const static Trie NFD_4E8(NFD_4E8_map);
const static Trie NFD_4E9_308(0x4EB);
const static BranchMap NFD_4E9_map {
    {0x308, NFD_4E9_308}};
const static Trie NFD_4E9(NFD_4E9_map);
const static Trie NFD_5D0_5B7(0xFB2E);
const static Trie NFD_5D0_5B8(0xFB2F);
const static Trie NFD_5D0_5BC(0xFB30);
const static BranchMap NFD_5D0_map {
    {0x5B7, NFD_5D0_5B7},
    {0x5B8, NFD_5D0_5B8},
    {0x5BC, NFD_5D0_5BC}};
const static Trie NFD_5D0(NFD_5D0_map);
const static Trie NFD_5D1_5BC(0xFB31);
const static Trie NFD_5D1_5BF(0xFB4C);
const static BranchMap NFD_5D1_map {
    {0x5BC, NFD_5D1_5BC},
    {0x5BF, NFD_5D1_5BF}};
const static Trie NFD_5D1(NFD_5D1_map);
const static Trie NFD_5D2_5BC(0xFB32);
const static BranchMap NFD_5D2_map {
    {0x5BC, NFD_5D2_5BC}};
const static Trie NFD_5D2(NFD_5D2_map);
const static Trie NFD_5D3_5BC(0xFB33);
const static BranchMap NFD_5D3_map {
    {0x5BC, NFD_5D3_5BC}};
const static Trie NFD_5D3(NFD_5D3_map);
const static Trie NFD_5D4_5BC(0xFB34);
const static BranchMap NFD_5D4_map {
    {0x5BC, NFD_5D4_5BC}};
const static Trie NFD_5D4(NFD_5D4_map);
const static Trie NFD_5D5_5B9(0xFB4B);
const static Trie NFD_5D5_5BC(0xFB35);
const static BranchMap NFD_5D5_map {
    {0x5B9, NFD_5D5_5B9},
    {0x5BC, NFD_5D5_5BC}};
const static Trie NFD_5D5(NFD_5D5_map);
const static Trie NFD_5D6_5BC(0xFB36);
const static BranchMap NFD_5D6_map {
    {0x5BC, NFD_5D6_5BC}};
const static Trie NFD_5D6(NFD_5D6_map);
const static Trie NFD_5D8_5BC(0xFB38);
const static BranchMap NFD_5D8_map {
    {0x5BC, NFD_5D8_5BC}};
const static Trie NFD_5D8(NFD_5D8_map);
const static Trie NFD_5D9_5B4(0xFB1D);
const static Trie NFD_5D9_5BC(0xFB39);
const static BranchMap NFD_5D9_map {
    {0x5B4, NFD_5D9_5B4},
    {0x5BC, NFD_5D9_5BC}};
const static Trie NFD_5D9(NFD_5D9_map);
const static Trie NFD_5DA_5BC(0xFB3A);
const static BranchMap NFD_5DA_map {
    {0x5BC, NFD_5DA_5BC}};
const static Trie NFD_5DA(NFD_5DA_map);
const static Trie NFD_5DB_5BC(0xFB3B);
const static Trie NFD_5DB_5BF(0xFB4D);
const static BranchMap NFD_5DB_map {
    {0x5BC, NFD_5DB_5BC},
    {0x5BF, NFD_5DB_5BF}};
const static Trie NFD_5DB(NFD_5DB_map);
const static Trie NFD_5DC_5BC(0xFB3C);
const static BranchMap NFD_5DC_map {
    {0x5BC, NFD_5DC_5BC}};
const static Trie NFD_5DC(NFD_5DC_map);
const static Trie NFD_5DE_5BC(0xFB3E);
const static BranchMap NFD_5DE_map {
    {0x5BC, NFD_5DE_5BC}};
const static Trie NFD_5DE(NFD_5DE_map);
const static Trie NFD_5E0_5BC(0xFB40);
const static BranchMap NFD_5E0_map {
    {0x5BC, NFD_5E0_5BC}};
const static Trie NFD_5E0(NFD_5E0_map);
const static Trie NFD_5E1_5BC(0xFB41);
const static BranchMap NFD_5E1_map {
    {0x5BC, NFD_5E1_5BC}};
const static Trie NFD_5E1(NFD_5E1_map);
const static Trie NFD_5E3_5BC(0xFB43);
const static BranchMap NFD_5E3_map {
    {0x5BC, NFD_5E3_5BC}};
const static Trie NFD_5E3(NFD_5E3_map);
const static Trie NFD_5E4_5BC(0xFB44);
const static Trie NFD_5E4_5BF(0xFB4E);
const static BranchMap NFD_5E4_map {
    {0x5BC, NFD_5E4_5BC},
    {0x5BF, NFD_5E4_5BF}};
const static Trie NFD_5E4(NFD_5E4_map);
const static Trie NFD_5E6_5BC(0xFB46);
const static BranchMap NFD_5E6_map {
    {0x5BC, NFD_5E6_5BC}};
const static Trie NFD_5E6(NFD_5E6_map);
const static Trie NFD_5E7_5BC(0xFB47);
const static BranchMap NFD_5E7_map {
    {0x5BC, NFD_5E7_5BC}};
const static Trie NFD_5E7(NFD_5E7_map);
const static Trie NFD_5E8_5BC(0xFB48);
const static BranchMap NFD_5E8_map {
    {0x5BC, NFD_5E8_5BC}};
const static Trie NFD_5E8(NFD_5E8_map);
const static Trie NFD_5E9_5BC_5C1(0xFB2C);
const static Trie NFD_5E9_5BC_5C2(0xFB2D);
const static BranchMap NFD_5E9_5BC_map {
    {0x5C1, NFD_5E9_5BC_5C1},
    {0x5C2, NFD_5E9_5BC_5C2}};
const static Trie NFD_5E9_5BC(0xFB49, NFD_5E9_5BC_map);
const static Trie NFD_5E9_5C1(0xFB2A);
const static Trie NFD_5E9_5C2(0xFB2B);
const static BranchMap NFD_5E9_map {
    {0x5BC, NFD_5E9_5BC},
    {0x5C1, NFD_5E9_5C1},
    {0x5C2, NFD_5E9_5C2}};
const static Trie NFD_5E9(NFD_5E9_map);
const static Trie NFD_5EA_5BC(0xFB4A);
const static BranchMap NFD_5EA_map {
    {0x5BC, NFD_5EA_5BC}};
const static Trie NFD_5EA(NFD_5EA_map);
const static Trie NFD_5F2_5B7(0xFB1F);
const static BranchMap NFD_5F2_map {
    {0x5B7, NFD_5F2_5B7}};
const static Trie NFD_5F2(NFD_5F2_map);
const static Trie NFD_627_653(0x622);
const static Trie NFD_627_654(0x623);
const static Trie NFD_627_655(0x625);
const static BranchMap NFD_627_map {
    {0x653, NFD_627_653},
    {0x654, NFD_627_654},
    {0x655, NFD_627_655}};
const static Trie NFD_627(NFD_627_map);
const static Trie NFD_648_654(0x624);
const static BranchMap NFD_648_map {
    {0x654, NFD_648_654}};
const static Trie NFD_648(NFD_648_map);
const static Trie NFD_64A_654(0x626);
const static BranchMap NFD_64A_map {
    {0x654, NFD_64A_654}};
const static Trie NFD_64A(NFD_64A_map);
const static Trie NFD_6C1_654(0x6C2);
const static BranchMap NFD_6C1_map {
    {0x654, NFD_6C1_654}};
const static Trie NFD_6C1(NFD_6C1_map);
const static Trie NFD_6D2_654(0x6D3);
const static BranchMap NFD_6D2_map {
    {0x654, NFD_6D2_654}};
const static Trie NFD_6D2(NFD_6D2_map);
const static Trie NFD_6D5_654(0x6C0);
const static BranchMap NFD_6D5_map {
    {0x654, NFD_6D5_654}};
const static Trie NFD_6D5(NFD_6D5_map);
const static Trie NFD_915_93C(0x958);
const static BranchMap NFD_915_map {
    {0x93C, NFD_915_93C}};
const static Trie NFD_915(NFD_915_map);
const static Trie NFD_916_93C(0x959);
const static BranchMap NFD_916_map {
    {0x93C, NFD_916_93C}};
const static Trie NFD_916(NFD_916_map);
const static Trie NFD_917_93C(0x95A);
const static BranchMap NFD_917_map {
    {0x93C, NFD_917_93C}};
const static Trie NFD_917(NFD_917_map);
const static Trie NFD_91C_93C(0x95B);
const static BranchMap NFD_91C_map {
    {0x93C, NFD_91C_93C}};
const static Trie NFD_91C(NFD_91C_map);
const static Trie NFD_921_93C(0x95C);
const static BranchMap NFD_921_map {
    {0x93C, NFD_921_93C}};
const static Trie NFD_921(NFD_921_map);
const static Trie NFD_922_93C(0x95D);
const static BranchMap NFD_922_map {
    {0x93C, NFD_922_93C}};
const static Trie NFD_922(NFD_922_map);
const static Trie NFD_928_93C(0x929);
const static BranchMap NFD_928_map {
    {0x93C, NFD_928_93C}};
const static Trie NFD_928(NFD_928_map);
const static Trie NFD_92B_93C(0x95E);
const static BranchMap NFD_92B_map {
    {0x93C, NFD_92B_93C}};
const static Trie NFD_92B(NFD_92B_map);
const static Trie NFD_92F_93C(0x95F);
const static BranchMap NFD_92F_map {
    {0x93C, NFD_92F_93C}};
const static Trie NFD_92F(NFD_92F_map);
const static Trie NFD_930_93C(0x931);
const static BranchMap NFD_930_map {
    {0x93C, NFD_930_93C}};
const static Trie NFD_930(NFD_930_map);
const static Trie NFD_933_93C(0x934);
const static BranchMap NFD_933_map {
    {0x93C, NFD_933_93C}};
const static Trie NFD_933(NFD_933_map);
const static Trie NFD_9A1_9BC(0x9DC);
const static BranchMap NFD_9A1_map {
    {0x9BC, NFD_9A1_9BC}};
const static Trie NFD_9A1(NFD_9A1_map);
const static Trie NFD_9A2_9BC(0x9DD);
const static BranchMap NFD_9A2_map {
    {0x9BC, NFD_9A2_9BC}};
const static Trie NFD_9A2(NFD_9A2_map);
const static Trie NFD_9AF_9BC(0x9DF);
const static BranchMap NFD_9AF_map {
    {0x9BC, NFD_9AF_9BC}};
const static Trie NFD_9AF(NFD_9AF_map);
const static Trie NFD_9C7_9BE(0x9CB);
const static Trie NFD_9C7_9D7(0x9CC);
const static BranchMap NFD_9C7_map {
    {0x9BE, NFD_9C7_9BE},
    {0x9D7, NFD_9C7_9D7}};
const static Trie NFD_9C7(NFD_9C7_map);
const static Trie NFD_A16_A3C(0xA59);
const static BranchMap NFD_A16_map {
    {0xA3C, NFD_A16_A3C}};
const static Trie NFD_A16(NFD_A16_map);
const static Trie NFD_A17_A3C(0xA5A);
const static BranchMap NFD_A17_map {
    {0xA3C, NFD_A17_A3C}};
const static Trie NFD_A17(NFD_A17_map);
const static Trie NFD_A1C_A3C(0xA5B);
const static BranchMap NFD_A1C_map {
    {0xA3C, NFD_A1C_A3C}};
const static Trie NFD_A1C(NFD_A1C_map);
const static Trie NFD_A2B_A3C(0xA5E);
const static BranchMap NFD_A2B_map {
    {0xA3C, NFD_A2B_A3C}};
const static Trie NFD_A2B(NFD_A2B_map);
const static Trie NFD_A32_A3C(0xA33);
const static BranchMap NFD_A32_map {
    {0xA3C, NFD_A32_A3C}};
const static Trie NFD_A32(NFD_A32_map);
const static Trie NFD_A38_A3C(0xA36);
const static BranchMap NFD_A38_map {
    {0xA3C, NFD_A38_A3C}};
const static Trie NFD_A38(NFD_A38_map);
const static Trie NFD_B21_B3C(0xB5C);
const static BranchMap NFD_B21_map {
    {0xB3C, NFD_B21_B3C}};
const static Trie NFD_B21(NFD_B21_map);
const static Trie NFD_B22_B3C(0xB5D);
const static BranchMap NFD_B22_map {
    {0xB3C, NFD_B22_B3C}};
const static Trie NFD_B22(NFD_B22_map);
const static Trie NFD_B47_B3E(0xB4B);
const static Trie NFD_B47_B56(0xB48);
const static Trie NFD_B47_B57(0xB4C);
const static BranchMap NFD_B47_map {
    {0xB3E, NFD_B47_B3E},
    {0xB56, NFD_B47_B56},
    {0xB57, NFD_B47_B57}};
const static Trie NFD_B47(NFD_B47_map);
const static Trie NFD_B92_BD7(0xB94);
const static BranchMap NFD_B92_map {
    {0xBD7, NFD_B92_BD7}};
const static Trie NFD_B92(NFD_B92_map);
const static Trie NFD_BC6_BBE(0xBCA);
const static Trie NFD_BC6_BD7(0xBCC);
const static BranchMap NFD_BC6_map {
    {0xBBE, NFD_BC6_BBE},
    {0xBD7, NFD_BC6_BD7}};
const static Trie NFD_BC6(NFD_BC6_map);
const static Trie NFD_BC7_BBE(0xBCB);
const static BranchMap NFD_BC7_map {
    {0xBBE, NFD_BC7_BBE}};
const static Trie NFD_BC7(NFD_BC7_map);
const static Trie NFD_C46_C56(0xC48);
const static BranchMap NFD_C46_map {
    {0xC56, NFD_C46_C56}};
const static Trie NFD_C46(NFD_C46_map);
const static Trie NFD_CBF_CD5(0xCC0);
const static BranchMap NFD_CBF_map {
    {0xCD5, NFD_CBF_CD5}};
const static Trie NFD_CBF(NFD_CBF_map);
const static Trie NFD_CC6_CC2_CD5(0xCCB);
const static BranchMap NFD_CC6_CC2_map {
    {0xCD5, NFD_CC6_CC2_CD5}};
const static Trie NFD_CC6_CC2(0xCCA, NFD_CC6_CC2_map);
const static Trie NFD_CC6_CD5(0xCC7);
const static Trie NFD_CC6_CD6(0xCC8);
const static BranchMap NFD_CC6_map {
    {0xCC2, NFD_CC6_CC2},
    {0xCD5, NFD_CC6_CD5},
    {0xCD6, NFD_CC6_CD6}};
const static Trie NFD_CC6(NFD_CC6_map);
const static Trie NFD_D46_D3E(0xD4A);
const static Trie NFD_D46_D57(0xD4C);
const static BranchMap NFD_D46_map {
    {0xD3E, NFD_D46_D3E},
    {0xD57, NFD_D46_D57}};
const static Trie NFD_D46(NFD_D46_map);
const static Trie NFD_D47_D3E(0xD4B);
const static BranchMap NFD_D47_map {
    {0xD3E, NFD_D47_D3E}};
const static Trie NFD_D47(NFD_D47_map);
const static Trie NFD_DD9_DCA(0xDDA);
const static Trie NFD_DD9_DCF_DCA(0xDDD);
const static BranchMap NFD_DD9_DCF_map {
    {0xDCA, NFD_DD9_DCF_DCA}};
const static Trie NFD_DD9_DCF(0xDDC, NFD_DD9_DCF_map);
const static Trie NFD_DD9_DDF(0xDDE);
const static BranchMap NFD_DD9_map {
    {0xDCA, NFD_DD9_DCA},
    {0xDCF, NFD_DD9_DCF},
    {0xDDF, NFD_DD9_DDF}};
const static Trie NFD_DD9(NFD_DD9_map);
const static Trie NFD_F40_FB5(0xF69);
const static BranchMap NFD_F40_map {
    {0xFB5, NFD_F40_FB5}};
const static Trie NFD_F40(NFD_F40_map);
const static Trie NFD_F42_FB7(0xF43);
const static BranchMap NFD_F42_map {
    {0xFB7, NFD_F42_FB7}};
const static Trie NFD_F42(NFD_F42_map);
const static Trie NFD_F4C_FB7(0xF4D);
const static BranchMap NFD_F4C_map {
    {0xFB7, NFD_F4C_FB7}};
const static Trie NFD_F4C(NFD_F4C_map);
const static Trie NFD_F51_FB7(0xF52);
const static BranchMap NFD_F51_map {
    {0xFB7, NFD_F51_FB7}};
const static Trie NFD_F51(NFD_F51_map);
const static Trie NFD_F56_FB7(0xF57);
const static BranchMap NFD_F56_map {
    {0xFB7, NFD_F56_FB7}};
const static Trie NFD_F56(NFD_F56_map);
const static Trie NFD_F5B_FB7(0xF5C);
const static BranchMap NFD_F5B_map {
    {0xFB7, NFD_F5B_FB7}};
const static Trie NFD_F5B(NFD_F5B_map);
const static Trie NFD_F71_F72(0xF73);
const static Trie NFD_F71_F74(0xF75);
const static Trie NFD_F71_F80(0xF81);
const static BranchMap NFD_F71_map {
    {0xF72, NFD_F71_F72},
    {0xF74, NFD_F71_F74},
    {0xF80, NFD_F71_F80}};
const static Trie NFD_F71(NFD_F71_map);
const static Trie NFD_F90_FB5(0xFB9);
const static BranchMap NFD_F90_map {
    {0xFB5, NFD_F90_FB5}};
const static Trie NFD_F90(NFD_F90_map);
const static Trie NFD_F92_FB7(0xF93);
const static BranchMap NFD_F92_map {
    {0xFB7, NFD_F92_FB7}};
const static Trie NFD_F92(NFD_F92_map);
const static Trie NFD_F9C_FB7(0xF9D);
const static BranchMap NFD_F9C_map {
    {0xFB7, NFD_F9C_FB7}};
const static Trie NFD_F9C(NFD_F9C_map);
const static Trie NFD_FA1_FB7(0xFA2);
const static BranchMap NFD_FA1_map {
    {0xFB7, NFD_FA1_FB7}};
const static Trie NFD_FA1(NFD_FA1_map);
const static Trie NFD_FA6_FB7(0xFA7);
const static BranchMap NFD_FA6_map {
    {0xFB7, NFD_FA6_FB7}};
const static Trie NFD_FA6(NFD_FA6_map);
const static Trie NFD_FAB_FB7(0xFAC);
const static BranchMap NFD_FAB_map {
    {0xFB7, NFD_FAB_FB7}};
const static Trie NFD_FAB(NFD_FAB_map);
const static Trie NFD_FB2_F80(0xF76);
const static BranchMap NFD_FB2_map {
    {0xF80, NFD_FB2_F80}};
const static Trie NFD_FB2(NFD_FB2_map);
const static Trie NFD_FB3_F80(0xF78);
const static BranchMap NFD_FB3_map {
    {0xF80, NFD_FB3_F80}};
const static Trie NFD_FB3(NFD_FB3_map);
const static Trie NFD_1025_102E(0x1026);
const static BranchMap NFD_1025_map {
    {0x102E, NFD_1025_102E}};
const static Trie NFD_1025(NFD_1025_map);
const static Trie NFD_1B05_1B35(0x1B06);
const static BranchMap NFD_1B05_map {
    {0x1B35, NFD_1B05_1B35}};
const static Trie NFD_1B05(NFD_1B05_map);
const static Trie NFD_1B07_1B35(0x1B08);
const static BranchMap NFD_1B07_map {
    {0x1B35, NFD_1B07_1B35}};
const static Trie NFD_1B07(NFD_1B07_map);
const static Trie NFD_1B09_1B35(0x1B0A);
const static BranchMap NFD_1B09_map {
    {0x1B35, NFD_1B09_1B35}};
const static Trie NFD_1B09(NFD_1B09_map);
const static Trie NFD_1B0B_1B35(0x1B0C);
const static BranchMap NFD_1B0B_map {
    {0x1B35, NFD_1B0B_1B35}};
const static Trie NFD_1B0B(NFD_1B0B_map);
const static Trie NFD_1B0D_1B35(0x1B0E);
const static BranchMap NFD_1B0D_map {
    {0x1B35, NFD_1B0D_1B35}};
const static Trie NFD_1B0D(NFD_1B0D_map);
const static Trie NFD_1B11_1B35(0x1B12);
const static BranchMap NFD_1B11_map {
    {0x1B35, NFD_1B11_1B35}};
const static Trie NFD_1B11(NFD_1B11_map);
const static Trie NFD_1B3A_1B35(0x1B3B);
const static BranchMap NFD_1B3A_map {
    {0x1B35, NFD_1B3A_1B35}};
const static Trie NFD_1B3A(NFD_1B3A_map);
const static Trie NFD_1B3C_1B35(0x1B3D);
const static BranchMap NFD_1B3C_map {
    {0x1B35, NFD_1B3C_1B35}};
const static Trie NFD_1B3C(NFD_1B3C_map);
const static Trie NFD_1B3E_1B35(0x1B40);
const static BranchMap NFD_1B3E_map {
    {0x1B35, NFD_1B3E_1B35}};
const static Trie NFD_1B3E(NFD_1B3E_map);
const static Trie NFD_1B3F_1B35(0x1B41);
const static BranchMap NFD_1B3F_map {
    {0x1B35, NFD_1B3F_1B35}};
const static Trie NFD_1B3F(NFD_1B3F_map);
const static Trie NFD_1B42_1B35(0x1B43);
const static BranchMap NFD_1B42_map {
    {0x1B35, NFD_1B42_1B35}};
const static Trie NFD_1B42(NFD_1B42_map);
const static Trie NFD_1FBF_300(0x1FCD);
const static Trie NFD_1FBF_301(0x1FCE);
const static Trie NFD_1FBF_342(0x1FCF);
const static BranchMap NFD_1FBF_map {
    {0x300, NFD_1FBF_300},
    {0x301, NFD_1FBF_301},
    {0x342, NFD_1FBF_342}};
const static Trie NFD_1FBF(NFD_1FBF_map);
const static Trie NFD_1FFE_300(0x1FDD);
const static Trie NFD_1FFE_301(0x1FDE);
const static Trie NFD_1FFE_342(0x1FDF);
const static BranchMap NFD_1FFE_map {
    {0x300, NFD_1FFE_300},
    {0x301, NFD_1FFE_301},
    {0x342, NFD_1FFE_342}};
const static Trie NFD_1FFE(NFD_1FFE_map);
const static Trie NFD_2190_338(0x219A);
const static BranchMap NFD_2190_map {
    {0x338, NFD_2190_338}};
const static Trie NFD_2190(NFD_2190_map);
const static Trie NFD_2192_338(0x219B);
const static BranchMap NFD_2192_map {
    {0x338, NFD_2192_338}};
const static Trie NFD_2192(NFD_2192_map);
const static Trie NFD_2194_338(0x21AE);
const static BranchMap NFD_2194_map {
    {0x338, NFD_2194_338}};
const static Trie NFD_2194(NFD_2194_map);
const static Trie NFD_21D0_338(0x21CD);
const static BranchMap NFD_21D0_map {
    {0x338, NFD_21D0_338}};
const static Trie NFD_21D0(NFD_21D0_map);
const static Trie NFD_21D2_338(0x21CF);
const static BranchMap NFD_21D2_map {
    {0x338, NFD_21D2_338}};
const static Trie NFD_21D2(NFD_21D2_map);
const static Trie NFD_21D4_338(0x21CE);
const static BranchMap NFD_21D4_map {
    {0x338, NFD_21D4_338}};
const static Trie NFD_21D4(NFD_21D4_map);
const static Trie NFD_2203_338(0x2204);
const static BranchMap NFD_2203_map {
    {0x338, NFD_2203_338}};
const static Trie NFD_2203(NFD_2203_map);
const static Trie NFD_2208_338(0x2209);
const static BranchMap NFD_2208_map {
    {0x338, NFD_2208_338}};
const static Trie NFD_2208(NFD_2208_map);
const static Trie NFD_220B_338(0x220C);
const static BranchMap NFD_220B_map {
    {0x338, NFD_220B_338}};
const static Trie NFD_220B(NFD_220B_map);
const static Trie NFD_2223_338(0x2224);
const static BranchMap NFD_2223_map {
    {0x338, NFD_2223_338}};
const static Trie NFD_2223(NFD_2223_map);
const static Trie NFD_2225_338(0x2226);
const static BranchMap NFD_2225_map {
    {0x338, NFD_2225_338}};
const static Trie NFD_2225(NFD_2225_map);
const static Trie NFD_223C_338(0x2241);
const static BranchMap NFD_223C_map {
    {0x338, NFD_223C_338}};
const static Trie NFD_223C(NFD_223C_map);
const static Trie NFD_2243_338(0x2244);
const static BranchMap NFD_2243_map {
    {0x338, NFD_2243_338}};
const static Trie NFD_2243(NFD_2243_map);
const static Trie NFD_2245_338(0x2247);
const static BranchMap NFD_2245_map {
    {0x338, NFD_2245_338}};
const static Trie NFD_2245(NFD_2245_map);
const static Trie NFD_2248_338(0x2249);
const static BranchMap NFD_2248_map {
    {0x338, NFD_2248_338}};
const static Trie NFD_2248(NFD_2248_map);
const static Trie NFD_224D_338(0x226D);
const static BranchMap NFD_224D_map {
    {0x338, NFD_224D_338}};
const static Trie NFD_224D(NFD_224D_map);
const static Trie NFD_2261_338(0x2262);
const static BranchMap NFD_2261_map {
    {0x338, NFD_2261_338}};
const static Trie NFD_2261(NFD_2261_map);
const static Trie NFD_2264_338(0x2270);
const static BranchMap NFD_2264_map {
    {0x338, NFD_2264_338}};
const static Trie NFD_2264(NFD_2264_map);
const static Trie NFD_2265_338(0x2271);
const static BranchMap NFD_2265_map {
    {0x338, NFD_2265_338}};
const static Trie NFD_2265(NFD_2265_map);
const static Trie NFD_2272_338(0x2274);
const static BranchMap NFD_2272_map {
    {0x338, NFD_2272_338}};
const static Trie NFD_2272(NFD_2272_map);
const static Trie NFD_2273_338(0x2275);
const static BranchMap NFD_2273_map {
    {0x338, NFD_2273_338}};
const static Trie NFD_2273(NFD_2273_map);
const static Trie NFD_2276_338(0x2278);
const static BranchMap NFD_2276_map {
    {0x338, NFD_2276_338}};
const static Trie NFD_2276(NFD_2276_map);
const static Trie NFD_2277_338(0x2279);
const static BranchMap NFD_2277_map {
    {0x338, NFD_2277_338}};
const static Trie NFD_2277(NFD_2277_map);
const static Trie NFD_227A_338(0x2280);
const static BranchMap NFD_227A_map {
    {0x338, NFD_227A_338}};
const static Trie NFD_227A(NFD_227A_map);
const static Trie NFD_227B_338(0x2281);
const static BranchMap NFD_227B_map {
    {0x338, NFD_227B_338}};
const static Trie NFD_227B(NFD_227B_map);
const static Trie NFD_227C_338(0x22E0);
const static BranchMap NFD_227C_map {
    {0x338, NFD_227C_338}};
const static Trie NFD_227C(NFD_227C_map);
const static Trie NFD_227D_338(0x22E1);
const static BranchMap NFD_227D_map {
    {0x338, NFD_227D_338}};
const static Trie NFD_227D(NFD_227D_map);
const static Trie NFD_2282_338(0x2284);
const static BranchMap NFD_2282_map {
    {0x338, NFD_2282_338}};
const static Trie NFD_2282(NFD_2282_map);
const static Trie NFD_2283_338(0x2285);
const static BranchMap NFD_2283_map {
    {0x338, NFD_2283_338}};
const static Trie NFD_2283(NFD_2283_map);
const static Trie NFD_2286_338(0x2288);
const static BranchMap NFD_2286_map {
    {0x338, NFD_2286_338}};
const static Trie NFD_2286(NFD_2286_map);
const static Trie NFD_2287_338(0x2289);
const static BranchMap NFD_2287_map {
    {0x338, NFD_2287_338}};
const static Trie NFD_2287(NFD_2287_map);
const static Trie NFD_2291_338(0x22E2);
const static BranchMap NFD_2291_map {
    {0x338, NFD_2291_338}};
const static Trie NFD_2291(NFD_2291_map);
const static Trie NFD_2292_338(0x22E3);
const static BranchMap NFD_2292_map {
    {0x338, NFD_2292_338}};
const static Trie NFD_2292(NFD_2292_map);
const static Trie NFD_22A2_338(0x22AC);
const static BranchMap NFD_22A2_map {
    {0x338, NFD_22A2_338}};
const static Trie NFD_22A2(NFD_22A2_map);
const static Trie NFD_22A8_338(0x22AD);
const static BranchMap NFD_22A8_map {
    {0x338, NFD_22A8_338}};
const static Trie NFD_22A8(NFD_22A8_map);
const static Trie NFD_22A9_338(0x22AE);
const static BranchMap NFD_22A9_map {
    {0x338, NFD_22A9_338}};
const static Trie NFD_22A9(NFD_22A9_map);
const static Trie NFD_22AB_338(0x22AF);
const static BranchMap NFD_22AB_map {
    {0x338, NFD_22AB_338}};
const static Trie NFD_22AB(NFD_22AB_map);
const static Trie NFD_22B2_338(0x22EA);
const static BranchMap NFD_22B2_map {
    {0x338, NFD_22B2_338}};
const static Trie NFD_22B2(NFD_22B2_map);
const static Trie NFD_22B3_338(0x22EB);
const static BranchMap NFD_22B3_map {
    {0x338, NFD_22B3_338}};
const static Trie NFD_22B3(NFD_22B3_map);
const static Trie NFD_22B4_338(0x22EC);
const static BranchMap NFD_22B4_map {
    {0x338, NFD_22B4_338}};
const static Trie NFD_22B4(NFD_22B4_map);
const static Trie NFD_22B5_338(0x22ED);
const static BranchMap NFD_22B5_map {
    {0x338, NFD_22B5_338}};
const static Trie NFD_22B5(NFD_22B5_map);
const static Trie NFD_2ADD_338(0x2ADC);
const static BranchMap NFD_2ADD_map {
    {0x338, NFD_2ADD_338}};
const static Trie NFD_2ADD(NFD_2ADD_map);
const static Trie NFD_3046_3099(0x3094);
const static BranchMap NFD_3046_map {
    {0x3099, NFD_3046_3099}};
const static Trie NFD_3046(NFD_3046_map);
const static Trie NFD_304B_3099(0x304C);
const static BranchMap NFD_304B_map {
    {0x3099, NFD_304B_3099}};
const static Trie NFD_304B(NFD_304B_map);
const static Trie NFD_304D_3099(0x304E);
const static BranchMap NFD_304D_map {
    {0x3099, NFD_304D_3099}};
const static Trie NFD_304D(NFD_304D_map);
const static Trie NFD_304F_3099(0x3050);
const static BranchMap NFD_304F_map {
    {0x3099, NFD_304F_3099}};
const static Trie NFD_304F(NFD_304F_map);
const static Trie NFD_3051_3099(0x3052);
const static BranchMap NFD_3051_map {
    {0x3099, NFD_3051_3099}};
const static Trie NFD_3051(NFD_3051_map);
const static Trie NFD_3053_3099(0x3054);
const static BranchMap NFD_3053_map {
    {0x3099, NFD_3053_3099}};
const static Trie NFD_3053(NFD_3053_map);
const static Trie NFD_3055_3099(0x3056);
const static BranchMap NFD_3055_map {
    {0x3099, NFD_3055_3099}};
const static Trie NFD_3055(NFD_3055_map);
const static Trie NFD_3057_3099(0x3058);
const static BranchMap NFD_3057_map {
    {0x3099, NFD_3057_3099}};
const static Trie NFD_3057(NFD_3057_map);
const static Trie NFD_3059_3099(0x305A);
const static BranchMap NFD_3059_map {
    {0x3099, NFD_3059_3099}};
const static Trie NFD_3059(NFD_3059_map);
const static Trie NFD_305B_3099(0x305C);
const static BranchMap NFD_305B_map {
    {0x3099, NFD_305B_3099}};
const static Trie NFD_305B(NFD_305B_map);
const static Trie NFD_305D_3099(0x305E);
const static BranchMap NFD_305D_map {
    {0x3099, NFD_305D_3099}};
const static Trie NFD_305D(NFD_305D_map);
const static Trie NFD_305F_3099(0x3060);
const static BranchMap NFD_305F_map {
    {0x3099, NFD_305F_3099}};
const static Trie NFD_305F(NFD_305F_map);
const static Trie NFD_3061_3099(0x3062);
const static BranchMap NFD_3061_map {
    {0x3099, NFD_3061_3099}};
const static Trie NFD_3061(NFD_3061_map);
const static Trie NFD_3064_3099(0x3065);
const static BranchMap NFD_3064_map {
    {0x3099, NFD_3064_3099}};
const static Trie NFD_3064(NFD_3064_map);
const static Trie NFD_3066_3099(0x3067);
const static BranchMap NFD_3066_map {
    {0x3099, NFD_3066_3099}};
const static Trie NFD_3066(NFD_3066_map);
const static Trie NFD_3068_3099(0x3069);
const static BranchMap NFD_3068_map {
    {0x3099, NFD_3068_3099}};
const static Trie NFD_3068(NFD_3068_map);
const static Trie NFD_306F_3099(0x3070);
const static Trie NFD_306F_309A(0x3071);
const static BranchMap NFD_306F_map {
    {0x3099, NFD_306F_3099},
    {0x309A, NFD_306F_309A}};
const static Trie NFD_306F(NFD_306F_map);
const static Trie NFD_3072_3099(0x3073);
const static Trie NFD_3072_309A(0x3074);
const static BranchMap NFD_3072_map {
    {0x3099, NFD_3072_3099},
    {0x309A, NFD_3072_309A}};
const static Trie NFD_3072(NFD_3072_map);
const static Trie NFD_3075_3099(0x3076);
const static Trie NFD_3075_309A(0x3077);
const static BranchMap NFD_3075_map {
    {0x3099, NFD_3075_3099},
    {0x309A, NFD_3075_309A}};
const static Trie NFD_3075(NFD_3075_map);
const static Trie NFD_3078_3099(0x3079);
const static Trie NFD_3078_309A(0x307A);
const static BranchMap NFD_3078_map {
    {0x3099, NFD_3078_3099},
    {0x309A, NFD_3078_309A}};
const static Trie NFD_3078(NFD_3078_map);
const static Trie NFD_307B_3099(0x307C);
const static Trie NFD_307B_309A(0x307D);
const static BranchMap NFD_307B_map {
    {0x3099, NFD_307B_3099},
    {0x309A, NFD_307B_309A}};
const static Trie NFD_307B(NFD_307B_map);
const static Trie NFD_309D_3099(0x309E);
const static BranchMap NFD_309D_map {
    {0x3099, NFD_309D_3099}};
const static Trie NFD_309D(NFD_309D_map);
const static Trie NFD_30A6_3099(0x30F4);
const static BranchMap NFD_30A6_map {
    {0x3099, NFD_30A6_3099}};
const static Trie NFD_30A6(NFD_30A6_map);
const static Trie NFD_30AB_3099(0x30AC);
const static BranchMap NFD_30AB_map {
    {0x3099, NFD_30AB_3099}};
const static Trie NFD_30AB(NFD_30AB_map);
const static Trie NFD_30AD_3099(0x30AE);
const static BranchMap NFD_30AD_map {
    {0x3099, NFD_30AD_3099}};
const static Trie NFD_30AD(NFD_30AD_map);
const static Trie NFD_30AF_3099(0x30B0);
const static BranchMap NFD_30AF_map {
    {0x3099, NFD_30AF_3099}};
const static Trie NFD_30AF(NFD_30AF_map);
const static Trie NFD_30B1_3099(0x30B2);
const static BranchMap NFD_30B1_map {
    {0x3099, NFD_30B1_3099}};
const static Trie NFD_30B1(NFD_30B1_map);
const static Trie NFD_30B3_3099(0x30B4);
const static BranchMap NFD_30B3_map {
    {0x3099, NFD_30B3_3099}};
const static Trie NFD_30B3(NFD_30B3_map);
const static Trie NFD_30B5_3099(0x30B6);
const static BranchMap NFD_30B5_map {
    {0x3099, NFD_30B5_3099}};
const static Trie NFD_30B5(NFD_30B5_map);
const static Trie NFD_30B7_3099(0x30B8);
const static BranchMap NFD_30B7_map {
    {0x3099, NFD_30B7_3099}};
const static Trie NFD_30B7(NFD_30B7_map);
const static Trie NFD_30B9_3099(0x30BA);
const static BranchMap NFD_30B9_map {
    {0x3099, NFD_30B9_3099}};
const static Trie NFD_30B9(NFD_30B9_map);
const static Trie NFD_30BB_3099(0x30BC);
const static BranchMap NFD_30BB_map {
    {0x3099, NFD_30BB_3099}};
const static Trie NFD_30BB(NFD_30BB_map);
const static Trie NFD_30BD_3099(0x30BE);
const static BranchMap NFD_30BD_map {
    {0x3099, NFD_30BD_3099}};
const static Trie NFD_30BD(NFD_30BD_map);
const static Trie NFD_30BF_3099(0x30C0);
const static BranchMap NFD_30BF_map {
    {0x3099, NFD_30BF_3099}};
const static Trie NFD_30BF(NFD_30BF_map);
const static Trie NFD_30C1_3099(0x30C2);
const static BranchMap NFD_30C1_map {
    {0x3099, NFD_30C1_3099}};
const static Trie NFD_30C1(NFD_30C1_map);
const static Trie NFD_30C4_3099(0x30C5);
const static BranchMap NFD_30C4_map {
    {0x3099, NFD_30C4_3099}};
const static Trie NFD_30C4(NFD_30C4_map);
const static Trie NFD_30C6_3099(0x30C7);
const static BranchMap NFD_30C6_map {
    {0x3099, NFD_30C6_3099}};
const static Trie NFD_30C6(NFD_30C6_map);
const static Trie NFD_30C8_3099(0x30C9);
const static BranchMap NFD_30C8_map {
    {0x3099, NFD_30C8_3099}};
const static Trie NFD_30C8(NFD_30C8_map);
const static Trie NFD_30CF_3099(0x30D0);
const static Trie NFD_30CF_309A(0x30D1);
const static BranchMap NFD_30CF_map {
    {0x3099, NFD_30CF_3099},
    {0x309A, NFD_30CF_309A}};
const static Trie NFD_30CF(NFD_30CF_map);
const static Trie NFD_30D2_3099(0x30D3);
const static Trie NFD_30D2_309A(0x30D4);
const static BranchMap NFD_30D2_map {
    {0x3099, NFD_30D2_3099},
    {0x309A, NFD_30D2_309A}};
const static Trie NFD_30D2(NFD_30D2_map);
const static Trie NFD_30D5_3099(0x30D6);
const static Trie NFD_30D5_309A(0x30D7);
const static BranchMap NFD_30D5_map {
    {0x3099, NFD_30D5_3099},
    {0x309A, NFD_30D5_309A}};
const static Trie NFD_30D5(NFD_30D5_map);
const static Trie NFD_30D8_3099(0x30D9);
const static Trie NFD_30D8_309A(0x30DA);
const static BranchMap NFD_30D8_map {
    {0x3099, NFD_30D8_3099},
    {0x309A, NFD_30D8_309A}};
const static Trie NFD_30D8(NFD_30D8_map);
const static Trie NFD_30DB_3099(0x30DC);
const static Trie NFD_30DB_309A(0x30DD);
const static BranchMap NFD_30DB_map {
    {0x3099, NFD_30DB_3099},
    {0x309A, NFD_30DB_309A}};
const static Trie NFD_30DB(NFD_30DB_map);
const static Trie NFD_30EF_3099(0x30F7);
const static BranchMap NFD_30EF_map {
    {0x3099, NFD_30EF_3099}};
const static Trie NFD_30EF(NFD_30EF_map);
const static Trie NFD_30F0_3099(0x30F8);
const static BranchMap NFD_30F0_map {
    {0x3099, NFD_30F0_3099}};
const static Trie NFD_30F0(NFD_30F0_map);
const static Trie NFD_30F1_3099(0x30F9);
const static BranchMap NFD_30F1_map {
    {0x3099, NFD_30F1_3099}};
const static Trie NFD_30F1(NFD_30F1_map);
const static Trie NFD_30F2_3099(0x30FA);
const static BranchMap NFD_30F2_map {
    {0x3099, NFD_30F2_3099}};
const static Trie NFD_30F2(NFD_30F2_map);
const static Trie NFD_30FD_3099(0x30FE);
const static BranchMap NFD_30FD_map {
    {0x3099, NFD_30FD_3099}};
const static Trie NFD_30FD(NFD_30FD_map);
const static Trie NFD_11099_110BA(0x1109A);
const static BranchMap NFD_11099_map {
    {0x110BA, NFD_11099_110BA}};
const static Trie NFD_11099(NFD_11099_map);
const static Trie NFD_1109B_110BA(0x1109C);
const static BranchMap NFD_1109B_map {
    {0x110BA, NFD_1109B_110BA}};
const static Trie NFD_1109B(NFD_1109B_map);
const static Trie NFD_110A5_110BA(0x110AB);
const static BranchMap NFD_110A5_map {
    {0x110BA, NFD_110A5_110BA}};
const static Trie NFD_110A5(NFD_110A5_map);
const static Trie NFD_11131_11127(0x1112E);
const static BranchMap NFD_11131_map {
    {0x11127, NFD_11131_11127}};
const static Trie NFD_11131(NFD_11131_map);
const static Trie NFD_11132_11127(0x1112F);
const static BranchMap NFD_11132_map {
    {0x11127, NFD_11132_11127}};
const static Trie NFD_11132(NFD_11132_map);
const static Trie NFD_11347_1133E(0x1134B);
const static Trie NFD_11347_11357(0x1134C);
const static BranchMap NFD_11347_map {
    {0x1133E, NFD_11347_1133E},
    {0x11357, NFD_11347_11357}};
const static Trie NFD_11347(NFD_11347_map);
const static Trie NFD_114B9_114B0(0x114BC);
const static Trie NFD_114B9_114BA(0x114BB);
const static Trie NFD_114B9_114BD(0x114BE);
const static BranchMap NFD_114B9_map {
    {0x114B0, NFD_114B9_114B0},
    {0x114BA, NFD_114B9_114BA},
    {0x114BD, NFD_114B9_114BD}};
const static Trie NFD_114B9(NFD_114B9_map);
const static Trie NFD_115B8_115AF(0x115BA);
const static BranchMap NFD_115B8_map {
    {0x115AF, NFD_115B8_115AF}};
const static Trie NFD_115B8(NFD_115B8_map);
const static Trie NFD_115B9_115AF(0x115BB);
const static BranchMap NFD_115B9_map {
    {0x115AF, NFD_115B9_115AF}};
const static Trie NFD_115B9(NFD_115B9_map);
const static Trie NFD_1D157_1D165(0x1D15E);
const static BranchMap NFD_1D157_map {
    {0x1D165, NFD_1D157_1D165}};
const static Trie NFD_1D157(NFD_1D157_map);
const static Trie NFD_1D158_1D165_1D16E(0x1D160);
const static Trie NFD_1D158_1D165_1D16F(0x1D161);
const static Trie NFD_1D158_1D165_1D170(0x1D162);
const static Trie NFD_1D158_1D165_1D171(0x1D163);
const static Trie NFD_1D158_1D165_1D172(0x1D164);
const static BranchMap NFD_1D158_1D165_map {
    {0x1D16E, NFD_1D158_1D165_1D16E},
    {0x1D16F, NFD_1D158_1D165_1D16F},
    {0x1D170, NFD_1D158_1D165_1D170},
    {0x1D171, NFD_1D158_1D165_1D171},
    {0x1D172, NFD_1D158_1D165_1D172}};
const static Trie NFD_1D158_1D165(0x1D15F, NFD_1D158_1D165_map);
const static BranchMap NFD_1D158_map {
    {0x1D165, NFD_1D158_1D165}};
const static Trie NFD_1D158(NFD_1D158_map);
const static Trie NFD_1D1B9_1D165_1D16E(0x1D1BD);
const static Trie NFD_1D1B9_1D165_1D16F(0x1D1BF);
const static BranchMap NFD_1D1B9_1D165_map {
    {0x1D16E, NFD_1D1B9_1D165_1D16E},
    {0x1D16F, NFD_1D1B9_1D165_1D16F}};
const static Trie NFD_1D1B9_1D165(0x1D1BB, NFD_1D1B9_1D165_map);
const static BranchMap NFD_1D1B9_map {
    {0x1D165, NFD_1D1B9_1D165}};
const static Trie NFD_1D1B9(NFD_1D1B9_map);
const static Trie NFD_1D1BA_1D165_1D16E(0x1D1BE);
const static Trie NFD_1D1BA_1D165_1D16F(0x1D1C0);
const static BranchMap NFD_1D1BA_1D165_map {
    {0x1D16E, NFD_1D1BA_1D165_1D16E},
    {0x1D16F, NFD_1D1BA_1D165_1D16F}};
const static Trie NFD_1D1BA_1D165(0x1D1BC, NFD_1D1BA_1D165_map);
const static BranchMap NFD_1D1BA_map {
    {0x1D165, NFD_1D1BA_1D165}};
const static Trie NFD_1D1BA(NFD_1D1BA_map);
const static BranchMap NFD_map {
    {0x3C, NFD_3C},
    {0x3D, NFD_3D},
    {0x3E, NFD_3E},
    {0x41, NFD_41},
    {0x42, NFD_42},
    {0x43, NFD_43},
    {0x44, NFD_44},
    {0x45, NFD_45},
    {0x46, NFD_46},
    {0x47, NFD_47},
    {0x48, NFD_48},
    {0x49, NFD_49},
    {0x4A, NFD_4A},
    {0x4B, NFD_4B},
    {0x4C, NFD_4C},
    {0x4D, NFD_4D},
    {0x4E, NFD_4E},
    {0x4F, NFD_4F},
    {0x50, NFD_50},
    {0x52, NFD_52},
    {0x53, NFD_53},
    {0x54, NFD_54},
    {0x55, NFD_55},
    {0x56, NFD_56},
    {0x57, NFD_57},
    {0x58, NFD_58},
    {0x59, NFD_59},
    {0x5A, NFD_5A},
    {0x61, NFD_61},
    {0x62, NFD_62},
    {0x63, NFD_63},
    {0x64, NFD_64},
    {0x65, NFD_65},
    {0x66, NFD_66},
    {0x67, NFD_67},
    {0x68, NFD_68},
    {0x69, NFD_69},
    {0x6A, NFD_6A},
    {0x6B, NFD_6B},
    {0x6C, NFD_6C},
    {0x6D, NFD_6D},
    {0x6E, NFD_6E},
    {0x6F, NFD_6F},
    {0x70, NFD_70},
    {0x72, NFD_72},
    {0x73, NFD_73},
    {0x74, NFD_74},
    {0x75, NFD_75},
    {0x76, NFD_76},
    {0x77, NFD_77},
    {0x78, NFD_78},
    {0x79, NFD_79},
    {0x7A, NFD_7A},
    {0xA8, NFD_A8},
    {0xC6, NFD_C6},
    {0xD8, NFD_D8},
    {0xE6, NFD_E6},
    {0xF8, NFD_F8},
    {0x17F, NFD_17F},
    {0x1B7, NFD_1B7},
    {0x292, NFD_292},
    {0x308, NFD_308},
    {0x391, NFD_391},
    {0x395, NFD_395},
    {0x397, NFD_397},
    {0x399, NFD_399},
    {0x39F, NFD_39F},
    {0x3A1, NFD_3A1},
    {0x3A5, NFD_3A5},
    {0x3A9, NFD_3A9},
    {0x3B1, NFD_3B1},
    {0x3B5, NFD_3B5},
    {0x3B7, NFD_3B7},
    {0x3B9, NFD_3B9},
    {0x3BF, NFD_3BF},
    {0x3C1, NFD_3C1},
    {0x3C5, NFD_3C5},
    {0x3C9, NFD_3C9},
    {0x3D2, NFD_3D2},
    {0x406, NFD_406},
    {0x410, NFD_410},
    {0x413, NFD_413},
    {0x415, NFD_415},
    {0x416, NFD_416},
    {0x417, NFD_417},
    {0x418, NFD_418},
    {0x41A, NFD_41A},
    {0x41E, NFD_41E},
    {0x423, NFD_423},
    {0x427, NFD_427},
    {0x42B, NFD_42B},
    {0x42D, NFD_42D},
    {0x430, NFD_430},
    {0x433, NFD_433},
    {0x435, NFD_435},
    {0x436, NFD_436},
    {0x437, NFD_437},
    {0x438, NFD_438},
    {0x43A, NFD_43A},
    {0x43E, NFD_43E},
    {0x443, NFD_443},
    {0x447, NFD_447},
    {0x44B, NFD_44B},
    {0x44D, NFD_44D},
    {0x456, NFD_456},
    {0x474, NFD_474},
    {0x475, NFD_475},
    {0x4D8, NFD_4D8},
    {0x4D9, NFD_4D9},
    {0x4E8, NFD_4E8},
    {0x4E9, NFD_4E9},
    {0x5D0, NFD_5D0},
    {0x5D1, NFD_5D1},
    {0x5D2, NFD_5D2},
    {0x5D3, NFD_5D3},
    {0x5D4, NFD_5D4},
    {0x5D5, NFD_5D5},
    {0x5D6, NFD_5D6},
    {0x5D8, NFD_5D8},
    {0x5D9, NFD_5D9},
    {0x5DA, NFD_5DA},
    {0x5DB, NFD_5DB},
    {0x5DC, NFD_5DC},
    {0x5DE, NFD_5DE},
    {0x5E0, NFD_5E0},
    {0x5E1, NFD_5E1},
    {0x5E3, NFD_5E3},
    {0x5E4, NFD_5E4},
    {0x5E6, NFD_5E6},
    {0x5E7, NFD_5E7},
    {0x5E8, NFD_5E8},
    {0x5E9, NFD_5E9},
    {0x5EA, NFD_5EA},
    {0x5F2, NFD_5F2},
    {0x627, NFD_627},
    {0x648, NFD_648},
    {0x64A, NFD_64A},
    {0x6C1, NFD_6C1},
    {0x6D2, NFD_6D2},
    {0x6D5, NFD_6D5},
    {0x915, NFD_915},
    {0x916, NFD_916},
    {0x917, NFD_917},
    {0x91C, NFD_91C},
    {0x921, NFD_921},
    {0x922, NFD_922},
    {0x928, NFD_928},
    {0x92B, NFD_92B},
    {0x92F, NFD_92F},
    {0x930, NFD_930},
    {0x933, NFD_933},
    {0x9A1, NFD_9A1},
    {0x9A2, NFD_9A2},
    {0x9AF, NFD_9AF},
    {0x9C7, NFD_9C7},
    {0xA16, NFD_A16},
    {0xA17, NFD_A17},
    {0xA1C, NFD_A1C},
    {0xA2B, NFD_A2B},
    {0xA32, NFD_A32},
    {0xA38, NFD_A38},
    {0xB21, NFD_B21},
    {0xB22, NFD_B22},
    {0xB47, NFD_B47},
    {0xB92, NFD_B92},
    {0xBC6, NFD_BC6},
    {0xBC7, NFD_BC7},
    {0xC46, NFD_C46},
    {0xCBF, NFD_CBF},
    {0xCC6, NFD_CC6},
    {0xD46, NFD_D46},
    {0xD47, NFD_D47},
    {0xDD9, NFD_DD9},
    {0xF40, NFD_F40},
    {0xF42, NFD_F42},
    {0xF4C, NFD_F4C},
    {0xF51, NFD_F51},
    {0xF56, NFD_F56},
    {0xF5B, NFD_F5B},
    {0xF71, NFD_F71},
    {0xF90, NFD_F90},
    {0xF92, NFD_F92},
    {0xF9C, NFD_F9C},
    {0xFA1, NFD_FA1},
    {0xFA6, NFD_FA6},
    {0xFAB, NFD_FAB},
    {0xFB2, NFD_FB2},
    {0xFB3, NFD_FB3},
    {0x1025, NFD_1025},
    {0x1B05, NFD_1B05},
    {0x1B07, NFD_1B07},
    {0x1B09, NFD_1B09},
    {0x1B0B, NFD_1B0B},
    {0x1B0D, NFD_1B0D},
    {0x1B11, NFD_1B11},
    {0x1B3A, NFD_1B3A},
    {0x1B3C, NFD_1B3C},
    {0x1B3E, NFD_1B3E},
    {0x1B3F, NFD_1B3F},
    {0x1B42, NFD_1B42},
    {0x1FBF, NFD_1FBF},
    {0x1FFE, NFD_1FFE},
    {0x2190, NFD_2190},
    {0x2192, NFD_2192},
    {0x2194, NFD_2194},
    {0x21D0, NFD_21D0},
    {0x21D2, NFD_21D2},
    {0x21D4, NFD_21D4},
    {0x2203, NFD_2203},
    {0x2208, NFD_2208},
    {0x220B, NFD_220B},
    {0x2223, NFD_2223},
    {0x2225, NFD_2225},
    {0x223C, NFD_223C},
    {0x2243, NFD_2243},
    {0x2245, NFD_2245},
    {0x2248, NFD_2248},
    {0x224D, NFD_224D},
    {0x2261, NFD_2261},
    {0x2264, NFD_2264},
    {0x2265, NFD_2265},
    {0x2272, NFD_2272},
    {0x2273, NFD_2273},
    {0x2276, NFD_2276},
    {0x2277, NFD_2277},
    {0x227A, NFD_227A},
    {0x227B, NFD_227B},
    {0x227C, NFD_227C},
    {0x227D, NFD_227D},
    {0x2282, NFD_2282},
    {0x2283, NFD_2283},
    {0x2286, NFD_2286},
    {0x2287, NFD_2287},
    {0x2291, NFD_2291},
    {0x2292, NFD_2292},
    {0x22A2, NFD_22A2},
    {0x22A8, NFD_22A8},
    {0x22A9, NFD_22A9},
    {0x22AB, NFD_22AB},
    {0x22B2, NFD_22B2},
    {0x22B3, NFD_22B3},
    {0x22B4, NFD_22B4},
    {0x22B5, NFD_22B5},
    {0x2ADD, NFD_2ADD},
    {0x3046, NFD_3046},
    {0x304B, NFD_304B},
    {0x304D, NFD_304D},
    {0x304F, NFD_304F},
    {0x3051, NFD_3051},
    {0x3053, NFD_3053},
    {0x3055, NFD_3055},
    {0x3057, NFD_3057},
    {0x3059, NFD_3059},
    {0x305B, NFD_305B},
    {0x305D, NFD_305D},
    {0x305F, NFD_305F},
    {0x3061, NFD_3061},
    {0x3064, NFD_3064},
    {0x3066, NFD_3066},
    {0x3068, NFD_3068},
    {0x306F, NFD_306F},
    {0x3072, NFD_3072},
    {0x3075, NFD_3075},
    {0x3078, NFD_3078},
    {0x307B, NFD_307B},
    {0x309D, NFD_309D},
    {0x30A6, NFD_30A6},
    {0x30AB, NFD_30AB},
    {0x30AD, NFD_30AD},
    {0x30AF, NFD_30AF},
    {0x30B1, NFD_30B1},
    {0x30B3, NFD_30B3},
    {0x30B5, NFD_30B5},
    {0x30B7, NFD_30B7},
    {0x30B9, NFD_30B9},
    {0x30BB, NFD_30BB},
    {0x30BD, NFD_30BD},
    {0x30BF, NFD_30BF},
    {0x30C1, NFD_30C1},
    {0x30C4, NFD_30C4},
    {0x30C6, NFD_30C6},
    {0x30C8, NFD_30C8},
    {0x30CF, NFD_30CF},
    {0x30D2, NFD_30D2},
    {0x30D5, NFD_30D5},
    {0x30D8, NFD_30D8},
    {0x30DB, NFD_30DB},
    {0x30EF, NFD_30EF},
    {0x30F0, NFD_30F0},
    {0x30F1, NFD_30F1},
    {0x30F2, NFD_30F2},
    {0x30FD, NFD_30FD},
    {0x11099, NFD_11099},
    {0x1109B, NFD_1109B},
    {0x110A5, NFD_110A5},
    {0x11131, NFD_11131},
    {0x11132, NFD_11132},
    {0x11347, NFD_11347},
    {0x114B9, NFD_114B9},
    {0x115B8, NFD_115B8},
    {0x115B9, NFD_115B9},
    {0x1D157, NFD_1D157},
    {0x1D158, NFD_1D158},
    {0x1D1B9, NFD_1D1B9},
    {0x1D1BA, NFD_1D1BA}};
const static Trie NFD_Trie(NFD_map);

//
//  Mappings for codepoints with a complex casefold-canonical decomposition.
//  (A decomposition that differs from the simple casefold of its NFD.)
//
const static Trie NFDi_61_2BE(0x1E9A);
const static BranchMap NFDi_61_map {
    {0x2BE, NFDi_61_2BE}};
const static Trie NFDi_61(NFDi_61_map);
const static Trie NFDi_66_66_69(0xFB03);
const static Trie NFDi_66_66_6C(0xFB04);
const static BranchMap NFDi_66_66_map {
    {0x69, NFDi_66_66_69},
    {0x6C, NFDi_66_66_6C}};
const static Trie NFDi_66_66(0xFB00, NFDi_66_66_map);
const static Trie NFDi_66_69(0xFB01);
const static Trie NFDi_66_6C(0xFB02);
const static BranchMap NFDi_66_map {
    {0x66, NFDi_66_66},
    {0x69, NFDi_66_69},
    {0x6C, NFDi_66_6C}};
const static Trie NFDi_66(NFDi_66_map);
const static Trie NFDi_73_73(0xDF);
const static Trie NFDi_73_74(0xFB05);
const static BranchMap NFDi_73_map {
    {0x73, NFDi_73_73},
    {0x74, NFDi_73_74}};
const static Trie NFDi_73(NFDi_73_map);
const static Trie NFDi_2BC_6E(0x149);
const static BranchMap NFDi_2BC_map {
    {0x6E, NFDi_2BC_6E}};
const static Trie NFDi_2BC(NFDi_2BC_map);
const static Trie NFDi_565_582(0x587);
const static BranchMap NFDi_565_map {
    {0x582, NFDi_565_582}};
const static Trie NFDi_565(NFDi_565_map);
const static Trie NFDi_574_565(0xFB14);
const static Trie NFDi_574_56B(0xFB15);
const static Trie NFDi_574_56D(0xFB17);
const static Trie NFDi_574_576(0xFB13);
const static BranchMap NFDi_574_map {
    {0x565, NFDi_574_565},
    {0x56B, NFDi_574_56B},
    {0x56D, NFDi_574_56D},
    {0x576, NFDi_574_576}};
const static Trie NFDi_574(NFDi_574_map);
const static Trie NFDi_57E_576(0xFB16);
const static BranchMap NFDi_57E_map {
    {0x576, NFDi_57E_576}};
const static Trie NFDi_57E(NFDi_57E_map);
const static BranchMap NFDi_map {
    {0x61, NFDi_61},
    {0x66, NFDi_66},
    {0x73, NFDi_73},
    {0x2BC, NFDi_2BC},
    {0x565, NFDi_565},
    {0x574, NFDi_574},
    {0x57E, NFDi_57E}};
const static Trie NFDi_Trie(NFDi_map);

//
//  Mappings for codepoints with an NFKD decomposition that differs from
//  its NFD decomposition.
//
const static Trie NFKD_20_301(0xB4);
const static Trie NFKD_20_303(0x2DC);
const static Trie NFKD_20_304(0xAF);
const static Trie NFKD_20_305(0x203E);
const static Trie NFKD_20_306(0x2D8);
const static Trie NFKD_20_307(0x2D9);
const static Trie NFKD_20_308_300(0x1FED);
const static Trie NFKD_20_308_301(0x385);
const static Trie NFKD_20_308_342(0x1FC1);
const static BranchMap NFKD_20_308_map {
    {0x300, NFKD_20_308_300},
    {0x301, NFKD_20_308_301},
    {0x342, NFKD_20_308_342}};
const static Trie NFKD_20_308(0xA8, NFKD_20_308_map);
const static Trie NFKD_20_30A(0x2DA);
const static Trie NFKD_20_30B(0x2DD);
const static Trie NFKD_20_313_300(0x1FCD);
const static Trie NFKD_20_313_301(0x1FCE);
const static Trie NFKD_20_313_342(0x1FCF);
const static BranchMap NFKD_20_313_map {
    {0x300, NFKD_20_313_300},
    {0x301, NFKD_20_313_301},
    {0x342, NFKD_20_313_342}};
const static Trie NFKD_20_313(0x1FBD, NFKD_20_313_map);
const static Trie NFKD_20_314_300(0x1FDD);
const static Trie NFKD_20_314_301(0x1FDE);
const static Trie NFKD_20_314_342(0x1FDF);
const static BranchMap NFKD_20_314_map {
    {0x300, NFKD_20_314_300},
    {0x301, NFKD_20_314_301},
    {0x342, NFKD_20_314_342}};
const static Trie NFKD_20_314(0x1FFE, NFKD_20_314_map);
const static Trie NFKD_20_327(0xB8);
const static Trie NFKD_20_328(0x2DB);
const static Trie NFKD_20_333(0x2017);
const static Trie NFKD_20_342(0x1FC0);
const static Trie NFKD_20_345(0x37A);
const static Trie NFKD_20_64B(0xFE70);
const static Trie NFKD_20_64C_651(0xFC5E);
const static BranchMap NFKD_20_64C_map {
    {0x651, NFKD_20_64C_651}};
const static Trie NFKD_20_64C(0xFE72, NFKD_20_64C_map);
const static Trie NFKD_20_64D_651(0xFC5F);
const static BranchMap NFKD_20_64D_map {
    {0x651, NFKD_20_64D_651}};
const static Trie NFKD_20_64D(0xFE74, NFKD_20_64D_map);
const static Trie NFKD_20_64E_651(0xFC60);
const static BranchMap NFKD_20_64E_map {
    {0x651, NFKD_20_64E_651}};
const static Trie NFKD_20_64E(0xFE76, NFKD_20_64E_map);
const static Trie NFKD_20_64F_651(0xFC61);
const static BranchMap NFKD_20_64F_map {
    {0x651, NFKD_20_64F_651}};
const static Trie NFKD_20_64F(0xFE78, NFKD_20_64F_map);
const static Trie NFKD_20_650_651(0xFC62);
const static BranchMap NFKD_20_650_map {
    {0x651, NFKD_20_650_651}};
const static Trie NFKD_20_650(0xFE7A, NFKD_20_650_map);
const static Trie NFKD_20_651_670(0xFC63);
const static BranchMap NFKD_20_651_map {
    {0x670, NFKD_20_651_670}};
const static Trie NFKD_20_651(0xFE7C, NFKD_20_651_map);
const static Trie NFKD_20_652(0xFE7E);
const static Trie NFKD_20_3099(0x309B);
const static Trie NFKD_20_309A(0x309C);
const static BranchMap NFKD_20_map {
    {0x301, NFKD_20_301},
    {0x303, NFKD_20_303},
    {0x304, NFKD_20_304},
    {0x305, NFKD_20_305},
    {0x306, NFKD_20_306},
    {0x307, NFKD_20_307},
    {0x308, NFKD_20_308},
    {0x30A, NFKD_20_30A},
    {0x30B, NFKD_20_30B},
    {0x313, NFKD_20_313},
    {0x314, NFKD_20_314},
    {0x327, NFKD_20_327},
    {0x328, NFKD_20_328},
    {0x333, NFKD_20_333},
    {0x342, NFKD_20_342},
    {0x345, NFKD_20_345},
    {0x64B, NFKD_20_64B},
    {0x64C, NFKD_20_64C},
    {0x64D, NFKD_20_64D},
    {0x64E, NFKD_20_64E},
    {0x64F, NFKD_20_64F},
    {0x650, NFKD_20_650},
    {0x651, NFKD_20_651},
    {0x652, NFKD_20_652},
    {0x3099, NFKD_20_3099},
    {0x309A, NFKD_20_309A}};
const static Trie NFKD_20(NFKD_20_map);
const static Trie NFKD_21_21(0x203C);
const static Trie NFKD_21_3F(0x2049);
const static BranchMap NFKD_21_map {
    {0x21, NFKD_21_21},
    {0x3F, NFKD_21_3F}};
const static Trie NFKD_21(NFKD_21_map);
const static Trie NFKD_28_31_29(0x2474);
const static Trie NFKD_28_31_30_29(0x247D);
const static BranchMap NFKD_28_31_30_map {
    {0x29, NFKD_28_31_30_29}};
const static Trie NFKD_28_31_30(NFKD_28_31_30_map);
const static Trie NFKD_28_31_31_29(0x247E);
const static BranchMap NFKD_28_31_31_map {
    {0x29, NFKD_28_31_31_29}};
const static Trie NFKD_28_31_31(NFKD_28_31_31_map);
const static Trie NFKD_28_31_32_29(0x247F);
const static BranchMap NFKD_28_31_32_map {
    {0x29, NFKD_28_31_32_29}};
const static Trie NFKD_28_31_32(NFKD_28_31_32_map);
const static Trie NFKD_28_31_33_29(0x2480);
const static BranchMap NFKD_28_31_33_map {
    {0x29, NFKD_28_31_33_29}};
const static Trie NFKD_28_31_33(NFKD_28_31_33_map);
const static Trie NFKD_28_31_34_29(0x2481);
const static BranchMap NFKD_28_31_34_map {
    {0x29, NFKD_28_31_34_29}};
const static Trie NFKD_28_31_34(NFKD_28_31_34_map);
const static Trie NFKD_28_31_35_29(0x2482);
const static BranchMap NFKD_28_31_35_map {
    {0x29, NFKD_28_31_35_29}};
const static Trie NFKD_28_31_35(NFKD_28_31_35_map);
const static Trie NFKD_28_31_36_29(0x2483);
const static BranchMap NFKD_28_31_36_map {
    {0x29, NFKD_28_31_36_29}};
const static Trie NFKD_28_31_36(NFKD_28_31_36_map);
const static Trie NFKD_28_31_37_29(0x2484);
const static BranchMap NFKD_28_31_37_map {
    {0x29, NFKD_28_31_37_29}};
const static Trie NFKD_28_31_37(NFKD_28_31_37_map);
const static Trie NFKD_28_31_38_29(0x2485);
const static BranchMap NFKD_28_31_38_map {
    {0x29, NFKD_28_31_38_29}};
const static Trie NFKD_28_31_38(NFKD_28_31_38_map);
const static Trie NFKD_28_31_39_29(0x2486);
const static BranchMap NFKD_28_31_39_map {
    {0x29, NFKD_28_31_39_29}};
const static Trie NFKD_28_31_39(NFKD_28_31_39_map);
const static BranchMap NFKD_28_31_map {
    {0x29, NFKD_28_31_29},
    {0x30, NFKD_28_31_30},
    {0x31, NFKD_28_31_31},
    {0x32, NFKD_28_31_32},
    {0x33, NFKD_28_31_33},
    {0x34, NFKD_28_31_34},
    {0x35, NFKD_28_31_35},
    {0x36, NFKD_28_31_36},
    {0x37, NFKD_28_31_37},
    {0x38, NFKD_28_31_38},
    {0x39, NFKD_28_31_39}};
const static Trie NFKD_28_31(NFKD_28_31_map);
const static Trie NFKD_28_32_29(0x2475);
const static Trie NFKD_28_32_30_29(0x2487);
const static BranchMap NFKD_28_32_30_map {
    {0x29, NFKD_28_32_30_29}};
const static Trie NFKD_28_32_30(NFKD_28_32_30_map);
const static BranchMap NFKD_28_32_map {
    {0x29, NFKD_28_32_29},
    {0x30, NFKD_28_32_30}};
const static Trie NFKD_28_32(NFKD_28_32_map);
const static Trie NFKD_28_33_29(0x2476);
const static BranchMap NFKD_28_33_map {
    {0x29, NFKD_28_33_29}};
const static Trie NFKD_28_33(NFKD_28_33_map);
const static Trie NFKD_28_34_29(0x2477);
const static BranchMap NFKD_28_34_map {
    {0x29, NFKD_28_34_29}};
const static Trie NFKD_28_34(NFKD_28_34_map);
const static Trie NFKD_28_35_29(0x2478);
const static BranchMap NFKD_28_35_map {
    {0x29, NFKD_28_35_29}};
const static Trie NFKD_28_35(NFKD_28_35_map);
const static Trie NFKD_28_36_29(0x2479);
const static BranchMap NFKD_28_36_map {
    {0x29, NFKD_28_36_29}};
const static Trie NFKD_28_36(NFKD_28_36_map);
const static Trie NFKD_28_37_29(0x247A);
const static BranchMap NFKD_28_37_map {
    {0x29, NFKD_28_37_29}};
const static Trie NFKD_28_37(NFKD_28_37_map);
const static Trie NFKD_28_38_29(0x247B);
const static BranchMap NFKD_28_38_map {
    {0x29, NFKD_28_38_29}};
const static Trie NFKD_28_38(NFKD_28_38_map);
const static Trie NFKD_28_39_29(0x247C);
const static BranchMap NFKD_28_39_map {
    {0x29, NFKD_28_39_29}};
const static Trie NFKD_28_39(NFKD_28_39_map);
const static Trie NFKD_28_41_29(0x1F110);
const static BranchMap NFKD_28_41_map {
    {0x29, NFKD_28_41_29}};
const static Trie NFKD_28_41(NFKD_28_41_map);
const static Trie NFKD_28_42_29(0x1F111);
const static BranchMap NFKD_28_42_map {
    {0x29, NFKD_28_42_29}};
const static Trie NFKD_28_42(NFKD_28_42_map);
const static Trie NFKD_28_43_29(0x1F112);
const static BranchMap NFKD_28_43_map {
    {0x29, NFKD_28_43_29}};
const static Trie NFKD_28_43(NFKD_28_43_map);
const static Trie NFKD_28_44_29(0x1F113);
const static BranchMap NFKD_28_44_map {
    {0x29, NFKD_28_44_29}};
const static Trie NFKD_28_44(NFKD_28_44_map);
const static Trie NFKD_28_45_29(0x1F114);
const static BranchMap NFKD_28_45_map {
    {0x29, NFKD_28_45_29}};
const static Trie NFKD_28_45(NFKD_28_45_map);
const static Trie NFKD_28_46_29(0x1F115);
const static BranchMap NFKD_28_46_map {
    {0x29, NFKD_28_46_29}};
const static Trie NFKD_28_46(NFKD_28_46_map);
const static Trie NFKD_28_47_29(0x1F116);
const static BranchMap NFKD_28_47_map {
    {0x29, NFKD_28_47_29}};
const static Trie NFKD_28_47(NFKD_28_47_map);
const static Trie NFKD_28_48_29(0x1F117);
const static BranchMap NFKD_28_48_map {
    {0x29, NFKD_28_48_29}};
const static Trie NFKD_28_48(NFKD_28_48_map);
const static Trie NFKD_28_49_29(0x1F118);
const static BranchMap NFKD_28_49_map {
    {0x29, NFKD_28_49_29}};
const static Trie NFKD_28_49(NFKD_28_49_map);
const static Trie NFKD_28_4A_29(0x1F119);
const static BranchMap NFKD_28_4A_map {
    {0x29, NFKD_28_4A_29}};
const static Trie NFKD_28_4A(NFKD_28_4A_map);
const static Trie NFKD_28_4B_29(0x1F11A);
const static BranchMap NFKD_28_4B_map {
    {0x29, NFKD_28_4B_29}};
const static Trie NFKD_28_4B(NFKD_28_4B_map);
const static Trie NFKD_28_4C_29(0x1F11B);
const static BranchMap NFKD_28_4C_map {
    {0x29, NFKD_28_4C_29}};
const static Trie NFKD_28_4C(NFKD_28_4C_map);
const static Trie NFKD_28_4D_29(0x1F11C);
const static BranchMap NFKD_28_4D_map {
    {0x29, NFKD_28_4D_29}};
const static Trie NFKD_28_4D(NFKD_28_4D_map);
const static Trie NFKD_28_4E_29(0x1F11D);
const static BranchMap NFKD_28_4E_map {
    {0x29, NFKD_28_4E_29}};
const static Trie NFKD_28_4E(NFKD_28_4E_map);
const static Trie NFKD_28_4F_29(0x1F11E);
const static BranchMap NFKD_28_4F_map {
    {0x29, NFKD_28_4F_29}};
const static Trie NFKD_28_4F(NFKD_28_4F_map);
const static Trie NFKD_28_50_29(0x1F11F);
const static BranchMap NFKD_28_50_map {
    {0x29, NFKD_28_50_29}};
const static Trie NFKD_28_50(NFKD_28_50_map);
const static Trie NFKD_28_51_29(0x1F120);
const static BranchMap NFKD_28_51_map {
    {0x29, NFKD_28_51_29}};
const static Trie NFKD_28_51(NFKD_28_51_map);
const static Trie NFKD_28_52_29(0x1F121);
const static BranchMap NFKD_28_52_map {
    {0x29, NFKD_28_52_29}};
const static Trie NFKD_28_52(NFKD_28_52_map);
const static Trie NFKD_28_53_29(0x1F122);
const static BranchMap NFKD_28_53_map {
    {0x29, NFKD_28_53_29}};
const static Trie NFKD_28_53(NFKD_28_53_map);
const static Trie NFKD_28_54_29(0x1F123);
const static BranchMap NFKD_28_54_map {
    {0x29, NFKD_28_54_29}};
const static Trie NFKD_28_54(NFKD_28_54_map);
const static Trie NFKD_28_55_29(0x1F124);
const static BranchMap NFKD_28_55_map {
    {0x29, NFKD_28_55_29}};
const static Trie NFKD_28_55(NFKD_28_55_map);
const static Trie NFKD_28_56_29(0x1F125);
const static BranchMap NFKD_28_56_map {
    {0x29, NFKD_28_56_29}};
const static Trie NFKD_28_56(NFKD_28_56_map);
const static Trie NFKD_28_57_29(0x1F126);
const static BranchMap NFKD_28_57_map {
    {0x29, NFKD_28_57_29}};
const static Trie NFKD_28_57(NFKD_28_57_map);
const static Trie NFKD_28_58_29(0x1F127);
const static BranchMap NFKD_28_58_map {
    {0x29, NFKD_28_58_29}};
const static Trie NFKD_28_58(NFKD_28_58_map);
const static Trie NFKD_28_59_29(0x1F128);
const static BranchMap NFKD_28_59_map {
    {0x29, NFKD_28_59_29}};
const static Trie NFKD_28_59(NFKD_28_59_map);
const static Trie NFKD_28_5A_29(0x1F129);
const static BranchMap NFKD_28_5A_map {
    {0x29, NFKD_28_5A_29}};
const static Trie NFKD_28_5A(NFKD_28_5A_map);
const static Trie NFKD_28_61_29(0x249C);
const static BranchMap NFKD_28_61_map {
    {0x29, NFKD_28_61_29}};
const static Trie NFKD_28_61(NFKD_28_61_map);
const static Trie NFKD_28_62_29(0x249D);
const static BranchMap NFKD_28_62_map {
    {0x29, NFKD_28_62_29}};
const static Trie NFKD_28_62(NFKD_28_62_map);
const static Trie NFKD_28_63_29(0x249E);
const static BranchMap NFKD_28_63_map {
    {0x29, NFKD_28_63_29}};
const static Trie NFKD_28_63(NFKD_28_63_map);
const static Trie NFKD_28_64_29(0x249F);
const static BranchMap NFKD_28_64_map {
    {0x29, NFKD_28_64_29}};
const static Trie NFKD_28_64(NFKD_28_64_map);
const static Trie NFKD_28_65_29(0x24A0);
const static BranchMap NFKD_28_65_map {
    {0x29, NFKD_28_65_29}};
const static Trie NFKD_28_65(NFKD_28_65_map);
const static Trie NFKD_28_66_29(0x24A1);
const static BranchMap NFKD_28_66_map {
    {0x29, NFKD_28_66_29}};
const static Trie NFKD_28_66(NFKD_28_66_map);
const static Trie NFKD_28_67_29(0x24A2);
const static BranchMap NFKD_28_67_map {
    {0x29, NFKD_28_67_29}};
const static Trie NFKD_28_67(NFKD_28_67_map);
const static Trie NFKD_28_68_29(0x24A3);
const static BranchMap NFKD_28_68_map {
    {0x29, NFKD_28_68_29}};
const static Trie NFKD_28_68(NFKD_28_68_map);
const static Trie NFKD_28_69_29(0x24A4);
const static BranchMap NFKD_28_69_map {
    {0x29, NFKD_28_69_29}};
const static Trie NFKD_28_69(NFKD_28_69_map);
const static Trie NFKD_28_6A_29(0x24A5);
const static BranchMap NFKD_28_6A_map {
    {0x29, NFKD_28_6A_29}};
const static Trie NFKD_28_6A(NFKD_28_6A_map);
const static Trie NFKD_28_6B_29(0x24A6);
const static BranchMap NFKD_28_6B_map {
    {0x29, NFKD_28_6B_29}};
const static Trie NFKD_28_6B(NFKD_28_6B_map);
const static Trie NFKD_28_6C_29(0x24A7);
const static BranchMap NFKD_28_6C_map {
    {0x29, NFKD_28_6C_29}};
const static Trie NFKD_28_6C(NFKD_28_6C_map);
const static Trie NFKD_28_6D_29(0x24A8);
const static BranchMap NFKD_28_6D_map {
    {0x29, NFKD_28_6D_29}};
const static Trie NFKD_28_6D(NFKD_28_6D_map);
const static Trie NFKD_28_6E_29(0x24A9);
const static BranchMap NFKD_28_6E_map {
    {0x29, NFKD_28_6E_29}};
const static Trie NFKD_28_6E(NFKD_28_6E_map);
const static Trie NFKD_28_6F_29(0x24AA);
const static BranchMap NFKD_28_6F_map {
    {0x29, NFKD_28_6F_29}};
const static Trie NFKD_28_6F(NFKD_28_6F_map);
const static Trie NFKD_28_70_29(0x24AB);
const static BranchMap NFKD_28_70_map {
    {0x29, NFKD_28_70_29}};
const static Trie NFKD_28_70(NFKD_28_70_map);
const static Trie NFKD_28_71_29(0x24AC);
const static BranchMap NFKD_28_71_map {
    {0x29, NFKD_28_71_29}};
const static Trie NFKD_28_71(NFKD_28_71_map);
const static Trie NFKD_28_72_29(0x24AD);
const static BranchMap NFKD_28_72_map {
    {0x29, NFKD_28_72_29}};
const static Trie NFKD_28_72(NFKD_28_72_map);
const static Trie NFKD_28_73_29(0x24AE);
const static BranchMap NFKD_28_73_map {
    {0x29, NFKD_28_73_29}};
const static Trie NFKD_28_73(NFKD_28_73_map);
const static Trie NFKD_28_74_29(0x24AF);
const static BranchMap NFKD_28_74_map {
    {0x29, NFKD_28_74_29}};
const static Trie NFKD_28_74(NFKD_28_74_map);
const static Trie NFKD_28_75_29(0x24B0);
const static BranchMap NFKD_28_75_map {
    {0x29, NFKD_28_75_29}};
const static Trie NFKD_28_75(NFKD_28_75_map);
const static Trie NFKD_28_76_29(0x24B1);
const static BranchMap NFKD_28_76_map {
    {0x29, NFKD_28_76_29}};
const static Trie NFKD_28_76(NFKD_28_76_map);
const static Trie NFKD_28_77_29(0x24B2);
const static BranchMap NFKD_28_77_map {
    {0x29, NFKD_28_77_29}};
const static Trie NFKD_28_77(NFKD_28_77_map);
const static Trie NFKD_28_78_29(0x24B3);
const static BranchMap NFKD_28_78_map {
    {0x29, NFKD_28_78_29}};
const static Trie NFKD_28_78(NFKD_28_78_map);
const static Trie NFKD_28_79_29(0x24B4);
const static BranchMap NFKD_28_79_map {
    {0x29, NFKD_28_79_29}};
const static Trie NFKD_28_79(NFKD_28_79_map);
const static Trie NFKD_28_7A_29(0x24B5);
const static BranchMap NFKD_28_7A_map {
    {0x29, NFKD_28_7A_29}};
const static Trie NFKD_28_7A(NFKD_28_7A_map);
const static Trie NFKD_28_1100_29(0x3200);
const static Trie NFKD_28_1100_1161_29(0x320E);
const static BranchMap NFKD_28_1100_1161_map {
    {0x29, NFKD_28_1100_1161_29}};
const static Trie NFKD_28_1100_1161(NFKD_28_1100_1161_map);
const static BranchMap NFKD_28_1100_map {
    {0x29, NFKD_28_1100_29},
    {0x1161, NFKD_28_1100_1161}};
const static Trie NFKD_28_1100(NFKD_28_1100_map);
const static Trie NFKD_28_1102_29(0x3201);
const static Trie NFKD_28_1102_1161_29(0x320F);
const static BranchMap NFKD_28_1102_1161_map {
    {0x29, NFKD_28_1102_1161_29}};
const static Trie NFKD_28_1102_1161(NFKD_28_1102_1161_map);
const static BranchMap NFKD_28_1102_map {
    {0x29, NFKD_28_1102_29},
    {0x1161, NFKD_28_1102_1161}};
const static Trie NFKD_28_1102(NFKD_28_1102_map);
const static Trie NFKD_28_1103_29(0x3202);
const static Trie NFKD_28_1103_1161_29(0x3210);
const static BranchMap NFKD_28_1103_1161_map {
    {0x29, NFKD_28_1103_1161_29}};
const static Trie NFKD_28_1103_1161(NFKD_28_1103_1161_map);
const static BranchMap NFKD_28_1103_map {
    {0x29, NFKD_28_1103_29},
    {0x1161, NFKD_28_1103_1161}};
const static Trie NFKD_28_1103(NFKD_28_1103_map);
const static Trie NFKD_28_1105_29(0x3203);
const static Trie NFKD_28_1105_1161_29(0x3211);
const static BranchMap NFKD_28_1105_1161_map {
    {0x29, NFKD_28_1105_1161_29}};
const static Trie NFKD_28_1105_1161(NFKD_28_1105_1161_map);
const static BranchMap NFKD_28_1105_map {
    {0x29, NFKD_28_1105_29},
    {0x1161, NFKD_28_1105_1161}};
const static Trie NFKD_28_1105(NFKD_28_1105_map);
const static Trie NFKD_28_1106_29(0x3204);
const static Trie NFKD_28_1106_1161_29(0x3212);
const static BranchMap NFKD_28_1106_1161_map {
    {0x29, NFKD_28_1106_1161_29}};
const static Trie NFKD_28_1106_1161(NFKD_28_1106_1161_map);
const static BranchMap NFKD_28_1106_map {
    {0x29, NFKD_28_1106_29},
    {0x1161, NFKD_28_1106_1161}};
const static Trie NFKD_28_1106(NFKD_28_1106_map);
const static Trie NFKD_28_1107_29(0x3205);
const static Trie NFKD_28_1107_1161_29(0x3213);
const static BranchMap NFKD_28_1107_1161_map {
    {0x29, NFKD_28_1107_1161_29}};
const static Trie NFKD_28_1107_1161(NFKD_28_1107_1161_map);
const static BranchMap NFKD_28_1107_map {
    {0x29, NFKD_28_1107_29},
    {0x1161, NFKD_28_1107_1161}};
const static Trie NFKD_28_1107(NFKD_28_1107_map);
const static Trie NFKD_28_1109_29(0x3206);
const static Trie NFKD_28_1109_1161_29(0x3214);
const static BranchMap NFKD_28_1109_1161_map {
    {0x29, NFKD_28_1109_1161_29}};
const static Trie NFKD_28_1109_1161(NFKD_28_1109_1161_map);
const static BranchMap NFKD_28_1109_map {
    {0x29, NFKD_28_1109_29},
    {0x1161, NFKD_28_1109_1161}};
const static Trie NFKD_28_1109(NFKD_28_1109_map);
const static Trie NFKD_28_110B_29(0x3207);
const static Trie NFKD_28_110B_1161_29(0x3215);
const static BranchMap NFKD_28_110B_1161_map {
    {0x29, NFKD_28_110B_1161_29}};
const static Trie NFKD_28_110B_1161(NFKD_28_110B_1161_map);
const static Trie NFKD_28_110B_1169_110C_1165_11AB_29(0x321D);
const static BranchMap NFKD_28_110B_1169_110C_1165_11AB_map {
    {0x29, NFKD_28_110B_1169_110C_1165_11AB_29}};
const static Trie NFKD_28_110B_1169_110C_1165_11AB(NFKD_28_110B_1169_110C_1165_11AB_map);
const static BranchMap NFKD_28_110B_1169_110C_1165_map {
    {0x11AB, NFKD_28_110B_1169_110C_1165_11AB}};
const static Trie NFKD_28_110B_1169_110C_1165(NFKD_28_110B_1169_110C_1165_map);
const static BranchMap NFKD_28_110B_1169_110C_map {
    {0x1165, NFKD_28_110B_1169_110C_1165}};
const static Trie NFKD_28_110B_1169_110C(NFKD_28_110B_1169_110C_map);
const static Trie NFKD_28_110B_1169_1112_116E_29(0x321E);
const static BranchMap NFKD_28_110B_1169_1112_116E_map {
    {0x29, NFKD_28_110B_1169_1112_116E_29}};
const static Trie NFKD_28_110B_1169_1112_116E(NFKD_28_110B_1169_1112_116E_map);
const static BranchMap NFKD_28_110B_1169_1112_map {
    {0x116E, NFKD_28_110B_1169_1112_116E}};
const static Trie NFKD_28_110B_1169_1112(NFKD_28_110B_1169_1112_map);
const static BranchMap NFKD_28_110B_1169_map {
    {0x110C, NFKD_28_110B_1169_110C},
    {0x1112, NFKD_28_110B_1169_1112}};
const static Trie NFKD_28_110B_1169(NFKD_28_110B_1169_map);
const static BranchMap NFKD_28_110B_map {
    {0x29, NFKD_28_110B_29},
    {0x1161, NFKD_28_110B_1161},
    {0x1169, NFKD_28_110B_1169}};
const static Trie NFKD_28_110B(NFKD_28_110B_map);
const static Trie NFKD_28_110C_29(0x3208);
const static Trie NFKD_28_110C_1161_29(0x3216);
const static BranchMap NFKD_28_110C_1161_map {
    {0x29, NFKD_28_110C_1161_29}};
const static Trie NFKD_28_110C_1161(NFKD_28_110C_1161_map);
const static Trie NFKD_28_110C_116E_29(0x321C);
const static BranchMap NFKD_28_110C_116E_map {
    {0x29, NFKD_28_110C_116E_29}};
const static Trie NFKD_28_110C_116E(NFKD_28_110C_116E_map);
const static BranchMap NFKD_28_110C_map {
    {0x29, NFKD_28_110C_29},
    {0x1161, NFKD_28_110C_1161},
    {0x116E, NFKD_28_110C_116E}};
const static Trie NFKD_28_110C(NFKD_28_110C_map);
const static Trie NFKD_28_110E_29(0x3209);
const static Trie NFKD_28_110E_1161_29(0x3217);
const static BranchMap NFKD_28_110E_1161_map {
    {0x29, NFKD_28_110E_1161_29}};
const static Trie NFKD_28_110E_1161(NFKD_28_110E_1161_map);
const static BranchMap NFKD_28_110E_map {
    {0x29, NFKD_28_110E_29},
    {0x1161, NFKD_28_110E_1161}};
const static Trie NFKD_28_110E(NFKD_28_110E_map);
const static Trie NFKD_28_110F_29(0x320A);
const static Trie NFKD_28_110F_1161_29(0x3218);
const static BranchMap NFKD_28_110F_1161_map {
    {0x29, NFKD_28_110F_1161_29}};
const static Trie NFKD_28_110F_1161(NFKD_28_110F_1161_map);
const static BranchMap NFKD_28_110F_map {
    {0x29, NFKD_28_110F_29},
    {0x1161, NFKD_28_110F_1161}};
const static Trie NFKD_28_110F(NFKD_28_110F_map);
const static Trie NFKD_28_1110_29(0x320B);
const static Trie NFKD_28_1110_1161_29(0x3219);
const static BranchMap NFKD_28_1110_1161_map {
    {0x29, NFKD_28_1110_1161_29}};
const static Trie NFKD_28_1110_1161(NFKD_28_1110_1161_map);
const static BranchMap NFKD_28_1110_map {
    {0x29, NFKD_28_1110_29},
    {0x1161, NFKD_28_1110_1161}};
const static Trie NFKD_28_1110(NFKD_28_1110_map);
const static Trie NFKD_28_1111_29(0x320C);
const static Trie NFKD_28_1111_1161_29(0x321A);
const static BranchMap NFKD_28_1111_1161_map {
    {0x29, NFKD_28_1111_1161_29}};
const static Trie NFKD_28_1111_1161(NFKD_28_1111_1161_map);
const static BranchMap NFKD_28_1111_map {
    {0x29, NFKD_28_1111_29},
    {0x1161, NFKD_28_1111_1161}};
const static Trie NFKD_28_1111(NFKD_28_1111_map);
const static Trie NFKD_28_1112_29(0x320D);
const static Trie NFKD_28_1112_1161_29(0x321B);
const static BranchMap NFKD_28_1112_1161_map {
    {0x29, NFKD_28_1112_1161_29}};
const static Trie NFKD_28_1112_1161(NFKD_28_1112_1161_map);
const static BranchMap NFKD_28_1112_map {
    {0x29, NFKD_28_1112_29},
    {0x1161, NFKD_28_1112_1161}};
const static Trie NFKD_28_1112(NFKD_28_1112_map);
const static Trie NFKD_28_4E00_29(0x3220);
const static BranchMap NFKD_28_4E00_map {
    {0x29, NFKD_28_4E00_29}};
const static Trie NFKD_28_4E00(NFKD_28_4E00_map);
const static Trie NFKD_28_4E03_29(0x3226);
const static BranchMap NFKD_28_4E03_map {
    {0x29, NFKD_28_4E03_29}};
const static Trie NFKD_28_4E03(NFKD_28_4E03_map);
const static Trie NFKD_28_4E09_29(0x3222);
const static BranchMap NFKD_28_4E09_map {
    {0x29, NFKD_28_4E09_29}};
const static Trie NFKD_28_4E09(NFKD_28_4E09_map);
const static Trie NFKD_28_4E5D_29(0x3228);
const static BranchMap NFKD_28_4E5D_map {
    {0x29, NFKD_28_4E5D_29}};
const static Trie NFKD_28_4E5D(NFKD_28_4E5D_map);
const static Trie NFKD_28_4E8C_29(0x3221);
const static BranchMap NFKD_28_4E8C_map {
    {0x29, NFKD_28_4E8C_29}};
const static Trie NFKD_28_4E8C(NFKD_28_4E8C_map);
const static Trie NFKD_28_4E94_29(0x3224);
const static BranchMap NFKD_28_4E94_map {
    {0x29, NFKD_28_4E94_29}};
const static Trie NFKD_28_4E94(NFKD_28_4E94_map);
const static Trie NFKD_28_4EE3_29(0x3239);
const static BranchMap NFKD_28_4EE3_map {
    {0x29, NFKD_28_4EE3_29}};
const static Trie NFKD_28_4EE3(NFKD_28_4EE3_map);
const static Trie NFKD_28_4F01_29(0x323D);
const static BranchMap NFKD_28_4F01_map {
    {0x29, NFKD_28_4F01_29}};
const static Trie NFKD_28_4F01(NFKD_28_4F01_map);
const static Trie NFKD_28_4F11_29(0x3241);
const static BranchMap NFKD_28_4F11_map {
    {0x29, NFKD_28_4F11_29}};
const static Trie NFKD_28_4F11(NFKD_28_4F11_map);
const static Trie NFKD_28_516B_29(0x3227);
const static BranchMap NFKD_28_516B_map {
    {0x29, NFKD_28_516B_29}};
const static Trie NFKD_28_516B(NFKD_28_516B_map);
const static Trie NFKD_28_516D_29(0x3225);
const static BranchMap NFKD_28_516D_map {
    {0x29, NFKD_28_516D_29}};
const static Trie NFKD_28_516D(NFKD_28_516D_map);
const static Trie NFKD_28_52B4_29(0x3238);
const static BranchMap NFKD_28_52B4_map {
    {0x29, NFKD_28_52B4_29}};
const static Trie NFKD_28_52B4(NFKD_28_52B4_map);
const static Trie NFKD_28_5341_29(0x3229);
const static BranchMap NFKD_28_5341_map {
    {0x29, NFKD_28_5341_29}};
const static Trie NFKD_28_5341(NFKD_28_5341_map);
const static Trie NFKD_28_5354_29(0x323F);
const static BranchMap NFKD_28_5354_map {
    {0x29, NFKD_28_5354_29}};
const static Trie NFKD_28_5354(NFKD_28_5354_map);
const static Trie NFKD_28_540D_29(0x3234);
const static BranchMap NFKD_28_540D_map {
    {0x29, NFKD_28_540D_29}};
const static Trie NFKD_28_540D(NFKD_28_540D_map);
const static Trie NFKD_28_547C_29(0x323A);
const static BranchMap NFKD_28_547C_map {
    {0x29, NFKD_28_547C_29}};
const static Trie NFKD_28_547C(NFKD_28_547C_map);
const static Trie NFKD_28_56DB_29(0x3223);
const static BranchMap NFKD_28_56DB_map {
    {0x29, NFKD_28_56DB_29}};
const static Trie NFKD_28_56DB(NFKD_28_56DB_map);
const static Trie NFKD_28_571F_29(0x322F);
const static BranchMap NFKD_28_571F_map {
    {0x29, NFKD_28_571F_29}};
const static Trie NFKD_28_571F(NFKD_28_571F_map);
const static Trie NFKD_28_5B66_29(0x323B);
const static BranchMap NFKD_28_5B66_map {
    {0x29, NFKD_28_5B66_29}};
const static Trie NFKD_28_5B66(NFKD_28_5B66_map);
const static Trie NFKD_28_65E5_29(0x3230);
const static BranchMap NFKD_28_65E5_map {
    {0x29, NFKD_28_65E5_29}};
const static Trie NFKD_28_65E5(NFKD_28_65E5_map);
const static Trie NFKD_28_6708_29(0x322A);
const static BranchMap NFKD_28_6708_map {
    {0x29, NFKD_28_6708_29}};
const static Trie NFKD_28_6708(NFKD_28_6708_map);
const static Trie NFKD_28_6709_29(0x3232);
const static BranchMap NFKD_28_6709_map {
    {0x29, NFKD_28_6709_29}};
const static Trie NFKD_28_6709(NFKD_28_6709_map);
const static Trie NFKD_28_6728_29(0x322D);
const static BranchMap NFKD_28_6728_map {
    {0x29, NFKD_28_6728_29}};
const static Trie NFKD_28_6728(NFKD_28_6728_map);
const static Trie NFKD_28_682A_29(0x3231);
const static BranchMap NFKD_28_682A_map {
    {0x29, NFKD_28_682A_29}};
const static Trie NFKD_28_682A(NFKD_28_682A_map);
const static Trie NFKD_28_6C34_29(0x322C);
const static BranchMap NFKD_28_6C34_map {
    {0x29, NFKD_28_6C34_29}};
const static Trie NFKD_28_6C34(NFKD_28_6C34_map);
const static Trie NFKD_28_706B_29(0x322B);
const static BranchMap NFKD_28_706B_map {
    {0x29, NFKD_28_706B_29}};
const static Trie NFKD_28_706B(NFKD_28_706B_map);
const static Trie NFKD_28_7279_29(0x3235);
const static BranchMap NFKD_28_7279_map {
    {0x29, NFKD_28_7279_29}};
const static Trie NFKD_28_7279(NFKD_28_7279_map);
const static Trie NFKD_28_76E3_29(0x323C);
const static BranchMap NFKD_28_76E3_map {
    {0x29, NFKD_28_76E3_29}};
const static Trie NFKD_28_76E3(NFKD_28_76E3_map);
const static Trie NFKD_28_793E_29(0x3233);
const static BranchMap NFKD_28_793E_map {
    {0x29, NFKD_28_793E_29}};
const static Trie NFKD_28_793E(NFKD_28_793E_map);
const static Trie NFKD_28_795D_29(0x3237);
const static BranchMap NFKD_28_795D_map {
    {0x29, NFKD_28_795D_29}};
const static Trie NFKD_28_795D(NFKD_28_795D_map);
const static Trie NFKD_28_796D_29(0x3240);
const static BranchMap NFKD_28_796D_map {
    {0x29, NFKD_28_796D_29}};
const static Trie NFKD_28_796D(NFKD_28_796D_map);
const static Trie NFKD_28_81EA_29(0x3242);
const static BranchMap NFKD_28_81EA_map {
    {0x29, NFKD_28_81EA_29}};
const static Trie NFKD_28_81EA(NFKD_28_81EA_map);
const static Trie NFKD_28_81F3_29(0x3243);
const static BranchMap NFKD_28_81F3_map {
    {0x29, NFKD_28_81F3_29}};
const static Trie NFKD_28_81F3(NFKD_28_81F3_map);
const static Trie NFKD_28_8CA1_29(0x3236);
const static BranchMap NFKD_28_8CA1_map {
    {0x29, NFKD_28_8CA1_29}};
const static Trie NFKD_28_8CA1(NFKD_28_8CA1_map);
const static Trie NFKD_28_8CC7_29(0x323E);
const static BranchMap NFKD_28_8CC7_map {
    {0x29, NFKD_28_8CC7_29}};
const static Trie NFKD_28_8CC7(NFKD_28_8CC7_map);
const static Trie NFKD_28_91D1_29(0x322E);
const static BranchMap NFKD_28_91D1_map {
    {0x29, NFKD_28_91D1_29}};
const static Trie NFKD_28_91D1(NFKD_28_91D1_map);
const static BranchMap NFKD_28_map {
    {0x31, NFKD_28_31},
    {0x32, NFKD_28_32},
    {0x33, NFKD_28_33},
    {0x34, NFKD_28_34},
    {0x35, NFKD_28_35},
    {0x36, NFKD_28_36},
    {0x37, NFKD_28_37},
    {0x38, NFKD_28_38},
    {0x39, NFKD_28_39},
    {0x41, NFKD_28_41},
    {0x42, NFKD_28_42},
    {0x43, NFKD_28_43},
    {0x44, NFKD_28_44},
    {0x45, NFKD_28_45},
    {0x46, NFKD_28_46},
    {0x47, NFKD_28_47},
    {0x48, NFKD_28_48},
    {0x49, NFKD_28_49},
    {0x4A, NFKD_28_4A},
    {0x4B, NFKD_28_4B},
    {0x4C, NFKD_28_4C},
    {0x4D, NFKD_28_4D},
    {0x4E, NFKD_28_4E},
    {0x4F, NFKD_28_4F},
    {0x50, NFKD_28_50},
    {0x51, NFKD_28_51},
    {0x52, NFKD_28_52},
    {0x53, NFKD_28_53},
    {0x54, NFKD_28_54},
    {0x55, NFKD_28_55},
    {0x56, NFKD_28_56},
    {0x57, NFKD_28_57},
    {0x58, NFKD_28_58},
    {0x59, NFKD_28_59},
    {0x5A, NFKD_28_5A},
    {0x61, NFKD_28_61},
    {0x62, NFKD_28_62},
    {0x63, NFKD_28_63},
    {0x64, NFKD_28_64},
    {0x65, NFKD_28_65},
    {0x66, NFKD_28_66},
    {0x67, NFKD_28_67},
    {0x68, NFKD_28_68},
    {0x69, NFKD_28_69},
    {0x6A, NFKD_28_6A},
    {0x6B, NFKD_28_6B},
    {0x6C, NFKD_28_6C},
    {0x6D, NFKD_28_6D},
    {0x6E, NFKD_28_6E},
    {0x6F, NFKD_28_6F},
    {0x70, NFKD_28_70},
    {0x71, NFKD_28_71},
    {0x72, NFKD_28_72},
    {0x73, NFKD_28_73},
    {0x74, NFKD_28_74},
    {0x75, NFKD_28_75},
    {0x76, NFKD_28_76},
    {0x77, NFKD_28_77},
    {0x78, NFKD_28_78},
    {0x79, NFKD_28_79},
    {0x7A, NFKD_28_7A},
    {0x1100, NFKD_28_1100},
    {0x1102, NFKD_28_1102},
    {0x1103, NFKD_28_1103},
    {0x1105, NFKD_28_1105},
    {0x1106, NFKD_28_1106},
    {0x1107, NFKD_28_1107},
    {0x1109, NFKD_28_1109},
    {0x110B, NFKD_28_110B},
    {0x110C, NFKD_28_110C},
    {0x110E, NFKD_28_110E},
    {0x110F, NFKD_28_110F},
    {0x1110, NFKD_28_1110},
    {0x1111, NFKD_28_1111},
    {0x1112, NFKD_28_1112},
    {0x4E00, NFKD_28_4E00},
    {0x4E03, NFKD_28_4E03},
    {0x4E09, NFKD_28_4E09},
    {0x4E5D, NFKD_28_4E5D},
    {0x4E8C, NFKD_28_4E8C},
    {0x4E94, NFKD_28_4E94},
    {0x4EE3, NFKD_28_4EE3},
    {0x4F01, NFKD_28_4F01},
    {0x4F11, NFKD_28_4F11},
    {0x516B, NFKD_28_516B},
    {0x516D, NFKD_28_516D},
    {0x52B4, NFKD_28_52B4},
    {0x5341, NFKD_28_5341},
    {0x5354, NFKD_28_5354},
    {0x540D, NFKD_28_540D},
    {0x547C, NFKD_28_547C},
    {0x56DB, NFKD_28_56DB},
    {0x571F, NFKD_28_571F},
    {0x5B66, NFKD_28_5B66},
    {0x65E5, NFKD_28_65E5},
    {0x6708, NFKD_28_6708},
    {0x6709, NFKD_28_6709},
    {0x6728, NFKD_28_6728},
    {0x682A, NFKD_28_682A},
    {0x6C34, NFKD_28_6C34},
    {0x706B, NFKD_28_706B},
    {0x7279, NFKD_28_7279},
    {0x76E3, NFKD_28_76E3},
    {0x793E, NFKD_28_793E},
    {0x795D, NFKD_28_795D},
    {0x796D, NFKD_28_796D},
    {0x81EA, NFKD_28_81EA},
    {0x81F3, NFKD_28_81F3},
    {0x8CA1, NFKD_28_8CA1},
    {0x8CC7, NFKD_28_8CC7},
    {0x91D1, NFKD_28_91D1}};
const static Trie NFKD_28(NFKD_28_map);
const static Trie NFKD_2E_2E_2E(0x2026);
const static BranchMap NFKD_2E_2E_map {
    {0x2E, NFKD_2E_2E_2E}};
const static Trie NFKD_2E_2E(0x2025, NFKD_2E_2E_map);
const static BranchMap NFKD_2E_map {
    {0x2E, NFKD_2E_2E}};
const static Trie NFKD_2E(NFKD_2E_map);
const static Trie NFKD_30_2C(0x1F101);
const static Trie NFKD_30_2E(0x1F100);
const static Trie NFKD_30_2044_33(0x2189);
const static BranchMap NFKD_30_2044_map {
    {0x33, NFKD_30_2044_33}};
const static Trie NFKD_30_2044(NFKD_30_2044_map);
const static Trie NFKD_30_70B9(0x3358);
const static BranchMap NFKD_30_map {
    {0x2C, NFKD_30_2C},
    {0x2E, NFKD_30_2E},
    {0x2044, NFKD_30_2044},
    {0x70B9, NFKD_30_70B9}};
const static Trie NFKD_30(NFKD_30_map);
const static Trie NFKD_31_2C(0x1F102);
const static Trie NFKD_31_2E(0x2488);
const static Trie NFKD_31_30_2E(0x2491);
const static Trie NFKD_31_30_65E5(0x33E9);
const static Trie NFKD_31_30_6708(0x32C9);
const static Trie NFKD_31_30_70B9(0x3362);
const static BranchMap NFKD_31_30_map {
    {0x2E, NFKD_31_30_2E},
    {0x65E5, NFKD_31_30_65E5},
    {0x6708, NFKD_31_30_6708},
    {0x70B9, NFKD_31_30_70B9}};
const static Trie NFKD_31_30(0x2469, NFKD_31_30_map);
const static Trie NFKD_31_31_2E(0x2492);
const static Trie NFKD_31_31_65E5(0x33EA);
const static Trie NFKD_31_31_6708(0x32CA);
const static Trie NFKD_31_31_70B9(0x3363);
const static BranchMap NFKD_31_31_map {
    {0x2E, NFKD_31_31_2E},
    {0x65E5, NFKD_31_31_65E5},
    {0x6708, NFKD_31_31_6708},
    {0x70B9, NFKD_31_31_70B9}};
const static Trie NFKD_31_31(0x246A, NFKD_31_31_map);
const static Trie NFKD_31_32_2E(0x2493);
const static Trie NFKD_31_32_65E5(0x33EB);
const static Trie NFKD_31_32_6708(0x32CB);
const static Trie NFKD_31_32_70B9(0x3364);
const static BranchMap NFKD_31_32_map {
    {0x2E, NFKD_31_32_2E},
    {0x65E5, NFKD_31_32_65E5},
    {0x6708, NFKD_31_32_6708},
    {0x70B9, NFKD_31_32_70B9}};
const static Trie NFKD_31_32(0x246B, NFKD_31_32_map);
const static Trie NFKD_31_33_2E(0x2494);
const static Trie NFKD_31_33_65E5(0x33EC);
const static Trie NFKD_31_33_70B9(0x3365);
const static BranchMap NFKD_31_33_map {
    {0x2E, NFKD_31_33_2E},
    {0x65E5, NFKD_31_33_65E5},
    {0x70B9, NFKD_31_33_70B9}};
const static Trie NFKD_31_33(0x246C, NFKD_31_33_map);
const static Trie NFKD_31_34_2E(0x2495);
const static Trie NFKD_31_34_65E5(0x33ED);
const static Trie NFKD_31_34_70B9(0x3366);
const static BranchMap NFKD_31_34_map {
    {0x2E, NFKD_31_34_2E},
    {0x65E5, NFKD_31_34_65E5},
    {0x70B9, NFKD_31_34_70B9}};
const static Trie NFKD_31_34(0x246D, NFKD_31_34_map);
const static Trie NFKD_31_35_2E(0x2496);
const static Trie NFKD_31_35_65E5(0x33EE);
const static Trie NFKD_31_35_70B9(0x3367);
const static BranchMap NFKD_31_35_map {
    {0x2E, NFKD_31_35_2E},
    {0x65E5, NFKD_31_35_65E5},
    {0x70B9, NFKD_31_35_70B9}};
const static Trie NFKD_31_35(0x246E, NFKD_31_35_map);
const static Trie NFKD_31_36_2E(0x2497);
const static Trie NFKD_31_36_65E5(0x33EF);
const static Trie NFKD_31_36_70B9(0x3368);
const static BranchMap NFKD_31_36_map {
    {0x2E, NFKD_31_36_2E},
    {0x65E5, NFKD_31_36_65E5},
    {0x70B9, NFKD_31_36_70B9}};
const static Trie NFKD_31_36(0x246F, NFKD_31_36_map);
const static Trie NFKD_31_37_2E(0x2498);
const static Trie NFKD_31_37_65E5(0x33F0);
const static Trie NFKD_31_37_70B9(0x3369);
const static BranchMap NFKD_31_37_map {
    {0x2E, NFKD_31_37_2E},
    {0x65E5, NFKD_31_37_65E5},
    {0x70B9, NFKD_31_37_70B9}};
const static Trie NFKD_31_37(0x2470, NFKD_31_37_map);
const static Trie NFKD_31_38_2E(0x2499);
const static Trie NFKD_31_38_65E5(0x33F1);
const static Trie NFKD_31_38_70B9(0x336A);
const static BranchMap NFKD_31_38_map {
    {0x2E, NFKD_31_38_2E},
    {0x65E5, NFKD_31_38_65E5},
    {0x70B9, NFKD_31_38_70B9}};
const static Trie NFKD_31_38(0x2471, NFKD_31_38_map);
const static Trie NFKD_31_39_2E(0x249A);
const static Trie NFKD_31_39_65E5(0x33F2);
const static Trie NFKD_31_39_70B9(0x336B);
const static BranchMap NFKD_31_39_map {
    {0x2E, NFKD_31_39_2E},
    {0x65E5, NFKD_31_39_65E5},
    {0x70B9, NFKD_31_39_70B9}};
const static Trie NFKD_31_39(0x2472, NFKD_31_39_map);
const static Trie NFKD_31_2044_31_30(0x2152);
const static BranchMap NFKD_31_2044_31_map {
    {0x30, NFKD_31_2044_31_30}};
const static Trie NFKD_31_2044_31(NFKD_31_2044_31_map);
const static Trie NFKD_31_2044_32(0xBD);
const static Trie NFKD_31_2044_33(0x2153);
const static Trie NFKD_31_2044_34(0xBC);
const static Trie NFKD_31_2044_35(0x2155);
const static Trie NFKD_31_2044_36(0x2159);
const static Trie NFKD_31_2044_37(0x2150);
const static Trie NFKD_31_2044_38(0x215B);
const static Trie NFKD_31_2044_39(0x2151);
const static BranchMap NFKD_31_2044_map {
    {0x31, NFKD_31_2044_31},
    {0x32, NFKD_31_2044_32},
    {0x33, NFKD_31_2044_33},
    {0x34, NFKD_31_2044_34},
    {0x35, NFKD_31_2044_35},
    {0x36, NFKD_31_2044_36},
    {0x37, NFKD_31_2044_37},
    {0x38, NFKD_31_2044_38},
    {0x39, NFKD_31_2044_39}};
const static Trie NFKD_31_2044(0x215F, NFKD_31_2044_map);
const static Trie NFKD_31_65E5(0x33E0);
const static Trie NFKD_31_6708(0x32C0);
const static Trie NFKD_31_70B9(0x3359);
const static BranchMap NFKD_31_map {
    {0x2C, NFKD_31_2C},
    {0x2E, NFKD_31_2E},
    {0x30, NFKD_31_30},
    {0x31, NFKD_31_31},
    {0x32, NFKD_31_32},
    {0x33, NFKD_31_33},
    {0x34, NFKD_31_34},
    {0x35, NFKD_31_35},
    {0x36, NFKD_31_36},
    {0x37, NFKD_31_37},
    {0x38, NFKD_31_38},
    {0x39, NFKD_31_39},
    {0x2044, NFKD_31_2044},
    {0x65E5, NFKD_31_65E5},
    {0x6708, NFKD_31_6708},
    {0x70B9, NFKD_31_70B9}};
const static Trie NFKD_31(NFKD_31_map);
const static Trie NFKD_32_2C(0x1F103);
const static Trie NFKD_32_2E(0x2489);
const static Trie NFKD_32_30_2E(0x249B);
const static Trie NFKD_32_30_65E5(0x33F3);
const static Trie NFKD_32_30_70B9(0x336C);
const static BranchMap NFKD_32_30_map {
    {0x2E, NFKD_32_30_2E},
    {0x65E5, NFKD_32_30_65E5},
    {0x70B9, NFKD_32_30_70B9}};
const static Trie NFKD_32_30(0x2473, NFKD_32_30_map);
const static Trie NFKD_32_31_65E5(0x33F4);
const static Trie NFKD_32_31_70B9(0x336D);
const static BranchMap NFKD_32_31_map {
    {0x65E5, NFKD_32_31_65E5},
    {0x70B9, NFKD_32_31_70B9}};
const static Trie NFKD_32_31(0x3251, NFKD_32_31_map);
const static Trie NFKD_32_32_65E5(0x33F5);
const static Trie NFKD_32_32_70B9(0x336E);
const static BranchMap NFKD_32_32_map {
    {0x65E5, NFKD_32_32_65E5},
    {0x70B9, NFKD_32_32_70B9}};
const static Trie NFKD_32_32(0x3252, NFKD_32_32_map);
const static Trie NFKD_32_33_65E5(0x33F6);
const static Trie NFKD_32_33_70B9(0x336F);
const static BranchMap NFKD_32_33_map {
    {0x65E5, NFKD_32_33_65E5},
    {0x70B9, NFKD_32_33_70B9}};
const static Trie NFKD_32_33(0x3253, NFKD_32_33_map);
const static Trie NFKD_32_34_65E5(0x33F7);
const static Trie NFKD_32_34_70B9(0x3370);
const static BranchMap NFKD_32_34_map {
    {0x65E5, NFKD_32_34_65E5},
    {0x70B9, NFKD_32_34_70B9}};
const static Trie NFKD_32_34(0x3254, NFKD_32_34_map);
const static Trie NFKD_32_35_65E5(0x33F8);
const static BranchMap NFKD_32_35_map {
    {0x65E5, NFKD_32_35_65E5}};
const static Trie NFKD_32_35(0x3255, NFKD_32_35_map);
const static Trie NFKD_32_36_65E5(0x33F9);
const static BranchMap NFKD_32_36_map {
    {0x65E5, NFKD_32_36_65E5}};
const static Trie NFKD_32_36(0x3256, NFKD_32_36_map);
const static Trie NFKD_32_37_65E5(0x33FA);
const static BranchMap NFKD_32_37_map {
    {0x65E5, NFKD_32_37_65E5}};
const static Trie NFKD_32_37(0x3257, NFKD_32_37_map);
const static Trie NFKD_32_38_65E5(0x33FB);
const static BranchMap NFKD_32_38_map {
    {0x65E5, NFKD_32_38_65E5}};
const static Trie NFKD_32_38(0x3258, NFKD_32_38_map);
const static Trie NFKD_32_39_65E5(0x33FC);
const static BranchMap NFKD_32_39_map {
    {0x65E5, NFKD_32_39_65E5}};
const static Trie NFKD_32_39(0x3259, NFKD_32_39_map);
const static Trie NFKD_32_2044_33(0x2154);
const static Trie NFKD_32_2044_35(0x2156);
const static BranchMap NFKD_32_2044_map {
    {0x33, NFKD_32_2044_33},
    {0x35, NFKD_32_2044_35}};
const static Trie NFKD_32_2044(NFKD_32_2044_map);
const static Trie NFKD_32_65E5(0x33E1);
const static Trie NFKD_32_6708(0x32C1);
const static Trie NFKD_32_70B9(0x335A);
const static BranchMap NFKD_32_map {
    {0x2C, NFKD_32_2C},
    {0x2E, NFKD_32_2E},
    {0x30, NFKD_32_30},
    {0x31, NFKD_32_31},
    {0x32, NFKD_32_32},
    {0x33, NFKD_32_33},
    {0x34, NFKD_32_34},
    {0x35, NFKD_32_35},
    {0x36, NFKD_32_36},
    {0x37, NFKD_32_37},
    {0x38, NFKD_32_38},
    {0x39, NFKD_32_39},
    {0x2044, NFKD_32_2044},
    {0x65E5, NFKD_32_65E5},
    {0x6708, NFKD_32_6708},
    {0x70B9, NFKD_32_70B9}};
const static Trie NFKD_32(NFKD_32_map);
const static Trie NFKD_33_2C(0x1F104);
const static Trie NFKD_33_2E(0x248A);
const static Trie NFKD_33_30_65E5(0x33FD);
const static BranchMap NFKD_33_30_map {
    {0x65E5, NFKD_33_30_65E5}};
const static Trie NFKD_33_30(0x325A, NFKD_33_30_map);
const static Trie NFKD_33_31_65E5(0x33FE);
const static BranchMap NFKD_33_31_map {
    {0x65E5, NFKD_33_31_65E5}};
const static Trie NFKD_33_31(0x325B, NFKD_33_31_map);
const static Trie NFKD_33_32(0x325C);
const static Trie NFKD_33_33(0x325D);
const static Trie NFKD_33_34(0x325E);
const static Trie NFKD_33_35(0x325F);
const static Trie NFKD_33_36(0x32B1);
const static Trie NFKD_33_37(0x32B2);
const static Trie NFKD_33_38(0x32B3);
const static Trie NFKD_33_39(0x32B4);
const static Trie NFKD_33_2044_34(0xBE);
const static Trie NFKD_33_2044_35(0x2157);
const static Trie NFKD_33_2044_38(0x215C);
const static BranchMap NFKD_33_2044_map {
    {0x34, NFKD_33_2044_34},
    {0x35, NFKD_33_2044_35},
    {0x38, NFKD_33_2044_38}};
const static Trie NFKD_33_2044(NFKD_33_2044_map);
const static Trie NFKD_33_65E5(0x33E2);
const static Trie NFKD_33_6708(0x32C2);
const static Trie NFKD_33_70B9(0x335B);
const static BranchMap NFKD_33_map {
    {0x2C, NFKD_33_2C},
    {0x2E, NFKD_33_2E},
    {0x30, NFKD_33_30},
    {0x31, NFKD_33_31},
    {0x32, NFKD_33_32},
    {0x33, NFKD_33_33},
    {0x34, NFKD_33_34},
    {0x35, NFKD_33_35},
    {0x36, NFKD_33_36},
    {0x37, NFKD_33_37},
    {0x38, NFKD_33_38},
    {0x39, NFKD_33_39},
    {0x2044, NFKD_33_2044},
    {0x65E5, NFKD_33_65E5},
    {0x6708, NFKD_33_6708},
    {0x70B9, NFKD_33_70B9}};
const static Trie NFKD_33(NFKD_33_map);
const static Trie NFKD_34_2C(0x1F105);
const static Trie NFKD_34_2E(0x248B);
const static Trie NFKD_34_30(0x32B5);
const static Trie NFKD_34_31(0x32B6);
const static Trie NFKD_34_32(0x32B7);
const static Trie NFKD_34_33(0x32B8);
const static Trie NFKD_34_34(0x32B9);
const static Trie NFKD_34_35(0x32BA);
const static Trie NFKD_34_36(0x32BB);
const static Trie NFKD_34_37(0x32BC);
const static Trie NFKD_34_38(0x32BD);
const static Trie NFKD_34_39(0x32BE);
const static Trie NFKD_34_2044_35(0x2158);
const static BranchMap NFKD_34_2044_map {
    {0x35, NFKD_34_2044_35}};
const static Trie NFKD_34_2044(NFKD_34_2044_map);
const static Trie NFKD_34_65E5(0x33E3);
const static Trie NFKD_34_6708(0x32C3);
const static Trie NFKD_34_70B9(0x335C);
const static BranchMap NFKD_34_map {
    {0x2C, NFKD_34_2C},
    {0x2E, NFKD_34_2E},
    {0x30, NFKD_34_30},
    {0x31, NFKD_34_31},
    {0x32, NFKD_34_32},
    {0x33, NFKD_34_33},
    {0x34, NFKD_34_34},
    {0x35, NFKD_34_35},
    {0x36, NFKD_34_36},
    {0x37, NFKD_34_37},
    {0x38, NFKD_34_38},
    {0x39, NFKD_34_39},
    {0x2044, NFKD_34_2044},
    {0x65E5, NFKD_34_65E5},
    {0x6708, NFKD_34_6708},
    {0x70B9, NFKD_34_70B9}};
const static Trie NFKD_34(NFKD_34_map);
const static Trie NFKD_35_2C(0x1F106);
const static Trie NFKD_35_2E(0x248C);
const static Trie NFKD_35_30(0x32BF);
const static Trie NFKD_35_2044_36(0x215A);
const static Trie NFKD_35_2044_38(0x215D);
const static BranchMap NFKD_35_2044_map {
    {0x36, NFKD_35_2044_36},
    {0x38, NFKD_35_2044_38}};
const static Trie NFKD_35_2044(NFKD_35_2044_map);
const static Trie NFKD_35_65E5(0x33E4);
const static Trie NFKD_35_6708(0x32C4);
const static Trie NFKD_35_70B9(0x335D);
const static BranchMap NFKD_35_map {
    {0x2C, NFKD_35_2C},
    {0x2E, NFKD_35_2E},
    {0x30, NFKD_35_30},
    {0x2044, NFKD_35_2044},
    {0x65E5, NFKD_35_65E5},
    {0x6708, NFKD_35_6708},
    {0x70B9, NFKD_35_70B9}};
const static Trie NFKD_35(NFKD_35_map);
const static Trie NFKD_36_2C(0x1F107);
const static Trie NFKD_36_2E(0x248D);
const static Trie NFKD_36_65E5(0x33E5);
const static Trie NFKD_36_6708(0x32C5);
const static Trie NFKD_36_70B9(0x335E);
const static BranchMap NFKD_36_map {
    {0x2C, NFKD_36_2C},
    {0x2E, NFKD_36_2E},
    {0x65E5, NFKD_36_65E5},
    {0x6708, NFKD_36_6708},
    {0x70B9, NFKD_36_70B9}};
const static Trie NFKD_36(NFKD_36_map);
const static Trie NFKD_37_2C(0x1F108);
const static Trie NFKD_37_2E(0x248E);
const static Trie NFKD_37_2044_38(0x215E);
const static BranchMap NFKD_37_2044_map {
    {0x38, NFKD_37_2044_38}};
const static Trie NFKD_37_2044(NFKD_37_2044_map);
const static Trie NFKD_37_65E5(0x33E6);
const static Trie NFKD_37_6708(0x32C6);
const static Trie NFKD_37_70B9(0x335F);
const static BranchMap NFKD_37_map {
    {0x2C, NFKD_37_2C},
    {0x2E, NFKD_37_2E},
    {0x2044, NFKD_37_2044},
    {0x65E5, NFKD_37_65E5},
    {0x6708, NFKD_37_6708},
    {0x70B9, NFKD_37_70B9}};
const static Trie NFKD_37(NFKD_37_map);
const static Trie NFKD_38_2C(0x1F109);
const static Trie NFKD_38_2E(0x248F);
const static Trie NFKD_38_65E5(0x33E7);
const static Trie NFKD_38_6708(0x32C7);
const static Trie NFKD_38_70B9(0x3360);
const static BranchMap NFKD_38_map {
    {0x2C, NFKD_38_2C},
    {0x2E, NFKD_38_2E},
    {0x65E5, NFKD_38_65E5},
    {0x6708, NFKD_38_6708},
    {0x70B9, NFKD_38_70B9}};
const static Trie NFKD_38(NFKD_38_map);
const static Trie NFKD_39_2C(0x1F10A);
const static Trie NFKD_39_2E(0x2490);
const static Trie NFKD_39_65E5(0x33E8);
const static Trie NFKD_39_6708(0x32C8);
const static Trie NFKD_39_70B9(0x3361);
const static BranchMap NFKD_39_map {
    {0x2C, NFKD_39_2C},
    {0x2E, NFKD_39_2E},
    {0x65E5, NFKD_39_65E5},
    {0x6708, NFKD_39_6708},
    {0x70B9, NFKD_39_70B9}};
const static Trie NFKD_39(NFKD_39_map);
const static Trie NFKD_3A_3A_3D(0x2A74);
const static BranchMap NFKD_3A_3A_map {
    {0x3D, NFKD_3A_3A_3D}};
const static Trie NFKD_3A_3A(NFKD_3A_3A_map);
const static BranchMap NFKD_3A_map {
    {0x3A, NFKD_3A_3A}};
const static Trie NFKD_3A(NFKD_3A_map);
const static Trie NFKD_3D_3D_3D(0x2A76);
const static BranchMap NFKD_3D_3D_map {
    {0x3D, NFKD_3D_3D_3D}};
const static Trie NFKD_3D_3D(0x2A75, NFKD_3D_3D_map);
const static BranchMap NFKD_3D_map {
    {0x3D, NFKD_3D_3D}};
const static Trie NFKD_3D(NFKD_3D_map);
const static Trie NFKD_3F_21(0x2048);
const static Trie NFKD_3F_3F(0x2047);
const static BranchMap NFKD_3F_map {
    {0x21, NFKD_3F_21},
    {0x3F, NFKD_3F_3F}};
const static Trie NFKD_3F(NFKD_3F_map);
const static Trie NFKD_41_55(0x3373);
const static Trie NFKD_41_2215_6D(0x33DF);
const static BranchMap NFKD_41_2215_map {
    {0x6D, NFKD_41_2215_6D}};
const static Trie NFKD_41_2215(NFKD_41_2215_map);
const static BranchMap NFKD_41_map {
    {0x55, NFKD_41_55},
    {0x2215, NFKD_41_2215}};
const static Trie NFKD_41(NFKD_41_map);
const static Trie NFKD_42_71(0x33C3);
const static BranchMap NFKD_42_map {
    {0x71, NFKD_42_71}};
const static Trie NFKD_42(NFKD_42_map);
const static Trie NFKD_43_44(0x1F12D);
const static Trie NFKD_43_6F_2E(0x33C7);
const static BranchMap NFKD_43_6F_map {
    {0x2E, NFKD_43_6F_2E}};
const static Trie NFKD_43_6F(NFKD_43_6F_map);
const static Trie NFKD_43_2215_6B_67(0x33C6);
const static BranchMap NFKD_43_2215_6B_map {
    {0x67, NFKD_43_2215_6B_67}};
const static Trie NFKD_43_2215_6B(NFKD_43_2215_6B_map);
const static BranchMap NFKD_43_2215_map {
    {0x6B, NFKD_43_2215_6B}};
const static Trie NFKD_43_2215(NFKD_43_2215_map);
const static BranchMap NFKD_43_map {
    {0x44, NFKD_43_44},
    {0x6F, NFKD_43_6F},
    {0x2215, NFKD_43_2215}};
const static Trie NFKD_43(NFKD_43_map);
const static Trie NFKD_44_4A(0x1F190);
const static Trie NFKD_44_5A_30C(0x1C4);
const static BranchMap NFKD_44_5A_map {
    {0x30C, NFKD_44_5A_30C}};
const static Trie NFKD_44_5A(0x1F1, NFKD_44_5A_map);
const static Trie NFKD_44_7A_30C(0x1C5);
const static BranchMap NFKD_44_7A_map {
    {0x30C, NFKD_44_7A_30C}};
const static Trie NFKD_44_7A(0x1F2, NFKD_44_7A_map);
const static BranchMap NFKD_44_map {
    {0x4A, NFKD_44_4A},
    {0x5A, NFKD_44_5A},
    {0x7A, NFKD_44_7A}};
const static Trie NFKD_44(NFKD_44_map);
const static Trie NFKD_46_41_58(0x213B);
const static BranchMap NFKD_46_41_map {
    {0x58, NFKD_46_41_58}};
const static Trie NFKD_46_41(NFKD_46_41_map);
const static BranchMap NFKD_46_map {
    {0x41, NFKD_46_41}};
const static Trie NFKD_46(NFKD_46_map);
const static Trie NFKD_47_42(0x3387);
const static Trie NFKD_47_48_7A(0x3393);
const static BranchMap NFKD_47_48_map {
    {0x7A, NFKD_47_48_7A}};
const static Trie NFKD_47_48(NFKD_47_48_map);
const static Trie NFKD_47_50_61(0x33AC);
const static BranchMap NFKD_47_50_map {
    {0x61, NFKD_47_50_61}};
const static Trie NFKD_47_50(NFKD_47_50_map);
const static Trie NFKD_47_79(0x33C9);
const static BranchMap NFKD_47_map {
    {0x42, NFKD_47_42},
    {0x48, NFKD_47_48},
    {0x50, NFKD_47_50},
    {0x79, NFKD_47_79}};
const static Trie NFKD_47(NFKD_47_map);
const static Trie NFKD_48_50(0x33CB);
const static Trie NFKD_48_56(0x1F14A);
const static Trie NFKD_48_67(0x32CC);
const static Trie NFKD_48_7A(0x3390);
const static BranchMap NFKD_48_map {
    {0x50, NFKD_48_50},
    {0x56, NFKD_48_56},
    {0x67, NFKD_48_67},
    {0x7A, NFKD_48_7A}};
const static Trie NFKD_48(NFKD_48_map);
const static Trie NFKD_49_49_49(0x2162);
const static BranchMap NFKD_49_49_map {
    {0x49, NFKD_49_49_49}};
const static Trie NFKD_49_49(0x2161, NFKD_49_49_map);
const static Trie NFKD_49_4A(0x132);
const static Trie NFKD_49_55(0x337A);
const static Trie NFKD_49_56(0x2163);
const static Trie NFKD_49_58(0x2168);
const static BranchMap NFKD_49_map {
    {0x49, NFKD_49_49},
    {0x4A, NFKD_49_4A},
    {0x55, NFKD_49_55},
    {0x56, NFKD_49_56},
    {0x58, NFKD_49_58}};
const static Trie NFKD_49(NFKD_49_map);
const static Trie NFKD_4B_42(0x3385);
const static Trie NFKD_4B_4B(0x33CD);
const static Trie NFKD_4B_4D(0x33CE);
const static BranchMap NFKD_4B_map {
    {0x42, NFKD_4B_42},
    {0x4B, NFKD_4B_4B},
    {0x4D, NFKD_4B_4D}};
const static Trie NFKD_4B(NFKD_4B_map);
const static Trie NFKD_4C_4A(0x1C7);
const static Trie NFKD_4C_54_44(0x32CF);
const static BranchMap NFKD_4C_54_map {
    {0x44, NFKD_4C_54_44}};
const static Trie NFKD_4C_54(NFKD_4C_54_map);
const static Trie NFKD_4C_6A(0x1C8);
const static Trie NFKD_4C_B7(0x13F);
const static BranchMap NFKD_4C_map {
    {0x4A, NFKD_4C_4A},
    {0x54, NFKD_4C_54},
    {0x6A, NFKD_4C_6A},
    {0xB7, NFKD_4C_B7}};
const static Trie NFKD_4C(NFKD_4C_map);
const static Trie NFKD_4D_42(0x3386);
const static Trie NFKD_4D_43(0x1F16A);
const static Trie NFKD_4D_44(0x1F16B);
const static Trie NFKD_4D_48_7A(0x3392);
const static BranchMap NFKD_4D_48_map {
    {0x7A, NFKD_4D_48_7A}};
const static Trie NFKD_4D_48(NFKD_4D_48_map);
const static Trie NFKD_4D_50_61(0x33AB);
const static BranchMap NFKD_4D_50_map {
    {0x61, NFKD_4D_50_61}};
const static Trie NFKD_4D_50(NFKD_4D_50_map);
const static Trie NFKD_4D_56(0x33B9);
const static Trie NFKD_4D_57(0x33BF);
const static Trie NFKD_4D_3A9(0x33C1);
const static BranchMap NFKD_4D_map {
    {0x42, NFKD_4D_42},
    {0x43, NFKD_4D_43},
    {0x44, NFKD_4D_44},
    {0x48, NFKD_4D_48},
    {0x50, NFKD_4D_50},
    {0x56, NFKD_4D_56},
    {0x57, NFKD_4D_57},
    {0x3A9, NFKD_4D_3A9}};
const static Trie NFKD_4D(NFKD_4D_map);
const static Trie NFKD_4E_4A(0x1CA);
const static Trie NFKD_4E_6A(0x1CB);
const static Trie NFKD_4E_6F(0x2116);
const static BranchMap NFKD_4E_map {
    {0x4A, NFKD_4E_4A},
    {0x6A, NFKD_4E_6A},
    {0x6F, NFKD_4E_6F}};
const static Trie NFKD_4E(NFKD_4E_map);
const static Trie NFKD_50_48(0x33D7);
const static Trie NFKD_50_50_4D(0x33D9);
const static Trie NFKD_50_50_56(0x1F14E);
const static BranchMap NFKD_50_50_map {
    {0x4D, NFKD_50_50_4D},
    {0x56, NFKD_50_50_56}};
const static Trie NFKD_50_50(NFKD_50_50_map);
const static Trie NFKD_50_52(0x33DA);
const static Trie NFKD_50_54_45(0x3250);
const static BranchMap NFKD_50_54_map {
    {0x45, NFKD_50_54_45}};
const static Trie NFKD_50_54(NFKD_50_54_map);
const static Trie NFKD_50_61(0x33A9);
const static BranchMap NFKD_50_map {
    {0x48, NFKD_50_48},
    {0x50, NFKD_50_50},
    {0x52, NFKD_50_52},
    {0x54, NFKD_50_54},
    {0x61, NFKD_50_61}};
const static Trie NFKD_50(NFKD_50_map);
const static Trie NFKD_52_73(0x20A8);
const static BranchMap NFKD_52_map {
    {0x73, NFKD_52_73}};
const static Trie NFKD_52(NFKD_52_map);
const static Trie NFKD_53_44(0x1F14C);
const static Trie NFKD_53_4D(0x2120);
const static Trie NFKD_53_53(0x1F14D);
const static Trie NFKD_53_76(0x33DC);
const static BranchMap NFKD_53_map {
    {0x44, NFKD_53_44},
    {0x4D, NFKD_53_4D},
    {0x53, NFKD_53_53},
    {0x76, NFKD_53_76}};
const static Trie NFKD_53(NFKD_53_map);
const static Trie NFKD_54_45_4C(0x2121);
const static BranchMap NFKD_54_45_map {
    {0x4C, NFKD_54_45_4C}};
const static Trie NFKD_54_45(NFKD_54_45_map);
const static Trie NFKD_54_48_7A(0x3394);
const static BranchMap NFKD_54_48_map {
    {0x7A, NFKD_54_48_7A}};
const static Trie NFKD_54_48(NFKD_54_48_map);
const static Trie NFKD_54_4D(0x2122);
const static BranchMap NFKD_54_map {
    {0x45, NFKD_54_45},
    {0x48, NFKD_54_48},
    {0x4D, NFKD_54_4D}};
const static Trie NFKD_54(NFKD_54_map);
const static Trie NFKD_56_49_49_49(0x2167);
const static BranchMap NFKD_56_49_49_map {
    {0x49, NFKD_56_49_49_49}};
const static Trie NFKD_56_49_49(0x2166, NFKD_56_49_49_map);
const static BranchMap NFKD_56_49_map {
    {0x49, NFKD_56_49_49}};
const static Trie NFKD_56_49(0x2165, NFKD_56_49_map);
const static Trie NFKD_56_2215_6D(0x33DE);
const static BranchMap NFKD_56_2215_map {
    {0x6D, NFKD_56_2215_6D}};
const static Trie NFKD_56_2215(NFKD_56_2215_map);
const static BranchMap NFKD_56_map {
    {0x49, NFKD_56_49},
    {0x2215, NFKD_56_2215}};
const static Trie NFKD_56(NFKD_56_map);
const static Trie NFKD_57_43(0x1F14F);
const static Trie NFKD_57_5A(0x1F12E);
const static Trie NFKD_57_62(0x33DD);
const static BranchMap NFKD_57_map {
    {0x43, NFKD_57_43},
    {0x5A, NFKD_57_5A},
    {0x62, NFKD_57_62}};
const static Trie NFKD_57(NFKD_57_map);
const static Trie NFKD_58_49_49(0x216B);
const static BranchMap NFKD_58_49_map {
    {0x49, NFKD_58_49_49}};
const static Trie NFKD_58_49(0x216A, NFKD_58_49_map);
const static BranchMap NFKD_58_map {
    {0x49, NFKD_58_49}};
const static Trie NFKD_58(NFKD_58_map);
const static Trie NFKD_61_2E_6D_2E(0x33C2);
const static BranchMap NFKD_61_2E_6D_map {
    {0x2E, NFKD_61_2E_6D_2E}};
const static Trie NFKD_61_2E_6D(NFKD_61_2E_6D_map);
const static BranchMap NFKD_61_2E_map {
    {0x6D, NFKD_61_2E_6D}};
const static Trie NFKD_61_2E(NFKD_61_2E_map);
const static Trie NFKD_61_2F_63(0x2100);
const static Trie NFKD_61_2F_73(0x2101);
const static BranchMap NFKD_61_2F_map {
    {0x63, NFKD_61_2F_63},
    {0x73, NFKD_61_2F_73}};
const static Trie NFKD_61_2F(NFKD_61_2F_map);
const static Trie NFKD_61_2BE(0x1E9A);
const static BranchMap NFKD_61_map {
    {0x2E, NFKD_61_2E},
    {0x2F, NFKD_61_2F},
    {0x2BE, NFKD_61_2BE}};
const static Trie NFKD_61(NFKD_61_map);
const static Trie NFKD_62_61_72(0x3374);
const static BranchMap NFKD_62_61_map {
    {0x72, NFKD_62_61_72}};
const static Trie NFKD_62_61(NFKD_62_61_map);
const static BranchMap NFKD_62_map {
    {0x61, NFKD_62_61}};
const static Trie NFKD_62(NFKD_62_map);
const static Trie NFKD_63_2F_6F(0x2105);
const static Trie NFKD_63_2F_75(0x2106);
const static BranchMap NFKD_63_2F_map {
    {0x6F, NFKD_63_2F_6F},
    {0x75, NFKD_63_2F_75}};
const static Trie NFKD_63_2F(NFKD_63_2F_map);
const static Trie NFKD_63_61_6C(0x3388);
const static BranchMap NFKD_63_61_map {
    {0x6C, NFKD_63_61_6C}};
const static Trie NFKD_63_61(NFKD_63_61_map);
const static Trie NFKD_63_63(0x33C4);
const static Trie NFKD_63_64(0x33C5);
const static Trie NFKD_63_6D_32(0x33A0);
const static Trie NFKD_63_6D_33(0x33A4);
const static BranchMap NFKD_63_6D_map {
    {0x32, NFKD_63_6D_32},
    {0x33, NFKD_63_6D_33}};
const static Trie NFKD_63_6D(0x339D, NFKD_63_6D_map);
const static BranchMap NFKD_63_map {
    {0x2F, NFKD_63_2F},
    {0x61, NFKD_63_61},
    {0x63, NFKD_63_63},
    {0x64, NFKD_63_64},
    {0x6D, NFKD_63_6D}};
const static Trie NFKD_63(NFKD_63_map);
const static Trie NFKD_64_42(0x33C8);
const static Trie NFKD_64_61(0x3372);
const static Trie NFKD_64_6C(0x3397);
const static Trie NFKD_64_6D_32(0x3378);
const static Trie NFKD_64_6D_33(0x3379);
const static BranchMap NFKD_64_6D_map {
    {0x32, NFKD_64_6D_32},
    {0x33, NFKD_64_6D_33}};
const static Trie NFKD_64_6D(0x3377, NFKD_64_6D_map);
const static Trie NFKD_64_7A_30C(0x1C6);
const static BranchMap NFKD_64_7A_map {
    {0x30C, NFKD_64_7A_30C}};
const static Trie NFKD_64_7A(0x1F3, NFKD_64_7A_map);
const static BranchMap NFKD_64_map {
    {0x42, NFKD_64_42},
    {0x61, NFKD_64_61},
    {0x6C, NFKD_64_6C},
    {0x6D, NFKD_64_6D},
    {0x7A, NFKD_64_7A}};
const static Trie NFKD_64(NFKD_64_map);
const static Trie NFKD_65_56(0x32CE);
const static Trie NFKD_65_72_67(0x32CD);
const static BranchMap NFKD_65_72_map {
    {0x67, NFKD_65_72_67}};
const static Trie NFKD_65_72(NFKD_65_72_map);
const static BranchMap NFKD_65_map {
    {0x56, NFKD_65_56},
    {0x72, NFKD_65_72}};
const static Trie NFKD_65(NFKD_65_map);
const static Trie NFKD_66_66_69(0xFB03);
const static Trie NFKD_66_66_6C(0xFB04);
const static BranchMap NFKD_66_66_map {
    {0x69, NFKD_66_66_69},
    {0x6C, NFKD_66_66_6C}};
const static Trie NFKD_66_66(0xFB00, NFKD_66_66_map);
const static Trie NFKD_66_69(0xFB01);
const static Trie NFKD_66_6C(0xFB02);
const static Trie NFKD_66_6D(0x3399);
const static BranchMap NFKD_66_map {
    {0x66, NFKD_66_66},
    {0x69, NFKD_66_69},
    {0x6C, NFKD_66_6C},
    {0x6D, NFKD_66_6D}};
const static Trie NFKD_66(NFKD_66_map);
const static Trie NFKD_67_61_6C(0x33FF);
const static BranchMap NFKD_67_61_map {
    {0x6C, NFKD_67_61_6C}};
const static Trie NFKD_67_61(NFKD_67_61_map);
const static BranchMap NFKD_67_map {
    {0x61, NFKD_67_61}};
const static Trie NFKD_67(NFKD_67_map);
const static Trie NFKD_68_50_61(0x3371);
const static BranchMap NFKD_68_50_map {
    {0x61, NFKD_68_50_61}};
const static Trie NFKD_68_50(NFKD_68_50_map);
const static Trie NFKD_68_61(0x33CA);
const static BranchMap NFKD_68_map {
    {0x50, NFKD_68_50},
    {0x61, NFKD_68_61}};
const static Trie NFKD_68(NFKD_68_map);
const static Trie NFKD_69_69_69(0x2172);
const static BranchMap NFKD_69_69_map {
    {0x69, NFKD_69_69_69}};
const static Trie NFKD_69_69(0x2171, NFKD_69_69_map);
const static Trie NFKD_69_6A(0x133);
const static Trie NFKD_69_6E(0x33CC);
const static Trie NFKD_69_76(0x2173);
const static Trie NFKD_69_78(0x2178);
const static BranchMap NFKD_69_map {
    {0x69, NFKD_69_69},
    {0x6A, NFKD_69_6A},
    {0x6E, NFKD_69_6E},
    {0x76, NFKD_69_76},
    {0x78, NFKD_69_78}};
const static Trie NFKD_69(NFKD_69_map);
const static Trie NFKD_6B_41(0x3384);
const static Trie NFKD_6B_48_7A(0x3391);
const static BranchMap NFKD_6B_48_map {
    {0x7A, NFKD_6B_48_7A}};
const static Trie NFKD_6B_48(NFKD_6B_48_map);
const static Trie NFKD_6B_50_61(0x33AA);
const static BranchMap NFKD_6B_50_map {
    {0x61, NFKD_6B_50_61}};
const static Trie NFKD_6B_50(NFKD_6B_50_map);
const static Trie NFKD_6B_56(0x33B8);
const static Trie NFKD_6B_57(0x33BE);
const static Trie NFKD_6B_63_61_6C(0x3389);
const static BranchMap NFKD_6B_63_61_map {
    {0x6C, NFKD_6B_63_61_6C}};
const static Trie NFKD_6B_63_61(NFKD_6B_63_61_map);
const static BranchMap NFKD_6B_63_map {
    {0x61, NFKD_6B_63_61}};
const static Trie NFKD_6B_63(NFKD_6B_63_map);
const static Trie NFKD_6B_67(0x338F);
const static Trie NFKD_6B_6C(0x3398);
const static Trie NFKD_6B_6D_32(0x33A2);
const static Trie NFKD_6B_6D_33(0x33A6);
const static BranchMap NFKD_6B_6D_map {
    {0x32, NFKD_6B_6D_32},
    {0x33, NFKD_6B_6D_33}};
const static Trie NFKD_6B_6D(0x339E, NFKD_6B_6D_map);
const static Trie NFKD_6B_74(0x33CF);
const static Trie NFKD_6B_3A9(0x33C0);
const static BranchMap NFKD_6B_map {
    {0x41, NFKD_6B_41},
    {0x48, NFKD_6B_48},
    {0x50, NFKD_6B_50},
    {0x56, NFKD_6B_56},
    {0x57, NFKD_6B_57},
    {0x63, NFKD_6B_63},
    {0x67, NFKD_6B_67},
    {0x6C, NFKD_6B_6C},
    {0x6D, NFKD_6B_6D},
    {0x74, NFKD_6B_74},
    {0x3A9, NFKD_6B_3A9}};
const static Trie NFKD_6B(NFKD_6B_map);
const static Trie NFKD_6C_6A(0x1C9);
const static Trie NFKD_6C_6D(0x33D0);
const static Trie NFKD_6C_6E(0x33D1);
const static Trie NFKD_6C_6F_67(0x33D2);
const static BranchMap NFKD_6C_6F_map {
    {0x67, NFKD_6C_6F_67}};
const static Trie NFKD_6C_6F(NFKD_6C_6F_map);
const static Trie NFKD_6C_78(0x33D3);
const static Trie NFKD_6C_B7(0x140);
const static BranchMap NFKD_6C_map {
    {0x6A, NFKD_6C_6A},
    {0x6D, NFKD_6C_6D},
    {0x6E, NFKD_6C_6E},
    {0x6F, NFKD_6C_6F},
    {0x78, NFKD_6C_78},
    {0xB7, NFKD_6C_B7}};
const static Trie NFKD_6C(NFKD_6C_map);
const static Trie NFKD_6D_32(0x33A1);
const static Trie NFKD_6D_33(0x33A5);
const static Trie NFKD_6D_41(0x3383);
const static Trie NFKD_6D_56(0x33B7);
const static Trie NFKD_6D_57(0x33BD);
const static Trie NFKD_6D_62(0x33D4);
const static Trie NFKD_6D_67(0x338E);
const static Trie NFKD_6D_69_6C(0x33D5);
const static BranchMap NFKD_6D_69_map {
    {0x6C, NFKD_6D_69_6C}};
const static Trie NFKD_6D_69(NFKD_6D_69_map);
const static Trie NFKD_6D_6C(0x3396);
const static Trie NFKD_6D_6D_32(0x339F);
const static Trie NFKD_6D_6D_33(0x33A3);
const static BranchMap NFKD_6D_6D_map {
    {0x32, NFKD_6D_6D_32},
    {0x33, NFKD_6D_6D_33}};
const static Trie NFKD_6D_6D(0x339C, NFKD_6D_6D_map);
const static Trie NFKD_6D_6F_6C(0x33D6);
const static BranchMap NFKD_6D_6F_map {
    {0x6C, NFKD_6D_6F_6C}};
const static Trie NFKD_6D_6F(NFKD_6D_6F_map);
const static Trie NFKD_6D_73(0x33B3);
const static Trie NFKD_6D_2215_73_32(0x33A8);
const static BranchMap NFKD_6D_2215_73_map {
    {0x32, NFKD_6D_2215_73_32}};
const static Trie NFKD_6D_2215_73(0x33A7, NFKD_6D_2215_73_map);
const static BranchMap NFKD_6D_2215_map {
    {0x73, NFKD_6D_2215_73}};
const static Trie NFKD_6D_2215(NFKD_6D_2215_map);
const static BranchMap NFKD_6D_map {
    {0x32, NFKD_6D_32},
    {0x33, NFKD_6D_33},
    {0x41, NFKD_6D_41},
    {0x56, NFKD_6D_56},
    {0x57, NFKD_6D_57},
    {0x62, NFKD_6D_62},
    {0x67, NFKD_6D_67},
    {0x69, NFKD_6D_69},
    {0x6C, NFKD_6D_6C},
    {0x6D, NFKD_6D_6D},
    {0x6F, NFKD_6D_6F},
    {0x73, NFKD_6D_73},
    {0x2215, NFKD_6D_2215}};
const static Trie NFKD_6D(NFKD_6D_map);
const static Trie NFKD_6E_41(0x3381);
const static Trie NFKD_6E_46(0x338B);
const static Trie NFKD_6E_56(0x33B5);
const static Trie NFKD_6E_57(0x33BB);
const static Trie NFKD_6E_6A(0x1CC);
const static Trie NFKD_6E_6D(0x339A);
const static Trie NFKD_6E_73(0x33B1);
const static BranchMap NFKD_6E_map {
    {0x41, NFKD_6E_41},
    {0x46, NFKD_6E_46},
    {0x56, NFKD_6E_56},
    {0x57, NFKD_6E_57},
    {0x6A, NFKD_6E_6A},
    {0x6D, NFKD_6E_6D},
    {0x73, NFKD_6E_73}};
const static Trie NFKD_6E(NFKD_6E_map);
const static Trie NFKD_6F_56(0x3375);
const static BranchMap NFKD_6F_map {
    {0x56, NFKD_6F_56}};
const static Trie NFKD_6F(NFKD_6F_map);
const static Trie NFKD_70_2E_6D_2E(0x33D8);
const static BranchMap NFKD_70_2E_6D_map {
    {0x2E, NFKD_70_2E_6D_2E}};
const static Trie NFKD_70_2E_6D(NFKD_70_2E_6D_map);
const static BranchMap NFKD_70_2E_map {
    {0x6D, NFKD_70_2E_6D}};
const static Trie NFKD_70_2E(NFKD_70_2E_map);
const static Trie NFKD_70_41(0x3380);
const static Trie NFKD_70_46(0x338A);
const static Trie NFKD_70_56(0x33B4);
const static Trie NFKD_70_57(0x33BA);
const static Trie NFKD_70_63(0x3376);
const static Trie NFKD_70_73(0x33B0);
const static BranchMap NFKD_70_map {
    {0x2E, NFKD_70_2E},
    {0x41, NFKD_70_41},
    {0x46, NFKD_70_46},
    {0x56, NFKD_70_56},
    {0x57, NFKD_70_57},
    {0x63, NFKD_70_63},
    {0x73, NFKD_70_73}};
const static Trie NFKD_70(NFKD_70_map);
const static Trie NFKD_72_61_64_2215_73_32(0x33AF);
const static BranchMap NFKD_72_61_64_2215_73_map {
    {0x32, NFKD_72_61_64_2215_73_32}};
const static Trie NFKD_72_61_64_2215_73(0x33AE, NFKD_72_61_64_2215_73_map);
const static BranchMap NFKD_72_61_64_2215_map {
    {0x73, NFKD_72_61_64_2215_73}};
const static Trie NFKD_72_61_64_2215(NFKD_72_61_64_2215_map);
const static BranchMap NFKD_72_61_64_map {
    {0x2215, NFKD_72_61_64_2215}};
const static Trie NFKD_72_61_64(0x33AD, NFKD_72_61_64_map);
const static BranchMap NFKD_72_61_map {
    {0x64, NFKD_72_61_64}};
const static Trie NFKD_72_61(NFKD_72_61_map);
const static BranchMap NFKD_72_map {
    {0x61, NFKD_72_61}};
const static Trie NFKD_72(NFKD_72_map);
const static Trie NFKD_73_72(0x33DB);
const static Trie NFKD_73_74(0xFB05);
const static Trie NFKD_73_307(0x1E9B);
const static BranchMap NFKD_73_map {
    {0x72, NFKD_73_72},
    {0x74, NFKD_73_74},
    {0x307, NFKD_73_307}};
const static Trie NFKD_73(NFKD_73_map);
const static Trie NFKD_76_69_69_69(0x2177);
const static BranchMap NFKD_76_69_69_map {
    {0x69, NFKD_76_69_69_69}};
const static Trie NFKD_76_69_69(0x2176, NFKD_76_69_69_map);
const static BranchMap NFKD_76_69_map {
    {0x69, NFKD_76_69_69}};
const static Trie NFKD_76_69(0x2175, NFKD_76_69_map);
const static BranchMap NFKD_76_map {
    {0x69, NFKD_76_69}};
const static Trie NFKD_76(NFKD_76_map);
const static Trie NFKD_78_69_69(0x217B);
const static BranchMap NFKD_78_69_map {
    {0x69, NFKD_78_69_69}};
const static Trie NFKD_78_69(0x217A, NFKD_78_69_map);
const static BranchMap NFKD_78_map {
    {0x69, NFKD_78_69}};
const static Trie NFKD_78(NFKD_78_map);
const static Trie NFKD_B0_43(0x2103);
const static Trie NFKD_B0_46(0x2109);
const static BranchMap NFKD_B0_map {
    {0x43, NFKD_B0_43},
    {0x46, NFKD_B0_46}};
const static Trie NFKD_B0(NFKD_B0_map);
const static Trie NFKD_2BC_6E(0x149);
const static BranchMap NFKD_2BC_map {
    {0x6E, NFKD_2BC_6E}};
const static Trie NFKD_2BC(NFKD_2BC_map);
const static Trie NFKD_3A5_301(0x3D3);
const static Trie NFKD_3A5_308(0x3D4);
const static BranchMap NFKD_3A5_map {
    {0x301, NFKD_3A5_301},
    {0x308, NFKD_3A5_308}};
const static Trie NFKD_3A5(NFKD_3A5_map);
const static Trie NFKD_3BC_41(0x3382);
const static Trie NFKD_3BC_46(0x338C);
const static Trie NFKD_3BC_56(0x33B6);
const static Trie NFKD_3BC_57(0x33BC);
const static Trie NFKD_3BC_67(0x338D);
const static Trie NFKD_3BC_6C(0x3395);
const static Trie NFKD_3BC_6D(0x339B);
const static Trie NFKD_3BC_73(0x33B2);
const static BranchMap NFKD_3BC_map {
    {0x41, NFKD_3BC_41},
    {0x46, NFKD_3BC_46},
    {0x56, NFKD_3BC_56},
    {0x57, NFKD_3BC_57},
    {0x67, NFKD_3BC_67},
    {0x6C, NFKD_3BC_6C},
    {0x6D, NFKD_3BC_6D},
    {0x73, NFKD_3BC_73}};
const static Trie NFKD_3BC(NFKD_3BC_map);
const static Trie NFKD_565_582(0x587);
const static BranchMap NFKD_565_map {
    {0x582, NFKD_565_582}};
const static Trie NFKD_565(NFKD_565_map);
const static Trie NFKD_574_565(0xFB14);
const static Trie NFKD_574_56B(0xFB15);
const static Trie NFKD_574_56D(0xFB17);
const static Trie NFKD_574_576(0xFB13);
const static BranchMap NFKD_574_map {
    {0x565, NFKD_574_565},
    {0x56B, NFKD_574_56B},
    {0x56D, NFKD_574_56D},
    {0x576, NFKD_574_576}};
const static Trie NFKD_574(NFKD_574_map);
const static Trie NFKD_57E_576(0xFB16);
const static BranchMap NFKD_57E_map {
    {0x576, NFKD_57E_576}};
const static Trie NFKD_57E(NFKD_57E_map);
const static Trie NFKD_5D0_5DC(0xFB4F);
const static BranchMap NFKD_5D0_map {
    {0x5DC, NFKD_5D0_5DC}};
const static Trie NFKD_5D0(NFKD_5D0_map);
const static Trie NFKD_627_643_628_631(0xFDF3);
const static BranchMap NFKD_627_643_628_map {
    {0x631, NFKD_627_643_628_631}};
const static Trie NFKD_627_643_628(NFKD_627_643_628_map);
const static BranchMap NFKD_627_643_map {
    {0x628, NFKD_627_643_628}};
const static Trie NFKD_627_643(NFKD_627_643_map);
const static Trie NFKD_627_644_644_647(0xFDF2);
const static BranchMap NFKD_627_644_644_map {
    {0x647, NFKD_627_644_644_647}};
const static Trie NFKD_627_644_644(NFKD_627_644_644_map);
const static BranchMap NFKD_627_644_map {
    {0x644, NFKD_627_644_644}};
const static Trie NFKD_627_644(NFKD_627_644_map);
const static Trie NFKD_627_64B(0xFD3C);
const static Trie NFKD_627_653(0xFE81);
const static Trie NFKD_627_654(0xFE83);
const static Trie NFKD_627_655(0xFE87);
const static Trie NFKD_627_674(0x675);
const static BranchMap NFKD_627_map {
    {0x643, NFKD_627_643},
    {0x644, NFKD_627_644},
    {0x64B, NFKD_627_64B},
    {0x653, NFKD_627_653},
    {0x654, NFKD_627_654},
    {0x655, NFKD_627_655},
    {0x674, NFKD_627_674}};
const static Trie NFKD_627(NFKD_627_map);
const static Trie NFKD_628_62C(0xFC05);
const static Trie NFKD_628_62D_64A(0xFDC2);
const static BranchMap NFKD_628_62D_map {
    {0x64A, NFKD_628_62D_64A}};
const static Trie NFKD_628_62D(0xFC06, NFKD_628_62D_map);
const static Trie NFKD_628_62E_64A(0xFD9E);
const static BranchMap NFKD_628_62E_map {
    {0x64A, NFKD_628_62E_64A}};
const static Trie NFKD_628_62E(0xFC07, NFKD_628_62E_map);
const static Trie NFKD_628_631(0xFC6A);
const static Trie NFKD_628_632(0xFC6B);
const static Trie NFKD_628_645(0xFC08);
const static Trie NFKD_628_646(0xFC6D);
const static Trie NFKD_628_647(0xFCA0);
const static Trie NFKD_628_649(0xFC09);
const static Trie NFKD_628_64A(0xFC0A);
const static BranchMap NFKD_628_map {
    {0x62C, NFKD_628_62C},
    {0x62D, NFKD_628_62D},
    {0x62E, NFKD_628_62E},
    {0x631, NFKD_628_631},
    {0x632, NFKD_628_632},
    {0x645, NFKD_628_645},
    {0x646, NFKD_628_646},
    {0x647, NFKD_628_647},
    {0x649, NFKD_628_649},
    {0x64A, NFKD_628_64A}};
const static Trie NFKD_628(NFKD_628_map);
const static Trie NFKD_62A_62C_645(0xFD50);
const static Trie NFKD_62A_62C_649(0xFDA0);
const static Trie NFKD_62A_62C_64A(0xFD9F);
const static BranchMap NFKD_62A_62C_map {
    {0x645, NFKD_62A_62C_645},
    {0x649, NFKD_62A_62C_649},
    {0x64A, NFKD_62A_62C_64A}};
const static Trie NFKD_62A_62C(0xFC0B, NFKD_62A_62C_map);
const static Trie NFKD_62A_62D_62C(0xFD51);
const static Trie NFKD_62A_62D_645(0xFD53);
const static BranchMap NFKD_62A_62D_map {
    {0x62C, NFKD_62A_62D_62C},
    {0x645, NFKD_62A_62D_645}};
const static Trie NFKD_62A_62D(0xFC0C, NFKD_62A_62D_map);
const static Trie NFKD_62A_62E_645(0xFD54);
const static Trie NFKD_62A_62E_649(0xFDA2);
const static Trie NFKD_62A_62E_64A(0xFDA1);
const static BranchMap NFKD_62A_62E_map {
    {0x645, NFKD_62A_62E_645},
    {0x649, NFKD_62A_62E_649},
    {0x64A, NFKD_62A_62E_64A}};
const static Trie NFKD_62A_62E(0xFC0D, NFKD_62A_62E_map);
const static Trie NFKD_62A_631(0xFC70);
const static Trie NFKD_62A_632(0xFC71);
const static Trie NFKD_62A_645_62C(0xFD55);
const static Trie NFKD_62A_645_62D(0xFD56);
const static Trie NFKD_62A_645_62E(0xFD57);
const static Trie NFKD_62A_645_649(0xFDA4);
const static Trie NFKD_62A_645_64A(0xFDA3);
const static BranchMap NFKD_62A_645_map {
    {0x62C, NFKD_62A_645_62C},
    {0x62D, NFKD_62A_645_62D},
    {0x62E, NFKD_62A_645_62E},
    {0x649, NFKD_62A_645_649},
    {0x64A, NFKD_62A_645_64A}};
const static Trie NFKD_62A_645(0xFC0E, NFKD_62A_645_map);
const static Trie NFKD_62A_646(0xFC73);
const static Trie NFKD_62A_647(0xFCA5);
const static Trie NFKD_62A_649(0xFC0F);
const static Trie NFKD_62A_64A(0xFC10);
const static BranchMap NFKD_62A_map {
    {0x62C, NFKD_62A_62C},
    {0x62D, NFKD_62A_62D},
    {0x62E, NFKD_62A_62E},
    {0x631, NFKD_62A_631},
    {0x632, NFKD_62A_632},
    {0x645, NFKD_62A_645},
    {0x646, NFKD_62A_646},
    {0x647, NFKD_62A_647},
    {0x649, NFKD_62A_649},
    {0x64A, NFKD_62A_64A}};
const static Trie NFKD_62A(NFKD_62A_map);
const static Trie NFKD_62B_62C(0xFC11);
const static Trie NFKD_62B_631(0xFC76);
const static Trie NFKD_62B_632(0xFC77);
const static Trie NFKD_62B_645(0xFC12);
const static Trie NFKD_62B_646(0xFC79);
const static Trie NFKD_62B_647(0xFCE6);
const static Trie NFKD_62B_649(0xFC13);
const static Trie NFKD_62B_64A(0xFC14);
const static BranchMap NFKD_62B_map {
    {0x62C, NFKD_62B_62C},
    {0x631, NFKD_62B_631},
    {0x632, NFKD_62B_632},
    {0x645, NFKD_62B_645},
    {0x646, NFKD_62B_646},
    {0x647, NFKD_62B_647},
    {0x649, NFKD_62B_649},
    {0x64A, NFKD_62B_64A}};
const static Trie NFKD_62B(NFKD_62B_map);
const static Trie NFKD_62C_62D_649(0xFDA6);
const static Trie NFKD_62C_62D_64A(0xFDBE);
const static BranchMap NFKD_62C_62D_map {
    {0x649, NFKD_62C_62D_649},
    {0x64A, NFKD_62C_62D_64A}};
const static Trie NFKD_62C_62D(0xFC15, NFKD_62C_62D_map);
const static Trie NFKD_62C_644_20_62C_644_627_644_647(0xFDFB);
const static BranchMap NFKD_62C_644_20_62C_644_627_644_map {
    {0x647, NFKD_62C_644_20_62C_644_627_644_647}};
const static Trie NFKD_62C_644_20_62C_644_627_644(NFKD_62C_644_20_62C_644_627_644_map);
const static BranchMap NFKD_62C_644_20_62C_644_627_map {
    {0x644, NFKD_62C_644_20_62C_644_627_644}};
const static Trie NFKD_62C_644_20_62C_644_627(NFKD_62C_644_20_62C_644_627_map);
const static BranchMap NFKD_62C_644_20_62C_644_map {
    {0x627, NFKD_62C_644_20_62C_644_627}};
const static Trie NFKD_62C_644_20_62C_644(NFKD_62C_644_20_62C_644_map);
const static BranchMap NFKD_62C_644_20_62C_map {
    {0x644, NFKD_62C_644_20_62C_644}};
const static Trie NFKD_62C_644_20_62C(NFKD_62C_644_20_62C_map);
const static BranchMap NFKD_62C_644_20_map {
    {0x62C, NFKD_62C_644_20_62C}};
const static Trie NFKD_62C_644_20(NFKD_62C_644_20_map);
const static BranchMap NFKD_62C_644_map {
    {0x20, NFKD_62C_644_20}};
const static Trie NFKD_62C_644(NFKD_62C_644_map);
const static Trie NFKD_62C_645_62D(0xFD58);
const static Trie NFKD_62C_645_649(0xFDA7);
const static Trie NFKD_62C_645_64A(0xFDA5);
const static BranchMap NFKD_62C_645_map {
    {0x62D, NFKD_62C_645_62D},
    {0x649, NFKD_62C_645_649},
    {0x64A, NFKD_62C_645_64A}};
const static Trie NFKD_62C_645(0xFC16, NFKD_62C_645_map);
const static Trie NFKD_62C_649(0xFD01);
const static Trie NFKD_62C_64A(0xFD02);
const static BranchMap NFKD_62C_map {
    {0x62D, NFKD_62C_62D},
    {0x644, NFKD_62C_644},
    {0x645, NFKD_62C_645},
    {0x649, NFKD_62C_649},
    {0x64A, NFKD_62C_64A}};
const static Trie NFKD_62C(NFKD_62C_map);
const static Trie NFKD_62D_62C_64A(0xFDBF);
const static BranchMap NFKD_62D_62C_map {
    {0x64A, NFKD_62D_62C_64A}};
const static Trie NFKD_62D_62C(0xFC17, NFKD_62D_62C_map);
const static Trie NFKD_62D_645_649(0xFD5B);
const static Trie NFKD_62D_645_64A(0xFD5A);
const static BranchMap NFKD_62D_645_map {
    {0x649, NFKD_62D_645_649},
    {0x64A, NFKD_62D_645_64A}};
const static Trie NFKD_62D_645(0xFC18, NFKD_62D_645_map);
const static Trie NFKD_62D_649(0xFCFF);
const static Trie NFKD_62D_64A(0xFD00);
const static BranchMap NFKD_62D_map {
    {0x62C, NFKD_62D_62C},
    {0x645, NFKD_62D_645},
    {0x649, NFKD_62D_649},
    {0x64A, NFKD_62D_64A}};
const static Trie NFKD_62D(NFKD_62D_map);
const static Trie NFKD_62E_62C(0xFC19);
const static Trie NFKD_62E_62D(0xFC1A);
const static Trie NFKD_62E_645(0xFC1B);
const static Trie NFKD_62E_649(0xFD03);
const static Trie NFKD_62E_64A(0xFD04);
const static BranchMap NFKD_62E_map {
    {0x62C, NFKD_62E_62C},
    {0x62D, NFKD_62E_62D},
    {0x645, NFKD_62E_645},
    {0x649, NFKD_62E_649},
    {0x64A, NFKD_62E_64A}};
const static Trie NFKD_62E(NFKD_62E_map);
const static Trie NFKD_630_670(0xFC5B);
const static BranchMap NFKD_630_map {
    {0x670, NFKD_630_670}};
const static Trie NFKD_630(NFKD_630_map);
const static Trie NFKD_631_633_648_644(0xFDF6);
const static BranchMap NFKD_631_633_648_map {
    {0x644, NFKD_631_633_648_644}};
const static Trie NFKD_631_633_648(NFKD_631_633_648_map);
const static BranchMap NFKD_631_633_map {
    {0x648, NFKD_631_633_648}};
const static Trie NFKD_631_633(NFKD_631_633_map);
const static Trie NFKD_631_670(0xFC5C);
const static Trie NFKD_631_6CC_627_644(0xFDFC);
const static BranchMap NFKD_631_6CC_627_map {
    {0x644, NFKD_631_6CC_627_644}};
const static Trie NFKD_631_6CC_627(NFKD_631_6CC_627_map);
const static BranchMap NFKD_631_6CC_map {
    {0x627, NFKD_631_6CC_627}};
const static Trie NFKD_631_6CC(NFKD_631_6CC_map);
const static BranchMap NFKD_631_map {
    {0x633, NFKD_631_633},
    {0x670, NFKD_631_670},
    {0x6CC, NFKD_631_6CC}};
const static Trie NFKD_631(NFKD_631_map);
const static Trie NFKD_633_62C_62D(0xFD5D);
const static Trie NFKD_633_62C_649(0xFD5E);
const static BranchMap NFKD_633_62C_map {
    {0x62D, NFKD_633_62C_62D},
    {0x649, NFKD_633_62C_649}};
const static Trie NFKD_633_62C(0xFC1C, NFKD_633_62C_map);
const static Trie NFKD_633_62D_62C(0xFD5C);
const static BranchMap NFKD_633_62D_map {
    {0x62C, NFKD_633_62D_62C}};
const static Trie NFKD_633_62D(0xFC1D, NFKD_633_62D_map);
const static Trie NFKD_633_62E_649(0xFDA8);
const static Trie NFKD_633_62E_64A(0xFDC6);
const static BranchMap NFKD_633_62E_map {
    {0x649, NFKD_633_62E_649},
    {0x64A, NFKD_633_62E_64A}};
const static Trie NFKD_633_62E(0xFC1E, NFKD_633_62E_map);
const static Trie NFKD_633_631(0xFD0E);
const static Trie NFKD_633_645_62C(0xFD61);
const static Trie NFKD_633_645_62D(0xFD5F);
const static Trie NFKD_633_645_645(0xFD62);
const static BranchMap NFKD_633_645_map {
    {0x62C, NFKD_633_645_62C},
    {0x62D, NFKD_633_645_62D},
    {0x645, NFKD_633_645_645}};
const static Trie NFKD_633_645(0xFC1F, NFKD_633_645_map);
const static Trie NFKD_633_647(0xFCE8);
const static Trie NFKD_633_649(0xFCFB);
const static Trie NFKD_633_64A(0xFCFC);
const static BranchMap NFKD_633_map {
    {0x62C, NFKD_633_62C},
    {0x62D, NFKD_633_62D},
    {0x62E, NFKD_633_62E},
    {0x631, NFKD_633_631},
    {0x645, NFKD_633_645},
    {0x647, NFKD_633_647},
    {0x649, NFKD_633_649},
    {0x64A, NFKD_633_64A}};
const static Trie NFKD_633(NFKD_633_map);
const static Trie NFKD_634_62C_64A(0xFD69);
const static BranchMap NFKD_634_62C_map {
    {0x64A, NFKD_634_62C_64A}};
const static Trie NFKD_634_62C(0xFD09, NFKD_634_62C_map);
const static Trie NFKD_634_62D_645(0xFD67);
const static Trie NFKD_634_62D_64A(0xFDAA);
const static BranchMap NFKD_634_62D_map {
    {0x645, NFKD_634_62D_645},
    {0x64A, NFKD_634_62D_64A}};
const static Trie NFKD_634_62D(0xFD0A, NFKD_634_62D_map);
const static Trie NFKD_634_62E(0xFD0B);
const static Trie NFKD_634_631(0xFD0D);
const static Trie NFKD_634_645_62E(0xFD6A);
const static Trie NFKD_634_645_645(0xFD6C);
const static BranchMap NFKD_634_645_map {
    {0x62E, NFKD_634_645_62E},
    {0x645, NFKD_634_645_645}};
const static Trie NFKD_634_645(0xFCE9, NFKD_634_645_map);
const static Trie NFKD_634_647(0xFCEA);
const static Trie NFKD_634_649(0xFCFD);
const static Trie NFKD_634_64A(0xFCFE);
const static BranchMap NFKD_634_map {
    {0x62C, NFKD_634_62C},
    {0x62D, NFKD_634_62D},
    {0x62E, NFKD_634_62E},
    {0x631, NFKD_634_631},
    {0x645, NFKD_634_645},
    {0x647, NFKD_634_647},
    {0x649, NFKD_634_649},
    {0x64A, NFKD_634_64A}};
const static Trie NFKD_634(NFKD_634_map);
const static Trie NFKD_635_62D_62D(0xFD64);
const static Trie NFKD_635_62D_64A(0xFDA9);
const static BranchMap NFKD_635_62D_map {
    {0x62D, NFKD_635_62D_62D},
    {0x64A, NFKD_635_62D_64A}};
const static Trie NFKD_635_62D(0xFC20, NFKD_635_62D_map);
const static Trie NFKD_635_62E(0xFCB2);
const static Trie NFKD_635_631(0xFD0F);
const static Trie NFKD_635_644_639_645(0xFDF5);
const static BranchMap NFKD_635_644_639_map {
    {0x645, NFKD_635_644_639_645}};
const static Trie NFKD_635_644_639(NFKD_635_644_639_map);
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_644_645(0xFDFA);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_644_map {
    {0x645, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_644_645}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_644(NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_644_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_map {
    {0x644, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_644}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633(NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_map {
    {0x633, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_633}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648(NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_map {
    {0x648, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_648}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20(NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_map {
    {0x20, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_20}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647(NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_map {
    {0x647, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_647}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644_64A(NFKD_635_644_649_20_627_644_644_647_20_639_644_64A_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_644_map {
    {0x64A, NFKD_635_644_649_20_627_644_644_647_20_639_644_64A}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639_644(NFKD_635_644_649_20_627_644_644_647_20_639_644_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_639_map {
    {0x644, NFKD_635_644_649_20_627_644_644_647_20_639_644}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20_639(NFKD_635_644_649_20_627_644_644_647_20_639_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_20_map {
    {0x639, NFKD_635_644_649_20_627_644_644_647_20_639}};
const static Trie NFKD_635_644_649_20_627_644_644_647_20(NFKD_635_644_649_20_627_644_644_647_20_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_647_map {
    {0x20, NFKD_635_644_649_20_627_644_644_647_20}};
const static Trie NFKD_635_644_649_20_627_644_644_647(NFKD_635_644_649_20_627_644_644_647_map);
const static BranchMap NFKD_635_644_649_20_627_644_644_map {
    {0x647, NFKD_635_644_649_20_627_644_644_647}};
const static Trie NFKD_635_644_649_20_627_644_644(NFKD_635_644_649_20_627_644_644_map);
const static BranchMap NFKD_635_644_649_20_627_644_map {
    {0x644, NFKD_635_644_649_20_627_644_644}};
const static Trie NFKD_635_644_649_20_627_644(NFKD_635_644_649_20_627_644_map);
const static BranchMap NFKD_635_644_649_20_627_map {
    {0x644, NFKD_635_644_649_20_627_644}};
const static Trie NFKD_635_644_649_20_627(NFKD_635_644_649_20_627_map);
const static BranchMap NFKD_635_644_649_20_map {
    {0x627, NFKD_635_644_649_20_627}};
const static Trie NFKD_635_644_649_20(NFKD_635_644_649_20_map);
const static BranchMap NFKD_635_644_649_map {
    {0x20, NFKD_635_644_649_20}};
const static Trie NFKD_635_644_649(0xFDF9, NFKD_635_644_649_map);
const static Trie NFKD_635_644_6D2(0xFDF0);
const static BranchMap NFKD_635_644_map {
    {0x639, NFKD_635_644_639},
    {0x649, NFKD_635_644_649},
    {0x6D2, NFKD_635_644_6D2}};
const static Trie NFKD_635_644(NFKD_635_644_map);
const static Trie NFKD_635_645_645(0xFD66);
const static BranchMap NFKD_635_645_map {
    {0x645, NFKD_635_645_645}};
const static Trie NFKD_635_645(0xFC21, NFKD_635_645_map);
const static Trie NFKD_635_649(0xFD05);
const static Trie NFKD_635_64A(0xFD06);
const static BranchMap NFKD_635_map {
    {0x62D, NFKD_635_62D},
    {0x62E, NFKD_635_62E},
    {0x631, NFKD_635_631},
    {0x644, NFKD_635_644},
    {0x645, NFKD_635_645},
    {0x649, NFKD_635_649},
    {0x64A, NFKD_635_64A}};
const static Trie NFKD_635(NFKD_635_map);
const static Trie NFKD_636_62C(0xFC22);
const static Trie NFKD_636_62D_649(0xFD6E);
const static Trie NFKD_636_62D_64A(0xFDAB);
const static BranchMap NFKD_636_62D_map {
    {0x649, NFKD_636_62D_649},
    {0x64A, NFKD_636_62D_64A}};
const static Trie NFKD_636_62D(0xFC23, NFKD_636_62D_map);
const static Trie NFKD_636_62E_645(0xFD6F);
const static BranchMap NFKD_636_62E_map {
    {0x645, NFKD_636_62E_645}};
const static Trie NFKD_636_62E(0xFC24, NFKD_636_62E_map);
const static Trie NFKD_636_631(0xFD10);
const static Trie NFKD_636_645(0xFC25);
const static Trie NFKD_636_649(0xFD07);
const static Trie NFKD_636_64A(0xFD08);
const static BranchMap NFKD_636_map {
    {0x62C, NFKD_636_62C},
    {0x62D, NFKD_636_62D},
    {0x62E, NFKD_636_62E},
    {0x631, NFKD_636_631},
    {0x645, NFKD_636_645},
    {0x649, NFKD_636_649},
    {0x64A, NFKD_636_64A}};
const static Trie NFKD_636(NFKD_636_map);
const static Trie NFKD_637_62D(0xFC26);
const static Trie NFKD_637_645_62D(0xFD71);
const static Trie NFKD_637_645_645(0xFD73);
const static Trie NFKD_637_645_64A(0xFD74);
const static BranchMap NFKD_637_645_map {
    {0x62D, NFKD_637_645_62D},
    {0x645, NFKD_637_645_645},
    {0x64A, NFKD_637_645_64A}};
const static Trie NFKD_637_645(0xFC27, NFKD_637_645_map);
const static Trie NFKD_637_649(0xFCF5);
const static Trie NFKD_637_64A(0xFCF6);
const static BranchMap NFKD_637_map {
    {0x62D, NFKD_637_62D},
    {0x645, NFKD_637_645},
    {0x649, NFKD_637_649},
    {0x64A, NFKD_637_64A}};
const static Trie NFKD_637(NFKD_637_map);
const static Trie NFKD_638_645(0xFC28);
const static BranchMap NFKD_638_map {
    {0x645, NFKD_638_645}};
const static Trie NFKD_638(NFKD_638_map);
const static Trie NFKD_639_62C_645(0xFD75);
const static BranchMap NFKD_639_62C_map {
    {0x645, NFKD_639_62C_645}};
const static Trie NFKD_639_62C(0xFC29, NFKD_639_62C_map);
const static Trie NFKD_639_644_64A_647(0xFDF7);
const static BranchMap NFKD_639_644_64A_map {
    {0x647, NFKD_639_644_64A_647}};
const static Trie NFKD_639_644_64A(NFKD_639_644_64A_map);
const static BranchMap NFKD_639_644_map {
    {0x64A, NFKD_639_644_64A}};
const static Trie NFKD_639_644(NFKD_639_644_map);
const static Trie NFKD_639_645_645(0xFD76);
const static Trie NFKD_639_645_649(0xFD78);
const static Trie NFKD_639_645_64A(0xFDB6);
const static BranchMap NFKD_639_645_map {
    {0x645, NFKD_639_645_645},
    {0x649, NFKD_639_645_649},
    {0x64A, NFKD_639_645_64A}};
const static Trie NFKD_639_645(0xFC2A, NFKD_639_645_map);
const static Trie NFKD_639_649(0xFCF7);
const static Trie NFKD_639_64A(0xFCF8);
const static BranchMap NFKD_639_map {
    {0x62C, NFKD_639_62C},
    {0x644, NFKD_639_644},
    {0x645, NFKD_639_645},
    {0x649, NFKD_639_649},
    {0x64A, NFKD_639_64A}};
const static Trie NFKD_639(NFKD_639_map);
const static Trie NFKD_63A_62C(0xFC2B);
const static Trie NFKD_63A_645_645(0xFD79);
const static Trie NFKD_63A_645_649(0xFD7B);
const static Trie NFKD_63A_645_64A(0xFD7A);
const static BranchMap NFKD_63A_645_map {
    {0x645, NFKD_63A_645_645},
    {0x649, NFKD_63A_645_649},
    {0x64A, NFKD_63A_645_64A}};
const static Trie NFKD_63A_645(0xFC2C, NFKD_63A_645_map);
const static Trie NFKD_63A_649(0xFCF9);
const static Trie NFKD_63A_64A(0xFCFA);
const static BranchMap NFKD_63A_map {
    {0x62C, NFKD_63A_62C},
    {0x645, NFKD_63A_645},
    {0x649, NFKD_63A_649},
    {0x64A, NFKD_63A_64A}};
const static Trie NFKD_63A(NFKD_63A_map);
const static Trie NFKD_640_64B(0xFE71);
const static Trie NFKD_640_64E_651(0xFCF2);
const static BranchMap NFKD_640_64E_map {
    {0x651, NFKD_640_64E_651}};
const static Trie NFKD_640_64E(0xFE77, NFKD_640_64E_map);
const static Trie NFKD_640_64F_651(0xFCF3);
const static BranchMap NFKD_640_64F_map {
    {0x651, NFKD_640_64F_651}};
const static Trie NFKD_640_64F(0xFE79, NFKD_640_64F_map);
const static Trie NFKD_640_650_651(0xFCF4);
const static BranchMap NFKD_640_650_map {
    {0x651, NFKD_640_650_651}};
const static Trie NFKD_640_650(0xFE7B, NFKD_640_650_map);
const static Trie NFKD_640_651(0xFE7D);
const static Trie NFKD_640_652(0xFE7F);
const static BranchMap NFKD_640_map {
    {0x64B, NFKD_640_64B},
    {0x64E, NFKD_640_64E},
    {0x64F, NFKD_640_64F},
    {0x650, NFKD_640_650},
    {0x651, NFKD_640_651},
    {0x652, NFKD_640_652}};
const static Trie NFKD_640(NFKD_640_map);
const static Trie NFKD_641_62C(0xFC2D);
const static Trie NFKD_641_62D(0xFC2E);
const static Trie NFKD_641_62E_645(0xFD7C);
const static BranchMap NFKD_641_62E_map {
    {0x645, NFKD_641_62E_645}};
const static Trie NFKD_641_62E(0xFC2F, NFKD_641_62E_map);
const static Trie NFKD_641_645_64A(0xFDC1);
const static BranchMap NFKD_641_645_map {
    {0x64A, NFKD_641_645_64A}};
const static Trie NFKD_641_645(0xFC30, NFKD_641_645_map);
const static Trie NFKD_641_649(0xFC31);
const static Trie NFKD_641_64A(0xFC32);
const static BranchMap NFKD_641_map {
    {0x62C, NFKD_641_62C},
    {0x62D, NFKD_641_62D},
    {0x62E, NFKD_641_62E},
    {0x645, NFKD_641_645},
    {0x649, NFKD_641_649},
    {0x64A, NFKD_641_64A}};
const static Trie NFKD_641(NFKD_641_map);
const static Trie NFKD_642_62D(0xFC33);
const static Trie NFKD_642_644_6D2(0xFDF1);
const static BranchMap NFKD_642_644_map {
    {0x6D2, NFKD_642_644_6D2}};
const static Trie NFKD_642_644(NFKD_642_644_map);
const static Trie NFKD_642_645_62D(0xFD7E);
const static Trie NFKD_642_645_645(0xFD7F);
const static Trie NFKD_642_645_64A(0xFDB2);
const static BranchMap NFKD_642_645_map {
    {0x62D, NFKD_642_645_62D},
    {0x645, NFKD_642_645_645},
    {0x64A, NFKD_642_645_64A}};
const static Trie NFKD_642_645(0xFC34, NFKD_642_645_map);
const static Trie NFKD_642_649(0xFC35);
const static Trie NFKD_642_64A(0xFC36);
const static BranchMap NFKD_642_map {
    {0x62D, NFKD_642_62D},
    {0x644, NFKD_642_644},
    {0x645, NFKD_642_645},
    {0x649, NFKD_642_649},
    {0x64A, NFKD_642_64A}};
const static Trie NFKD_642(NFKD_642_map);
const static Trie NFKD_643_627(0xFC37);
const static Trie NFKD_643_62C(0xFC38);
const static Trie NFKD_643_62D(0xFC39);
const static Trie NFKD_643_62E(0xFC3A);
const static Trie NFKD_643_644(0xFC3B);
const static Trie NFKD_643_645_645(0xFDBB);
const static Trie NFKD_643_645_64A(0xFDB7);
const static BranchMap NFKD_643_645_map {
    {0x645, NFKD_643_645_645},
    {0x64A, NFKD_643_645_64A}};
const static Trie NFKD_643_645(0xFC3C, NFKD_643_645_map);
const static Trie NFKD_643_649(0xFC3D);
const static Trie NFKD_643_64A(0xFC3E);
const static BranchMap NFKD_643_map {
    {0x627, NFKD_643_627},
    {0x62C, NFKD_643_62C},
    {0x62D, NFKD_643_62D},
    {0x62E, NFKD_643_62E},
    {0x644, NFKD_643_644},
    {0x645, NFKD_643_645},
    {0x649, NFKD_643_649},
    {0x64A, NFKD_643_64A}};
const static Trie NFKD_643(NFKD_643_map);
const static Trie NFKD_644_627_653(0xFEF5);
const static Trie NFKD_644_627_654(0xFEF7);
const static Trie NFKD_644_627_655(0xFEF9);
const static BranchMap NFKD_644_627_map {
    {0x653, NFKD_644_627_653},
    {0x654, NFKD_644_627_654},
    {0x655, NFKD_644_627_655}};
const static Trie NFKD_644_627(0xFEFB, NFKD_644_627_map);
const static Trie NFKD_644_62C_62C(0xFD83);
const static Trie NFKD_644_62C_645(0xFDBA);
const static Trie NFKD_644_62C_64A(0xFDAC);
const static BranchMap NFKD_644_62C_map {
    {0x62C, NFKD_644_62C_62C},
    {0x645, NFKD_644_62C_645},
    {0x64A, NFKD_644_62C_64A}};
const static Trie NFKD_644_62C(0xFC3F, NFKD_644_62C_map);
const static Trie NFKD_644_62D_645(0xFD80);
const static Trie NFKD_644_62D_649(0xFD82);
const static Trie NFKD_644_62D_64A(0xFD81);
const static BranchMap NFKD_644_62D_map {
    {0x645, NFKD_644_62D_645},
    {0x649, NFKD_644_62D_649},
    {0x64A, NFKD_644_62D_64A}};
const static Trie NFKD_644_62D(0xFC40, NFKD_644_62D_map);
const static Trie NFKD_644_62E_645(0xFD85);
const static BranchMap NFKD_644_62E_map {
    {0x645, NFKD_644_62E_645}};
const static Trie NFKD_644_62E(0xFC41, NFKD_644_62E_map);
const static Trie NFKD_644_645_62D(0xFD87);
const static Trie NFKD_644_645_64A(0xFDAD);
const static BranchMap NFKD_644_645_map {
    {0x62D, NFKD_644_645_62D},
    {0x64A, NFKD_644_645_64A}};
const static Trie NFKD_644_645(0xFC42, NFKD_644_645_map);
const static Trie NFKD_644_647(0xFCCD);
const static Trie NFKD_644_649(0xFC43);
const static Trie NFKD_644_64A(0xFC44);
const static BranchMap NFKD_644_map {
    {0x627, NFKD_644_627},
    {0x62C, NFKD_644_62C},
    {0x62D, NFKD_644_62D},
    {0x62E, NFKD_644_62E},
    {0x645, NFKD_644_645},
    {0x647, NFKD_644_647},
    {0x649, NFKD_644_649},
    {0x64A, NFKD_644_64A}};
const static Trie NFKD_644(NFKD_644_map);
const static Trie NFKD_645_627(0xFC88);
const static Trie NFKD_645_62C_62D(0xFD8C);
const static Trie NFKD_645_62C_62E(0xFD92);
const static Trie NFKD_645_62C_645(0xFD8D);
const static Trie NFKD_645_62C_64A(0xFDC0);
const static BranchMap NFKD_645_62C_map {
    {0x62D, NFKD_645_62C_62D},
    {0x62E, NFKD_645_62C_62E},
    {0x645, NFKD_645_62C_645},
    {0x64A, NFKD_645_62C_64A}};
const static Trie NFKD_645_62C(0xFC45, NFKD_645_62C_map);
const static Trie NFKD_645_62D_62C(0xFD89);
const static Trie NFKD_645_62D_645_62F(0xFDF4);
const static BranchMap NFKD_645_62D_645_map {
    {0x62F, NFKD_645_62D_645_62F}};
const static Trie NFKD_645_62D_645(0xFD8A, NFKD_645_62D_645_map);
const static Trie NFKD_645_62D_64A(0xFD8B);
const static BranchMap NFKD_645_62D_map {
    {0x62C, NFKD_645_62D_62C},
    {0x645, NFKD_645_62D_645},
    {0x64A, NFKD_645_62D_64A}};
const static Trie NFKD_645_62D(0xFC46, NFKD_645_62D_map);
const static Trie NFKD_645_62E_62C(0xFD8E);
const static Trie NFKD_645_62E_645(0xFD8F);
const static Trie NFKD_645_62E_64A(0xFDB9);
const static BranchMap NFKD_645_62E_map {
    {0x62C, NFKD_645_62E_62C},
    {0x645, NFKD_645_62E_645},
    {0x64A, NFKD_645_62E_64A}};
const static Trie NFKD_645_62E(0xFC47, NFKD_645_62E_map);
const static Trie NFKD_645_645_64A(0xFDB1);
const static BranchMap NFKD_645_645_map {
    {0x64A, NFKD_645_645_64A}};
const static Trie NFKD_645_645(0xFC48, NFKD_645_645_map);
const static Trie NFKD_645_649(0xFC49);
const static Trie NFKD_645_64A(0xFC4A);
const static BranchMap NFKD_645_map {
    {0x627, NFKD_645_627},
    {0x62C, NFKD_645_62C},
    {0x62D, NFKD_645_62D},
    {0x62E, NFKD_645_62E},
    {0x645, NFKD_645_645},
    {0x649, NFKD_645_649},
    {0x64A, NFKD_645_64A}};
const static Trie NFKD_645(NFKD_645_map);
const static Trie NFKD_646_62C_62D(0xFDB8);
const static Trie NFKD_646_62C_645(0xFD97);
const static Trie NFKD_646_62C_649(0xFD99);
const static Trie NFKD_646_62C_64A(0xFDC7);
const static BranchMap NFKD_646_62C_map {
    {0x62D, NFKD_646_62C_62D},
    {0x645, NFKD_646_62C_645},
    {0x649, NFKD_646_62C_649},
    {0x64A, NFKD_646_62C_64A}};
const static Trie NFKD_646_62C(0xFC4B, NFKD_646_62C_map);
const static Trie NFKD_646_62D_645(0xFD95);
const static Trie NFKD_646_62D_649(0xFD96);
const static Trie NFKD_646_62D_64A(0xFDB3);
const static BranchMap NFKD_646_62D_map {
    {0x645, NFKD_646_62D_645},
    {0x649, NFKD_646_62D_649},
    {0x64A, NFKD_646_62D_64A}};
const static Trie NFKD_646_62D(0xFC4C, NFKD_646_62D_map);
const static Trie NFKD_646_62E(0xFC4D);
const static Trie NFKD_646_631(0xFC8A);
const static Trie NFKD_646_632(0xFC8B);
const static Trie NFKD_646_645_649(0xFD9B);
const static Trie NFKD_646_645_64A(0xFD9A);
const static BranchMap NFKD_646_645_map {
    {0x649, NFKD_646_645_649},
    {0x64A, NFKD_646_645_64A}};
const static Trie NFKD_646_645(0xFC4E, NFKD_646_645_map);
const static Trie NFKD_646_646(0xFC8D);
const static Trie NFKD_646_647(0xFCD6);
const static Trie NFKD_646_649(0xFC4F);
const static Trie NFKD_646_64A(0xFC50);
const static BranchMap NFKD_646_map {
    {0x62C, NFKD_646_62C},
    {0x62D, NFKD_646_62D},
    {0x62E, NFKD_646_62E},
    {0x631, NFKD_646_631},
    {0x632, NFKD_646_632},
    {0x645, NFKD_646_645},
    {0x646, NFKD_646_646},
    {0x647, NFKD_646_647},
    {0x649, NFKD_646_649},
    {0x64A, NFKD_646_64A}};
const static Trie NFKD_646(NFKD_646_map);
const static Trie NFKD_647_62C(0xFC51);
const static Trie NFKD_647_645_62C(0xFD93);
const static Trie NFKD_647_645_645(0xFD94);
const static BranchMap NFKD_647_645_map {
    {0x62C, NFKD_647_645_62C},
    {0x645, NFKD_647_645_645}};
const static Trie NFKD_647_645(0xFC52, NFKD_647_645_map);
const static Trie NFKD_647_649(0xFC53);
const static Trie NFKD_647_64A(0xFC54);
const static Trie NFKD_647_670(0xFCD9);
const static BranchMap NFKD_647_map {
    {0x62C, NFKD_647_62C},
    {0x645, NFKD_647_645},
    {0x649, NFKD_647_649},
    {0x64A, NFKD_647_64A},
    {0x670, NFKD_647_670}};
const static Trie NFKD_647(NFKD_647_map);
const static Trie NFKD_648_633_644_645(0xFDF8);
const static BranchMap NFKD_648_633_644_map {
    {0x645, NFKD_648_633_644_645}};
const static Trie NFKD_648_633_644(NFKD_648_633_644_map);
const static BranchMap NFKD_648_633_map {
    {0x644, NFKD_648_633_644}};
const static Trie NFKD_648_633(NFKD_648_633_map);
const static Trie NFKD_648_654(0xFE85);
const static Trie NFKD_648_674(0x676);
const static BranchMap NFKD_648_map {
    {0x633, NFKD_648_633},
    {0x654, NFKD_648_654},
    {0x674, NFKD_648_674}};
const static Trie NFKD_648(NFKD_648_map);
const static Trie NFKD_649_670(0xFC5D);
const static BranchMap NFKD_649_map {
    {0x670, NFKD_649_670}};
const static Trie NFKD_649(NFKD_649_map);
const static Trie NFKD_64A_62C_64A(0xFDAF);
const static BranchMap NFKD_64A_62C_map {
    {0x64A, NFKD_64A_62C_64A}};
const static Trie NFKD_64A_62C(0xFC55, NFKD_64A_62C_map);
const static Trie NFKD_64A_62D_64A(0xFDAE);
const static BranchMap NFKD_64A_62D_map {
    {0x64A, NFKD_64A_62D_64A}};
const static Trie NFKD_64A_62D(0xFC56, NFKD_64A_62D_map);
const static Trie NFKD_64A_62E(0xFC57);
const static Trie NFKD_64A_631(0xFC91);
const static Trie NFKD_64A_632(0xFC92);
const static Trie NFKD_64A_645_645(0xFD9C);
const static Trie NFKD_64A_645_64A(0xFDB0);
const static BranchMap NFKD_64A_645_map {
    {0x645, NFKD_64A_645_645},
    {0x64A, NFKD_64A_645_64A}};
const static Trie NFKD_64A_645(0xFC58, NFKD_64A_645_map);
const static Trie NFKD_64A_646(0xFC94);
const static Trie NFKD_64A_647(0xFCDE);
const static Trie NFKD_64A_649(0xFC59);
const static Trie NFKD_64A_64A(0xFC5A);
const static Trie NFKD_64A_654_627(0xFBEA);
const static Trie NFKD_64A_654_62C(0xFC00);
const static Trie NFKD_64A_654_62D(0xFC01);
const static Trie NFKD_64A_654_62E(0xFC99);
const static Trie NFKD_64A_654_631(0xFC64);
const static Trie NFKD_64A_654_632(0xFC65);
const static Trie NFKD_64A_654_645(0xFC02);
const static Trie NFKD_64A_654_646(0xFC67);
const static Trie NFKD_64A_654_647(0xFC9B);
const static Trie NFKD_64A_654_648(0xFBEE);
const static Trie NFKD_64A_654_649(0xFBF9);
const static Trie NFKD_64A_654_64A(0xFC04);
const static Trie NFKD_64A_654_6C6(0xFBF2);
const static Trie NFKD_64A_654_6C7(0xFBF0);
const static Trie NFKD_64A_654_6C8(0xFBF4);
const static Trie NFKD_64A_654_6D0(0xFBF6);
const static Trie NFKD_64A_654_6D5(0xFBEC);
const static BranchMap NFKD_64A_654_map {
    {0x627, NFKD_64A_654_627},
    {0x62C, NFKD_64A_654_62C},
    {0x62D, NFKD_64A_654_62D},
    {0x62E, NFKD_64A_654_62E},
    {0x631, NFKD_64A_654_631},
    {0x632, NFKD_64A_654_632},
    {0x645, NFKD_64A_654_645},
    {0x646, NFKD_64A_654_646},
    {0x647, NFKD_64A_654_647},
    {0x648, NFKD_64A_654_648},
    {0x649, NFKD_64A_654_649},
    {0x64A, NFKD_64A_654_64A},
    {0x6C6, NFKD_64A_654_6C6},
    {0x6C7, NFKD_64A_654_6C7},
    {0x6C8, NFKD_64A_654_6C8},
    {0x6D0, NFKD_64A_654_6D0},
    {0x6D5, NFKD_64A_654_6D5}};
const static Trie NFKD_64A_654(0xFE89, NFKD_64A_654_map);
const static Trie NFKD_64A_674(0x678);
const static BranchMap NFKD_64A_map {
    {0x62C, NFKD_64A_62C},
    {0x62D, NFKD_64A_62D},
    {0x62E, NFKD_64A_62E},
    {0x631, NFKD_64A_631},
    {0x632, NFKD_64A_632},
    {0x645, NFKD_64A_645},
    {0x646, NFKD_64A_646},
    {0x647, NFKD_64A_647},
    {0x649, NFKD_64A_649},
    {0x64A, NFKD_64A_64A},
    {0x654, NFKD_64A_654},
    {0x674, NFKD_64A_674}};
const static Trie NFKD_64A(NFKD_64A_map);
const static Trie NFKD_6C7_674(0x677);
const static BranchMap NFKD_6C7_map {
    {0x674, NFKD_6C7_674}};
const static Trie NFKD_6C7(NFKD_6C7_map);
const static Trie NFKD_6D2_654(0xFBB0);
const static BranchMap NFKD_6D2_map {
    {0x654, NFKD_6D2_654}};
const static Trie NFKD_6D2(NFKD_6D2_map);
const static Trie NFKD_6D5_654(0xFBA4);
const static BranchMap NFKD_6D5_map {
    {0x654, NFKD_6D5_654}};
const static Trie NFKD_6D5(NFKD_6D5_map);
const static Trie NFKD_E4D_E32(0xE33);
const static BranchMap NFKD_E4D_map {
    {0xE32, NFKD_E4D_E32}};
const static Trie NFKD_E4D(NFKD_E4D_map);
const static Trie NFKD_EAB_E99(0xEDC);
const static Trie NFKD_EAB_EA1(0xEDD);
const static BranchMap NFKD_EAB_map {
    {0xE99, NFKD_EAB_E99},
    {0xEA1, NFKD_EAB_EA1}};
const static Trie NFKD_EAB(NFKD_EAB_map);
const static Trie NFKD_ECD_EB2(0xEB3);
const static BranchMap NFKD_ECD_map {
    {0xEB2, NFKD_ECD_EB2}};
const static Trie NFKD_ECD(NFKD_ECD_map);
const static Trie NFKD_FB2_F71_F80(0xF77);
const static BranchMap NFKD_FB2_F71_map {
    {0xF80, NFKD_FB2_F71_F80}};
const static Trie NFKD_FB2_F71(NFKD_FB2_F71_map);
const static BranchMap NFKD_FB2_map {
    {0xF71, NFKD_FB2_F71}};
const static Trie NFKD_FB2(NFKD_FB2_map);
const static Trie NFKD_FB3_F71_F80(0xF79);
const static BranchMap NFKD_FB3_F71_map {
    {0xF80, NFKD_FB3_F71_F80}};
const static Trie NFKD_FB3_F71(NFKD_FB3_F71_map);
const static BranchMap NFKD_FB3_map {
    {0xF71, NFKD_FB3_F71}};
const static Trie NFKD_FB3(NFKD_FB3_map);
const static Trie NFKD_1100_1161(0x326E);
const static BranchMap NFKD_1100_map {
    {0x1161, NFKD_1100_1161}};
const static Trie NFKD_1100(NFKD_1100_map);
const static Trie NFKD_1102_1161(0x326F);
const static BranchMap NFKD_1102_map {
    {0x1161, NFKD_1102_1161}};
const static Trie NFKD_1102(NFKD_1102_map);
const static Trie NFKD_1103_1161(0x3270);
const static BranchMap NFKD_1103_map {
    {0x1161, NFKD_1103_1161}};
const static Trie NFKD_1103(NFKD_1103_map);
const static Trie NFKD_1105_1161(0x3271);
const static BranchMap NFKD_1105_map {
    {0x1161, NFKD_1105_1161}};
const static Trie NFKD_1105(NFKD_1105_map);
const static Trie NFKD_1106_1161(0x3272);
const static BranchMap NFKD_1106_map {
    {0x1161, NFKD_1106_1161}};
const static Trie NFKD_1106(NFKD_1106_map);
const static Trie NFKD_1107_1161(0x3273);
const static BranchMap NFKD_1107_map {
    {0x1161, NFKD_1107_1161}};
const static Trie NFKD_1107(NFKD_1107_map);
const static Trie NFKD_1109_1161(0x3274);
const static BranchMap NFKD_1109_map {
    {0x1161, NFKD_1109_1161}};
const static Trie NFKD_1109(NFKD_1109_map);
const static Trie NFKD_110B_1161(0x3275);
const static Trie NFKD_110B_116E(0x327E);
const static BranchMap NFKD_110B_map {
    {0x1161, NFKD_110B_1161},
    {0x116E, NFKD_110B_116E}};
const static Trie NFKD_110B(NFKD_110B_map);
const static Trie NFKD_110C_1161(0x3276);
const static Trie NFKD_110C_116E_110B_1174(0x327D);
const static BranchMap NFKD_110C_116E_110B_map {
    {0x1174, NFKD_110C_116E_110B_1174}};
const static Trie NFKD_110C_116E_110B(NFKD_110C_116E_110B_map);
const static BranchMap NFKD_110C_116E_map {
    {0x110B, NFKD_110C_116E_110B}};
const static Trie NFKD_110C_116E(NFKD_110C_116E_map);
const static BranchMap NFKD_110C_map {
    {0x1161, NFKD_110C_1161},
    {0x116E, NFKD_110C_116E}};
const static Trie NFKD_110C(NFKD_110C_map);
const static Trie NFKD_110E_1161_11B7_1100_1169(0x327C);
const static BranchMap NFKD_110E_1161_11B7_1100_map {
    {0x1169, NFKD_110E_1161_11B7_1100_1169}};
const static Trie NFKD_110E_1161_11B7_1100(NFKD_110E_1161_11B7_1100_map);
const static BranchMap NFKD_110E_1161_11B7_map {
    {0x1100, NFKD_110E_1161_11B7_1100}};
const static Trie NFKD_110E_1161_11B7(NFKD_110E_1161_11B7_map);
const static BranchMap NFKD_110E_1161_map {
    {0x11B7, NFKD_110E_1161_11B7}};
const static Trie NFKD_110E_1161(0x3277, NFKD_110E_1161_map);
const static BranchMap NFKD_110E_map {
    {0x1161, NFKD_110E_1161}};
const static Trie NFKD_110E(NFKD_110E_map);
const static Trie NFKD_110F_1161(0x3278);
const static BranchMap NFKD_110F_map {
    {0x1161, NFKD_110F_1161}};
const static Trie NFKD_110F(NFKD_110F_map);
const static Trie NFKD_1110_1161(0x3279);
const static BranchMap NFKD_1110_map {
    {0x1161, NFKD_1110_1161}};
const static Trie NFKD_1110(NFKD_1110_map);
const static Trie NFKD_1111_1161(0x327A);
const static BranchMap NFKD_1111_map {
    {0x1161, NFKD_1111_1161}};
const static Trie NFKD_1111(NFKD_1111_map);
const static Trie NFKD_1112_1161(0x327B);
const static BranchMap NFKD_1112_map {
    {0x1161, NFKD_1112_1161}};
const static Trie NFKD_1112(NFKD_1112_map);
const static Trie NFKD_2032_2032_2032_2032(0x2057);
const static BranchMap NFKD_2032_2032_2032_map {
    {0x2032, NFKD_2032_2032_2032_2032}};
const static Trie NFKD_2032_2032_2032(0x2034, NFKD_2032_2032_2032_map);
const static BranchMap NFKD_2032_2032_map {
    {0x2032, NFKD_2032_2032_2032}};
const static Trie NFKD_2032_2032(0x2033, NFKD_2032_2032_map);
const static BranchMap NFKD_2032_map {
    {0x2032, NFKD_2032_2032}};
const static Trie NFKD_2032(NFKD_2032_map);
const static Trie NFKD_2035_2035_2035(0x2037);
const static BranchMap NFKD_2035_2035_map {
    {0x2035, NFKD_2035_2035_2035}};
const static Trie NFKD_2035_2035(0x2036, NFKD_2035_2035_map);
const static BranchMap NFKD_2035_map {
    {0x2035, NFKD_2035_2035}};
const static Trie NFKD_2035(NFKD_2035_map);
const static Trie NFKD_222B_222B_222B_222B(0x2A0C);
const static BranchMap NFKD_222B_222B_222B_map {
    {0x222B, NFKD_222B_222B_222B_222B}};
const static Trie NFKD_222B_222B_222B(0x222D, NFKD_222B_222B_222B_map);
const static BranchMap NFKD_222B_222B_map {
    {0x222B, NFKD_222B_222B_222B}};
const static Trie NFKD_222B_222B(0x222C, NFKD_222B_222B_map);
const static BranchMap NFKD_222B_map {
    {0x222B, NFKD_222B_222B}};
const static Trie NFKD_222B(NFKD_222B_map);
const static Trie NFKD_222E_222E_222E(0x2230);
const static BranchMap NFKD_222E_222E_map {
    {0x222E, NFKD_222E_222E_222E}};
const static Trie NFKD_222E_222E(0x222F, NFKD_222E_222E_map);
const static BranchMap NFKD_222E_map {
    {0x222E, NFKD_222E_222E}};
const static Trie NFKD_222E(NFKD_222E_map);
const static Trie NFKD_3014_53_3015(0x1F12A);
const static BranchMap NFKD_3014_53_map {
    {0x3015, NFKD_3014_53_3015}};
const static Trie NFKD_3014_53(NFKD_3014_53_map);
const static Trie NFKD_3014_4E09_3015(0x1F241);
const static BranchMap NFKD_3014_4E09_map {
    {0x3015, NFKD_3014_4E09_3015}};
const static Trie NFKD_3014_4E09(NFKD_3014_4E09_map);
const static Trie NFKD_3014_4E8C_3015(0x1F242);
const static BranchMap NFKD_3014_4E8C_map {
    {0x3015, NFKD_3014_4E8C_3015}};
const static Trie NFKD_3014_4E8C(NFKD_3014_4E8C_map);
const static Trie NFKD_3014_52DD_3015(0x1F247);
const static BranchMap NFKD_3014_52DD_map {
    {0x3015, NFKD_3014_52DD_3015}};
const static Trie NFKD_3014_52DD(NFKD_3014_52DD_map);
const static Trie NFKD_3014_5B89_3015(0x1F243);
const static BranchMap NFKD_3014_5B89_map {
    {0x3015, NFKD_3014_5B89_3015}};
const static Trie NFKD_3014_5B89(NFKD_3014_5B89_map);
const static Trie NFKD_3014_6253_3015(0x1F245);
const static BranchMap NFKD_3014_6253_map {
    {0x3015, NFKD_3014_6253_3015}};
const static Trie NFKD_3014_6253(NFKD_3014_6253_map);
const static Trie NFKD_3014_6557_3015(0x1F248);
const static BranchMap NFKD_3014_6557_map {
    {0x3015, NFKD_3014_6557_3015}};
const static Trie NFKD_3014_6557(NFKD_3014_6557_map);
const static Trie NFKD_3014_672C_3015(0x1F240);
const static BranchMap NFKD_3014_672C_map {
    {0x3015, NFKD_3014_672C_3015}};
const static Trie NFKD_3014_672C(NFKD_3014_672C_map);
const static Trie NFKD_3014_70B9_3015(0x1F244);
const static BranchMap NFKD_3014_70B9_map {
    {0x3015, NFKD_3014_70B9_3015}};
const static Trie NFKD_3014_70B9(NFKD_3014_70B9_map);
const static Trie NFKD_3014_76D7_3015(0x1F246);
const static BranchMap NFKD_3014_76D7_map {
    {0x3015, NFKD_3014_76D7_3015}};
const static Trie NFKD_3014_76D7(NFKD_3014_76D7_map);
const static BranchMap NFKD_3014_map {
    {0x53, NFKD_3014_53},
    {0x4E09, NFKD_3014_4E09},
    {0x4E8C, NFKD_3014_4E8C},
    {0x52DD, NFKD_3014_52DD},
    {0x5B89, NFKD_3014_5B89},
    {0x6253, NFKD_3014_6253},
    {0x6557, NFKD_3014_6557},
    {0x672C, NFKD_3014_672C},
    {0x70B9, NFKD_3014_70B9},
    {0x76D7, NFKD_3014_76D7}};
const static Trie NFKD_3014(NFKD_3014_map);
const static Trie NFKD_307B_304B(0x1F200);
const static BranchMap NFKD_307B_map {
    {0x304B, NFKD_307B_304B}};
const static Trie NFKD_307B(NFKD_307B_map);
const static Trie NFKD_3088_308A(0x309F);
const static BranchMap NFKD_3088_map {
    {0x308A, NFKD_3088_308A}};
const static Trie NFKD_3088(NFKD_3088_map);
const static Trie NFKD_30A2_30CF_309A_30FC_30C8(0x3300);
const static BranchMap NFKD_30A2_30CF_309A_30FC_map {
    {0x30C8, NFKD_30A2_30CF_309A_30FC_30C8}};
const static Trie NFKD_30A2_30CF_309A_30FC(NFKD_30A2_30CF_309A_30FC_map);
const static BranchMap NFKD_30A2_30CF_309A_map {
    {0x30FC, NFKD_30A2_30CF_309A_30FC}};
const static Trie NFKD_30A2_30CF_309A(NFKD_30A2_30CF_309A_map);
const static BranchMap NFKD_30A2_30CF_map {
    {0x309A, NFKD_30A2_30CF_309A}};
const static Trie NFKD_30A2_30CF(NFKD_30A2_30CF_map);
const static Trie NFKD_30A2_30EB_30D5_30A1(0x3301);
const static BranchMap NFKD_30A2_30EB_30D5_map {
    {0x30A1, NFKD_30A2_30EB_30D5_30A1}};
const static Trie NFKD_30A2_30EB_30D5(NFKD_30A2_30EB_30D5_map);
const static BranchMap NFKD_30A2_30EB_map {
    {0x30D5, NFKD_30A2_30EB_30D5}};
const static Trie NFKD_30A2_30EB(NFKD_30A2_30EB_map);
const static Trie NFKD_30A2_30F3_30D8_309A_30A2(0x3302);
const static BranchMap NFKD_30A2_30F3_30D8_309A_map {
    {0x30A2, NFKD_30A2_30F3_30D8_309A_30A2}};
const static Trie NFKD_30A2_30F3_30D8_309A(NFKD_30A2_30F3_30D8_309A_map);
const static BranchMap NFKD_30A2_30F3_30D8_map {
    {0x309A, NFKD_30A2_30F3_30D8_309A}};
const static Trie NFKD_30A2_30F3_30D8(NFKD_30A2_30F3_30D8_map);
const static BranchMap NFKD_30A2_30F3_map {
    {0x30D8, NFKD_30A2_30F3_30D8}};
const static Trie NFKD_30A2_30F3(NFKD_30A2_30F3_map);
const static Trie NFKD_30A2_30FC_30EB(0x3303);
const static BranchMap NFKD_30A2_30FC_map {
    {0x30EB, NFKD_30A2_30FC_30EB}};
const static Trie NFKD_30A2_30FC(NFKD_30A2_30FC_map);
const static BranchMap NFKD_30A2_map {
    {0x30CF, NFKD_30A2_30CF},
    {0x30EB, NFKD_30A2_30EB},
    {0x30F3, NFKD_30A2_30F3},
    {0x30FC, NFKD_30A2_30FC}};
const static Trie NFKD_30A2(NFKD_30A2_map);
const static Trie NFKD_30A4_30CB_30F3_30AF_3099(0x3304);
const static BranchMap NFKD_30A4_30CB_30F3_30AF_map {
    {0x3099, NFKD_30A4_30CB_30F3_30AF_3099}};
const static Trie NFKD_30A4_30CB_30F3_30AF(NFKD_30A4_30CB_30F3_30AF_map);
const static BranchMap NFKD_30A4_30CB_30F3_map {
    {0x30AF, NFKD_30A4_30CB_30F3_30AF}};
const static Trie NFKD_30A4_30CB_30F3(NFKD_30A4_30CB_30F3_map);
const static BranchMap NFKD_30A4_30CB_map {
    {0x30F3, NFKD_30A4_30CB_30F3}};
const static Trie NFKD_30A4_30CB(NFKD_30A4_30CB_map);
const static Trie NFKD_30A4_30F3_30C1(0x3305);
const static BranchMap NFKD_30A4_30F3_map {
    {0x30C1, NFKD_30A4_30F3_30C1}};
const static Trie NFKD_30A4_30F3(NFKD_30A4_30F3_map);
const static BranchMap NFKD_30A4_map {
    {0x30CB, NFKD_30A4_30CB},
    {0x30F3, NFKD_30A4_30F3}};
const static Trie NFKD_30A4(NFKD_30A4_map);
const static Trie NFKD_30A6_30A9_30F3(0x3306);
const static BranchMap NFKD_30A6_30A9_map {
    {0x30F3, NFKD_30A6_30A9_30F3}};
const static Trie NFKD_30A6_30A9(NFKD_30A6_30A9_map);
const static BranchMap NFKD_30A6_map {
    {0x30A9, NFKD_30A6_30A9}};
const static Trie NFKD_30A6(NFKD_30A6_map);
const static Trie NFKD_30A8_30B9_30AF_30FC_30C8_3099(0x3307);
const static BranchMap NFKD_30A8_30B9_30AF_30FC_30C8_map {
    {0x3099, NFKD_30A8_30B9_30AF_30FC_30C8_3099}};
const static Trie NFKD_30A8_30B9_30AF_30FC_30C8(NFKD_30A8_30B9_30AF_30FC_30C8_map);
const static BranchMap NFKD_30A8_30B9_30AF_30FC_map {
    {0x30C8, NFKD_30A8_30B9_30AF_30FC_30C8}};
const static Trie NFKD_30A8_30B9_30AF_30FC(NFKD_30A8_30B9_30AF_30FC_map);
const static BranchMap NFKD_30A8_30B9_30AF_map {
    {0x30FC, NFKD_30A8_30B9_30AF_30FC}};
const static Trie NFKD_30A8_30B9_30AF(NFKD_30A8_30B9_30AF_map);
const static BranchMap NFKD_30A8_30B9_map {
    {0x30AF, NFKD_30A8_30B9_30AF}};
const static Trie NFKD_30A8_30B9(NFKD_30A8_30B9_map);
const static Trie NFKD_30A8_30FC_30AB_30FC(0x3308);
const static BranchMap NFKD_30A8_30FC_30AB_map {
    {0x30FC, NFKD_30A8_30FC_30AB_30FC}};
const static Trie NFKD_30A8_30FC_30AB(NFKD_30A8_30FC_30AB_map);
const static BranchMap NFKD_30A8_30FC_map {
    {0x30AB, NFKD_30A8_30FC_30AB}};
const static Trie NFKD_30A8_30FC(NFKD_30A8_30FC_map);
const static BranchMap NFKD_30A8_map {
    {0x30B9, NFKD_30A8_30B9},
    {0x30FC, NFKD_30A8_30FC}};
const static Trie NFKD_30A8(NFKD_30A8_map);
const static Trie NFKD_30AA_30F3_30B9(0x3309);
const static BranchMap NFKD_30AA_30F3_map {
    {0x30B9, NFKD_30AA_30F3_30B9}};
const static Trie NFKD_30AA_30F3(NFKD_30AA_30F3_map);
const static Trie NFKD_30AA_30FC_30E0(0x330A);
const static BranchMap NFKD_30AA_30FC_map {
    {0x30E0, NFKD_30AA_30FC_30E0}};
const static Trie NFKD_30AA_30FC(NFKD_30AA_30FC_map);
const static BranchMap NFKD_30AA_map {
    {0x30F3, NFKD_30AA_30F3},
    {0x30FC, NFKD_30AA_30FC}};
const static Trie NFKD_30AA(NFKD_30AA_map);
const static Trie NFKD_30AB_3099_30ED_30F3(0x330E);
const static BranchMap NFKD_30AB_3099_30ED_map {
    {0x30F3, NFKD_30AB_3099_30ED_30F3}};
const static Trie NFKD_30AB_3099_30ED(NFKD_30AB_3099_30ED_map);
const static Trie NFKD_30AB_3099_30F3_30DE(0x330F);
const static BranchMap NFKD_30AB_3099_30F3_map {
    {0x30DE, NFKD_30AB_3099_30F3_30DE}};
const static Trie NFKD_30AB_3099_30F3(NFKD_30AB_3099_30F3_map);
const static BranchMap NFKD_30AB_3099_map {
    {0x30ED, NFKD_30AB_3099_30ED},
    {0x30F3, NFKD_30AB_3099_30F3}};
const static Trie NFKD_30AB_3099(NFKD_30AB_3099_map);
const static Trie NFKD_30AB_30A4_30EA(0x330B);
const static BranchMap NFKD_30AB_30A4_map {
    {0x30EA, NFKD_30AB_30A4_30EA}};
const static Trie NFKD_30AB_30A4(NFKD_30AB_30A4_map);
const static Trie NFKD_30AB_30E9_30C3_30C8(0x330C);
const static BranchMap NFKD_30AB_30E9_30C3_map {
    {0x30C8, NFKD_30AB_30E9_30C3_30C8}};
const static Trie NFKD_30AB_30E9_30C3(NFKD_30AB_30E9_30C3_map);
const static BranchMap NFKD_30AB_30E9_map {
    {0x30C3, NFKD_30AB_30E9_30C3}};
const static Trie NFKD_30AB_30E9(NFKD_30AB_30E9_map);
const static Trie NFKD_30AB_30ED_30EA_30FC(0x330D);
const static BranchMap NFKD_30AB_30ED_30EA_map {
    {0x30FC, NFKD_30AB_30ED_30EA_30FC}};
const static Trie NFKD_30AB_30ED_30EA(NFKD_30AB_30ED_30EA_map);
const static BranchMap NFKD_30AB_30ED_map {
    {0x30EA, NFKD_30AB_30ED_30EA}};
const static Trie NFKD_30AB_30ED(NFKD_30AB_30ED_map);
const static BranchMap NFKD_30AB_map {
    {0x3099, NFKD_30AB_3099},
    {0x30A4, NFKD_30AB_30A4},
    {0x30E9, NFKD_30AB_30E9},
    {0x30ED, NFKD_30AB_30ED}};
const static Trie NFKD_30AB(NFKD_30AB_map);
const static Trie NFKD_30AD_3099_30AB_3099(0x3310);
const static BranchMap NFKD_30AD_3099_30AB_map {
    {0x3099, NFKD_30AD_3099_30AB_3099}};
const static Trie NFKD_30AD_3099_30AB(NFKD_30AD_3099_30AB_map);
const static Trie NFKD_30AD_3099_30CB_30FC(0x3311);
const static BranchMap NFKD_30AD_3099_30CB_map {
    {0x30FC, NFKD_30AD_3099_30CB_30FC}};
const static Trie NFKD_30AD_3099_30CB(NFKD_30AD_3099_30CB_map);
const static Trie NFKD_30AD_3099_30EB_30BF_3099_30FC(0x3313);
const static BranchMap NFKD_30AD_3099_30EB_30BF_3099_map {
    {0x30FC, NFKD_30AD_3099_30EB_30BF_3099_30FC}};
const static Trie NFKD_30AD_3099_30EB_30BF_3099(NFKD_30AD_3099_30EB_30BF_3099_map);
const static BranchMap NFKD_30AD_3099_30EB_30BF_map {
    {0x3099, NFKD_30AD_3099_30EB_30BF_3099}};
const static Trie NFKD_30AD_3099_30EB_30BF(NFKD_30AD_3099_30EB_30BF_map);
const static BranchMap NFKD_30AD_3099_30EB_map {
    {0x30BF, NFKD_30AD_3099_30EB_30BF}};
const static Trie NFKD_30AD_3099_30EB(NFKD_30AD_3099_30EB_map);
const static BranchMap NFKD_30AD_3099_map {
    {0x30AB, NFKD_30AD_3099_30AB},
    {0x30CB, NFKD_30AD_3099_30CB},
    {0x30EB, NFKD_30AD_3099_30EB}};
const static Trie NFKD_30AD_3099(NFKD_30AD_3099_map);
const static Trie NFKD_30AD_30E5_30EA_30FC(0x3312);
const static BranchMap NFKD_30AD_30E5_30EA_map {
    {0x30FC, NFKD_30AD_30E5_30EA_30FC}};
const static Trie NFKD_30AD_30E5_30EA(NFKD_30AD_30E5_30EA_map);
const static BranchMap NFKD_30AD_30E5_map {
    {0x30EA, NFKD_30AD_30E5_30EA}};
const static Trie NFKD_30AD_30E5(NFKD_30AD_30E5_map);
const static Trie NFKD_30AD_30ED_30AF_3099_30E9_30E0(0x3315);
const static BranchMap NFKD_30AD_30ED_30AF_3099_30E9_map {
    {0x30E0, NFKD_30AD_30ED_30AF_3099_30E9_30E0}};
const static Trie NFKD_30AD_30ED_30AF_3099_30E9(NFKD_30AD_30ED_30AF_3099_30E9_map);
const static BranchMap NFKD_30AD_30ED_30AF_3099_map {
    {0x30E9, NFKD_30AD_30ED_30AF_3099_30E9}};
const static Trie NFKD_30AD_30ED_30AF_3099(NFKD_30AD_30ED_30AF_3099_map);
const static BranchMap NFKD_30AD_30ED_30AF_map {
    {0x3099, NFKD_30AD_30ED_30AF_3099}};
const static Trie NFKD_30AD_30ED_30AF(NFKD_30AD_30ED_30AF_map);
const static Trie NFKD_30AD_30ED_30E1_30FC_30C8_30EB(0x3316);
const static BranchMap NFKD_30AD_30ED_30E1_30FC_30C8_map {
    {0x30EB, NFKD_30AD_30ED_30E1_30FC_30C8_30EB}};
const static Trie NFKD_30AD_30ED_30E1_30FC_30C8(NFKD_30AD_30ED_30E1_30FC_30C8_map);
const static BranchMap NFKD_30AD_30ED_30E1_30FC_map {
    {0x30C8, NFKD_30AD_30ED_30E1_30FC_30C8}};
const static Trie NFKD_30AD_30ED_30E1_30FC(NFKD_30AD_30ED_30E1_30FC_map);
const static BranchMap NFKD_30AD_30ED_30E1_map {
    {0x30FC, NFKD_30AD_30ED_30E1_30FC}};
const static Trie NFKD_30AD_30ED_30E1(NFKD_30AD_30ED_30E1_map);
const static Trie NFKD_30AD_30ED_30EF_30C3_30C8(0x3317);
const static BranchMap NFKD_30AD_30ED_30EF_30C3_map {
    {0x30C8, NFKD_30AD_30ED_30EF_30C3_30C8}};
const static Trie NFKD_30AD_30ED_30EF_30C3(NFKD_30AD_30ED_30EF_30C3_map);
const static BranchMap NFKD_30AD_30ED_30EF_map {
    {0x30C3, NFKD_30AD_30ED_30EF_30C3}};
const static Trie NFKD_30AD_30ED_30EF(NFKD_30AD_30ED_30EF_map);
const static BranchMap NFKD_30AD_30ED_map {
    {0x30AF, NFKD_30AD_30ED_30AF},
    {0x30E1, NFKD_30AD_30ED_30E1},
    {0x30EF, NFKD_30AD_30ED_30EF}};
const static Trie NFKD_30AD_30ED(0x3314, NFKD_30AD_30ED_map);
const static BranchMap NFKD_30AD_map {
    {0x3099, NFKD_30AD_3099},
    {0x30E5, NFKD_30AD_30E5},
    {0x30ED, NFKD_30AD_30ED}};
const static Trie NFKD_30AD(NFKD_30AD_map);
const static Trie NFKD_30AF_3099_30E9_30E0_30C8_30F3(0x3319);
const static BranchMap NFKD_30AF_3099_30E9_30E0_30C8_map {
    {0x30F3, NFKD_30AF_3099_30E9_30E0_30C8_30F3}};
const static Trie NFKD_30AF_3099_30E9_30E0_30C8(NFKD_30AF_3099_30E9_30E0_30C8_map);
const static BranchMap NFKD_30AF_3099_30E9_30E0_map {
    {0x30C8, NFKD_30AF_3099_30E9_30E0_30C8}};
const static Trie NFKD_30AF_3099_30E9_30E0(0x3318, NFKD_30AF_3099_30E9_30E0_map);
const static BranchMap NFKD_30AF_3099_30E9_map {
    {0x30E0, NFKD_30AF_3099_30E9_30E0}};
const static Trie NFKD_30AF_3099_30E9(NFKD_30AF_3099_30E9_map);
const static BranchMap NFKD_30AF_3099_map {
    {0x30E9, NFKD_30AF_3099_30E9}};
const static Trie NFKD_30AF_3099(NFKD_30AF_3099_map);
const static Trie NFKD_30AF_30EB_30BB_3099_30A4_30ED(0x331A);
const static BranchMap NFKD_30AF_30EB_30BB_3099_30A4_map {
    {0x30ED, NFKD_30AF_30EB_30BB_3099_30A4_30ED}};
const static Trie NFKD_30AF_30EB_30BB_3099_30A4(NFKD_30AF_30EB_30BB_3099_30A4_map);
const static BranchMap NFKD_30AF_30EB_30BB_3099_map {
    {0x30A4, NFKD_30AF_30EB_30BB_3099_30A4}};
const static Trie NFKD_30AF_30EB_30BB_3099(NFKD_30AF_30EB_30BB_3099_map);
const static BranchMap NFKD_30AF_30EB_30BB_map {
    {0x3099, NFKD_30AF_30EB_30BB_3099}};
const static Trie NFKD_30AF_30EB_30BB(NFKD_30AF_30EB_30BB_map);
const static BranchMap NFKD_30AF_30EB_map {
    {0x30BB, NFKD_30AF_30EB_30BB}};
const static Trie NFKD_30AF_30EB(NFKD_30AF_30EB_map);
const static Trie NFKD_30AF_30ED_30FC_30CD(0x331B);
const static BranchMap NFKD_30AF_30ED_30FC_map {
    {0x30CD, NFKD_30AF_30ED_30FC_30CD}};
const static Trie NFKD_30AF_30ED_30FC(NFKD_30AF_30ED_30FC_map);
const static BranchMap NFKD_30AF_30ED_map {
    {0x30FC, NFKD_30AF_30ED_30FC}};
const static Trie NFKD_30AF_30ED(NFKD_30AF_30ED_map);
const static BranchMap NFKD_30AF_map {
    {0x3099, NFKD_30AF_3099},
    {0x30EB, NFKD_30AF_30EB},
    {0x30ED, NFKD_30AF_30ED}};
const static Trie NFKD_30AF(NFKD_30AF_map);
const static Trie NFKD_30B1_30FC_30B9(0x331C);
const static BranchMap NFKD_30B1_30FC_map {
    {0x30B9, NFKD_30B1_30FC_30B9}};
const static Trie NFKD_30B1_30FC(NFKD_30B1_30FC_map);
const static BranchMap NFKD_30B1_map {
    {0x30FC, NFKD_30B1_30FC}};
const static Trie NFKD_30B1(NFKD_30B1_map);
const static Trie NFKD_30B3_30B3(0x1F201);
const static Trie NFKD_30B3_30C8(0x30FF);
const static Trie NFKD_30B3_30EB_30CA(0x331D);
const static BranchMap NFKD_30B3_30EB_map {
    {0x30CA, NFKD_30B3_30EB_30CA}};
const static Trie NFKD_30B3_30EB(NFKD_30B3_30EB_map);
const static Trie NFKD_30B3_30FC_30DB_309A(0x331E);
const static BranchMap NFKD_30B3_30FC_30DB_map {
    {0x309A, NFKD_30B3_30FC_30DB_309A}};
const static Trie NFKD_30B3_30FC_30DB(NFKD_30B3_30FC_30DB_map);
const static BranchMap NFKD_30B3_30FC_map {
    {0x30DB, NFKD_30B3_30FC_30DB}};
const static Trie NFKD_30B3_30FC(NFKD_30B3_30FC_map);
const static BranchMap NFKD_30B3_map {
    {0x30B3, NFKD_30B3_30B3},
    {0x30C8, NFKD_30B3_30C8},
    {0x30EB, NFKD_30B3_30EB},
    {0x30FC, NFKD_30B3_30FC}};
const static Trie NFKD_30B3(NFKD_30B3_map);
const static Trie NFKD_30B5_30A4_30AF_30EB(0x331F);
const static BranchMap NFKD_30B5_30A4_30AF_map {
    {0x30EB, NFKD_30B5_30A4_30AF_30EB}};
const static Trie NFKD_30B5_30A4_30AF(NFKD_30B5_30A4_30AF_map);
const static BranchMap NFKD_30B5_30A4_map {
    {0x30AF, NFKD_30B5_30A4_30AF}};
const static Trie NFKD_30B5_30A4(NFKD_30B5_30A4_map);
const static Trie NFKD_30B5_30F3_30C1_30FC_30E0(0x3320);
const static BranchMap NFKD_30B5_30F3_30C1_30FC_map {
    {0x30E0, NFKD_30B5_30F3_30C1_30FC_30E0}};
const static Trie NFKD_30B5_30F3_30C1_30FC(NFKD_30B5_30F3_30C1_30FC_map);
const static BranchMap NFKD_30B5_30F3_30C1_map {
    {0x30FC, NFKD_30B5_30F3_30C1_30FC}};
const static Trie NFKD_30B5_30F3_30C1(NFKD_30B5_30F3_30C1_map);
const static BranchMap NFKD_30B5_30F3_map {
    {0x30C1, NFKD_30B5_30F3_30C1}};
const static Trie NFKD_30B5_30F3(NFKD_30B5_30F3_map);
const static BranchMap NFKD_30B5_map {
    {0x30A4, NFKD_30B5_30A4},
    {0x30F3, NFKD_30B5_30F3}};
const static Trie NFKD_30B5(NFKD_30B5_map);
const static Trie NFKD_30B7_30EA_30F3_30AF_3099(0x3321);
const static BranchMap NFKD_30B7_30EA_30F3_30AF_map {
    {0x3099, NFKD_30B7_30EA_30F3_30AF_3099}};
const static Trie NFKD_30B7_30EA_30F3_30AF(NFKD_30B7_30EA_30F3_30AF_map);
const static BranchMap NFKD_30B7_30EA_30F3_map {
    {0x30AF, NFKD_30B7_30EA_30F3_30AF}};
const static Trie NFKD_30B7_30EA_30F3(NFKD_30B7_30EA_30F3_map);
const static BranchMap NFKD_30B7_30EA_map {
    {0x30F3, NFKD_30B7_30EA_30F3}};
const static Trie NFKD_30B7_30EA(NFKD_30B7_30EA_map);
const static BranchMap NFKD_30B7_map {
    {0x30EA, NFKD_30B7_30EA}};
const static Trie NFKD_30B7(NFKD_30B7_map);
const static Trie NFKD_30BB_30F3_30C1(0x3322);
const static Trie NFKD_30BB_30F3_30C8(0x3323);
const static BranchMap NFKD_30BB_30F3_map {
    {0x30C1, NFKD_30BB_30F3_30C1},
    {0x30C8, NFKD_30BB_30F3_30C8}};
const static Trie NFKD_30BB_30F3(NFKD_30BB_30F3_map);
const static BranchMap NFKD_30BB_map {
    {0x30F3, NFKD_30BB_30F3}};
const static Trie NFKD_30BB(NFKD_30BB_map);
const static Trie NFKD_30BF_3099_30FC_30B9(0x3324);
const static BranchMap NFKD_30BF_3099_30FC_map {
    {0x30B9, NFKD_30BF_3099_30FC_30B9}};
const static Trie NFKD_30BF_3099_30FC(NFKD_30BF_3099_30FC_map);
const static BranchMap NFKD_30BF_3099_map {
    {0x30FC, NFKD_30BF_3099_30FC}};
const static Trie NFKD_30BF_3099(NFKD_30BF_3099_map);
const static BranchMap NFKD_30BF_map {
    {0x3099, NFKD_30BF_3099}};
const static Trie NFKD_30BF(NFKD_30BF_map);
const static Trie NFKD_30C6_3099_30B7(0x3325);
const static BranchMap NFKD_30C6_3099_map {
    {0x30B7, NFKD_30C6_3099_30B7}};
const static Trie NFKD_30C6_3099(0x1F213, NFKD_30C6_3099_map);
const static BranchMap NFKD_30C6_map {
    {0x3099, NFKD_30C6_3099}};
const static Trie NFKD_30C6(NFKD_30C6_map);
const static Trie NFKD_30C8_3099_30EB(0x3326);
const static BranchMap NFKD_30C8_3099_map {
    {0x30EB, NFKD_30C8_3099_30EB}};
const static Trie NFKD_30C8_3099(NFKD_30C8_3099_map);
const static Trie NFKD_30C8_30F3(0x3327);
const static BranchMap NFKD_30C8_map {
    {0x3099, NFKD_30C8_3099},
    {0x30F3, NFKD_30C8_30F3}};
const static Trie NFKD_30C8(NFKD_30C8_map);
const static Trie NFKD_30CA_30CE(0x3328);
const static BranchMap NFKD_30CA_map {
    {0x30CE, NFKD_30CA_30CE}};
const static Trie NFKD_30CA(NFKD_30CA_map);
const static Trie NFKD_30CE_30C3_30C8(0x3329);
const static BranchMap NFKD_30CE_30C3_map {
    {0x30C8, NFKD_30CE_30C3_30C8}};
const static Trie NFKD_30CE_30C3(NFKD_30CE_30C3_map);
const static BranchMap NFKD_30CE_map {
    {0x30C3, NFKD_30CE_30C3}};
const static Trie NFKD_30CE(NFKD_30CE_map);
const static Trie NFKD_30CF_3099_30FC_30EC_30EB(0x332D);
const static BranchMap NFKD_30CF_3099_30FC_30EC_map {
    {0x30EB, NFKD_30CF_3099_30FC_30EC_30EB}};
const static Trie NFKD_30CF_3099_30FC_30EC(NFKD_30CF_3099_30FC_30EC_map);
const static BranchMap NFKD_30CF_3099_30FC_map {
    {0x30EC, NFKD_30CF_3099_30FC_30EC}};
const static Trie NFKD_30CF_3099_30FC(NFKD_30CF_3099_30FC_map);
const static BranchMap NFKD_30CF_3099_map {
    {0x30FC, NFKD_30CF_3099_30FC}};
const static Trie NFKD_30CF_3099(NFKD_30CF_3099_map);
const static Trie NFKD_30CF_309A_30FC_30BB_30F3_30C8(0x332B);
const static BranchMap NFKD_30CF_309A_30FC_30BB_30F3_map {
    {0x30C8, NFKD_30CF_309A_30FC_30BB_30F3_30C8}};
const static Trie NFKD_30CF_309A_30FC_30BB_30F3(NFKD_30CF_309A_30FC_30BB_30F3_map);
const static BranchMap NFKD_30CF_309A_30FC_30BB_map {
    {0x30F3, NFKD_30CF_309A_30FC_30BB_30F3}};
const static Trie NFKD_30CF_309A_30FC_30BB(NFKD_30CF_309A_30FC_30BB_map);
const static Trie NFKD_30CF_309A_30FC_30C4(0x332C);
const static BranchMap NFKD_30CF_309A_30FC_map {
    {0x30BB, NFKD_30CF_309A_30FC_30BB},
    {0x30C4, NFKD_30CF_309A_30FC_30C4}};
const static Trie NFKD_30CF_309A_30FC(NFKD_30CF_309A_30FC_map);
const static BranchMap NFKD_30CF_309A_map {
    {0x30FC, NFKD_30CF_309A_30FC}};
const static Trie NFKD_30CF_309A(NFKD_30CF_309A_map);
const static Trie NFKD_30CF_30A4_30C4(0x332A);
const static BranchMap NFKD_30CF_30A4_map {
    {0x30C4, NFKD_30CF_30A4_30C4}};
const static Trie NFKD_30CF_30A4(NFKD_30CF_30A4_map);
const static BranchMap NFKD_30CF_map {
    {0x3099, NFKD_30CF_3099},
    {0x309A, NFKD_30CF_309A},
    {0x30A4, NFKD_30CF_30A4}};
const static Trie NFKD_30CF(NFKD_30CF_map);
const static Trie NFKD_30D2_3099_30EB(0x3331);
const static BranchMap NFKD_30D2_3099_map {
    {0x30EB, NFKD_30D2_3099_30EB}};
const static Trie NFKD_30D2_3099(NFKD_30D2_3099_map);
const static Trie NFKD_30D2_309A_30A2_30B9_30C8_30EB(0x332E);
const static BranchMap NFKD_30D2_309A_30A2_30B9_30C8_map {
    {0x30EB, NFKD_30D2_309A_30A2_30B9_30C8_30EB}};
const static Trie NFKD_30D2_309A_30A2_30B9_30C8(NFKD_30D2_309A_30A2_30B9_30C8_map);
const static BranchMap NFKD_30D2_309A_30A2_30B9_map {
    {0x30C8, NFKD_30D2_309A_30A2_30B9_30C8}};
const static Trie NFKD_30D2_309A_30A2_30B9(NFKD_30D2_309A_30A2_30B9_map);
const static BranchMap NFKD_30D2_309A_30A2_map {
    {0x30B9, NFKD_30D2_309A_30A2_30B9}};
const static Trie NFKD_30D2_309A_30A2(NFKD_30D2_309A_30A2_map);
const static Trie NFKD_30D2_309A_30AF_30EB(0x332F);
const static BranchMap NFKD_30D2_309A_30AF_map {
    {0x30EB, NFKD_30D2_309A_30AF_30EB}};
const static Trie NFKD_30D2_309A_30AF(NFKD_30D2_309A_30AF_map);
const static Trie NFKD_30D2_309A_30B3(0x3330);
const static BranchMap NFKD_30D2_309A_map {
    {0x30A2, NFKD_30D2_309A_30A2},
    {0x30AF, NFKD_30D2_309A_30AF},
    {0x30B3, NFKD_30D2_309A_30B3}};
const static Trie NFKD_30D2_309A(NFKD_30D2_309A_map);
const static BranchMap NFKD_30D2_map {
    {0x3099, NFKD_30D2_3099},
    {0x309A, NFKD_30D2_309A}};
const static Trie NFKD_30D2(NFKD_30D2_map);
const static Trie NFKD_30D5_3099_30C3_30B7_30A7_30EB(0x3334);
const static BranchMap NFKD_30D5_3099_30C3_30B7_30A7_map {
    {0x30EB, NFKD_30D5_3099_30C3_30B7_30A7_30EB}};
const static Trie NFKD_30D5_3099_30C3_30B7_30A7(NFKD_30D5_3099_30C3_30B7_30A7_map);
const static BranchMap NFKD_30D5_3099_30C3_30B7_map {
    {0x30A7, NFKD_30D5_3099_30C3_30B7_30A7}};
const static Trie NFKD_30D5_3099_30C3_30B7(NFKD_30D5_3099_30C3_30B7_map);
const static BranchMap NFKD_30D5_3099_30C3_map {
    {0x30B7, NFKD_30D5_3099_30C3_30B7}};
const static Trie NFKD_30D5_3099_30C3(NFKD_30D5_3099_30C3_map);
const static BranchMap NFKD_30D5_3099_map {
    {0x30C3, NFKD_30D5_3099_30C3}};
const static Trie NFKD_30D5_3099(NFKD_30D5_3099_map);
const static Trie NFKD_30D5_30A1_30E9_30C3_30C8_3099(0x3332);
const static BranchMap NFKD_30D5_30A1_30E9_30C3_30C8_map {
    {0x3099, NFKD_30D5_30A1_30E9_30C3_30C8_3099}};
const static Trie NFKD_30D5_30A1_30E9_30C3_30C8(NFKD_30D5_30A1_30E9_30C3_30C8_map);
const static BranchMap NFKD_30D5_30A1_30E9_30C3_map {
    {0x30C8, NFKD_30D5_30A1_30E9_30C3_30C8}};
const static Trie NFKD_30D5_30A1_30E9_30C3(NFKD_30D5_30A1_30E9_30C3_map);
const static BranchMap NFKD_30D5_30A1_30E9_map {
    {0x30C3, NFKD_30D5_30A1_30E9_30C3}};
const static Trie NFKD_30D5_30A1_30E9(NFKD_30D5_30A1_30E9_map);
const static BranchMap NFKD_30D5_30A1_map {
    {0x30E9, NFKD_30D5_30A1_30E9}};
const static Trie NFKD_30D5_30A1(NFKD_30D5_30A1_map);
const static Trie NFKD_30D5_30A3_30FC_30C8(0x3333);
const static BranchMap NFKD_30D5_30A3_30FC_map {
    {0x30C8, NFKD_30D5_30A3_30FC_30C8}};
const static Trie NFKD_30D5_30A3_30FC(NFKD_30D5_30A3_30FC_map);
const static BranchMap NFKD_30D5_30A3_map {
    {0x30FC, NFKD_30D5_30A3_30FC}};
const static Trie NFKD_30D5_30A3(NFKD_30D5_30A3_map);
const static Trie NFKD_30D5_30E9_30F3(0x3335);
const static BranchMap NFKD_30D5_30E9_map {
    {0x30F3, NFKD_30D5_30E9_30F3}};
const static Trie NFKD_30D5_30E9(NFKD_30D5_30E9_map);
const static BranchMap NFKD_30D5_map {
    {0x3099, NFKD_30D5_3099},
    {0x30A1, NFKD_30D5_30A1},
    {0x30A3, NFKD_30D5_30A3},
    {0x30E9, NFKD_30D5_30E9}};
const static Trie NFKD_30D5(NFKD_30D5_map);
const static Trie NFKD_30D8_3099_30FC_30BF(0x333C);
const static BranchMap NFKD_30D8_3099_30FC_map {
    {0x30BF, NFKD_30D8_3099_30FC_30BF}};
const static Trie NFKD_30D8_3099_30FC(NFKD_30D8_3099_30FC_map);
const static BranchMap NFKD_30D8_3099_map {
    {0x30FC, NFKD_30D8_3099_30FC}};
const static Trie NFKD_30D8_3099(NFKD_30D8_3099_map);
const static Trie NFKD_30D8_309A_30BD(0x3337);
const static Trie NFKD_30D8_309A_30CB_30D2(0x3338);
const static BranchMap NFKD_30D8_309A_30CB_map {
    {0x30D2, NFKD_30D8_309A_30CB_30D2}};
const static Trie NFKD_30D8_309A_30CB(NFKD_30D8_309A_30CB_map);
const static Trie NFKD_30D8_309A_30F3_30B9(0x333A);
const static BranchMap NFKD_30D8_309A_30F3_map {
    {0x30B9, NFKD_30D8_309A_30F3_30B9}};
const static Trie NFKD_30D8_309A_30F3(NFKD_30D8_309A_30F3_map);
const static Trie NFKD_30D8_309A_30FC_30B7_3099(0x333B);
const static BranchMap NFKD_30D8_309A_30FC_30B7_map {
    {0x3099, NFKD_30D8_309A_30FC_30B7_3099}};
const static Trie NFKD_30D8_309A_30FC_30B7(NFKD_30D8_309A_30FC_30B7_map);
const static BranchMap NFKD_30D8_309A_30FC_map {
    {0x30B7, NFKD_30D8_309A_30FC_30B7}};
const static Trie NFKD_30D8_309A_30FC(NFKD_30D8_309A_30FC_map);
const static BranchMap NFKD_30D8_309A_map {
    {0x30BD, NFKD_30D8_309A_30BD},
    {0x30CB, NFKD_30D8_309A_30CB},
    {0x30F3, NFKD_30D8_309A_30F3},
    {0x30FC, NFKD_30D8_309A_30FC}};
const static Trie NFKD_30D8_309A(NFKD_30D8_309A_map);
const static Trie NFKD_30D8_30AF_30BF_30FC_30EB(0x3336);
const static BranchMap NFKD_30D8_30AF_30BF_30FC_map {
    {0x30EB, NFKD_30D8_30AF_30BF_30FC_30EB}};
const static Trie NFKD_30D8_30AF_30BF_30FC(NFKD_30D8_30AF_30BF_30FC_map);
const static BranchMap NFKD_30D8_30AF_30BF_map {
    {0x30FC, NFKD_30D8_30AF_30BF_30FC}};
const static Trie NFKD_30D8_30AF_30BF(NFKD_30D8_30AF_30BF_map);
const static BranchMap NFKD_30D8_30AF_map {
    {0x30BF, NFKD_30D8_30AF_30BF}};
const static Trie NFKD_30D8_30AF(NFKD_30D8_30AF_map);
const static Trie NFKD_30D8_30EB_30C4(0x3339);
const static BranchMap NFKD_30D8_30EB_map {
    {0x30C4, NFKD_30D8_30EB_30C4}};
const static Trie NFKD_30D8_30EB(NFKD_30D8_30EB_map);
const static BranchMap NFKD_30D8_map {
    {0x3099, NFKD_30D8_3099},
    {0x309A, NFKD_30D8_309A},
    {0x30AF, NFKD_30D8_30AF},
    {0x30EB, NFKD_30D8_30EB}};
const static Trie NFKD_30D8(NFKD_30D8_map);
const static Trie NFKD_30DB_3099_30EB_30C8(0x333E);
const static BranchMap NFKD_30DB_3099_30EB_map {
    {0x30C8, NFKD_30DB_3099_30EB_30C8}};
const static Trie NFKD_30DB_3099_30EB(NFKD_30DB_3099_30EB_map);
const static BranchMap NFKD_30DB_3099_map {
    {0x30EB, NFKD_30DB_3099_30EB}};
const static Trie NFKD_30DB_3099(NFKD_30DB_3099_map);
const static Trie NFKD_30DB_309A_30A4_30F3_30C8(0x333D);
const static BranchMap NFKD_30DB_309A_30A4_30F3_map {
    {0x30C8, NFKD_30DB_309A_30A4_30F3_30C8}};
const static Trie NFKD_30DB_309A_30A4_30F3(NFKD_30DB_309A_30A4_30F3_map);
const static BranchMap NFKD_30DB_309A_30A4_map {
    {0x30F3, NFKD_30DB_309A_30A4_30F3}};
const static Trie NFKD_30DB_309A_30A4(NFKD_30DB_309A_30A4_map);
const static Trie NFKD_30DB_309A_30F3_30C8_3099(0x3340);
const static BranchMap NFKD_30DB_309A_30F3_30C8_map {
    {0x3099, NFKD_30DB_309A_30F3_30C8_3099}};
const static Trie NFKD_30DB_309A_30F3_30C8(NFKD_30DB_309A_30F3_30C8_map);
const static BranchMap NFKD_30DB_309A_30F3_map {
    {0x30C8, NFKD_30DB_309A_30F3_30C8}};
const static Trie NFKD_30DB_309A_30F3(NFKD_30DB_309A_30F3_map);
const static BranchMap NFKD_30DB_309A_map {
    {0x30A4, NFKD_30DB_309A_30A4},
    {0x30F3, NFKD_30DB_309A_30F3}};
const static Trie NFKD_30DB_309A(NFKD_30DB_309A_map);
const static Trie NFKD_30DB_30F3(0x333F);
const static Trie NFKD_30DB_30FC_30EB(0x3341);
const static Trie NFKD_30DB_30FC_30F3(0x3342);
const static BranchMap NFKD_30DB_30FC_map {
    {0x30EB, NFKD_30DB_30FC_30EB},
    {0x30F3, NFKD_30DB_30FC_30F3}};
const static Trie NFKD_30DB_30FC(NFKD_30DB_30FC_map);
const static BranchMap NFKD_30DB_map {
    {0x3099, NFKD_30DB_3099},
    {0x309A, NFKD_30DB_309A},
    {0x30F3, NFKD_30DB_30F3},
    {0x30FC, NFKD_30DB_30FC}};
const static Trie NFKD_30DB(NFKD_30DB_map);
const static Trie NFKD_30DE_30A4_30AF_30ED(0x3343);
const static BranchMap NFKD_30DE_30A4_30AF_map {
    {0x30ED, NFKD_30DE_30A4_30AF_30ED}};
const static Trie NFKD_30DE_30A4_30AF(NFKD_30DE_30A4_30AF_map);
const static Trie NFKD_30DE_30A4_30EB(0x3344);
const static BranchMap NFKD_30DE_30A4_map {
    {0x30AF, NFKD_30DE_30A4_30AF},
    {0x30EB, NFKD_30DE_30A4_30EB}};
const static Trie NFKD_30DE_30A4(NFKD_30DE_30A4_map);
const static Trie NFKD_30DE_30C3_30CF(0x3345);
const static BranchMap NFKD_30DE_30C3_map {
    {0x30CF, NFKD_30DE_30C3_30CF}};
const static Trie NFKD_30DE_30C3(NFKD_30DE_30C3_map);
const static Trie NFKD_30DE_30EB_30AF(0x3346);
const static BranchMap NFKD_30DE_30EB_map {
    {0x30AF, NFKD_30DE_30EB_30AF}};
const static Trie NFKD_30DE_30EB(NFKD_30DE_30EB_map);
const static Trie NFKD_30DE_30F3_30B7_30E7_30F3(0x3347);
const static BranchMap NFKD_30DE_30F3_30B7_30E7_map {
    {0x30F3, NFKD_30DE_30F3_30B7_30E7_30F3}};
const static Trie NFKD_30DE_30F3_30B7_30E7(NFKD_30DE_30F3_30B7_30E7_map);
const static BranchMap NFKD_30DE_30F3_30B7_map {
    {0x30E7, NFKD_30DE_30F3_30B7_30E7}};
const static Trie NFKD_30DE_30F3_30B7(NFKD_30DE_30F3_30B7_map);
const static BranchMap NFKD_30DE_30F3_map {
    {0x30B7, NFKD_30DE_30F3_30B7}};
const static Trie NFKD_30DE_30F3(NFKD_30DE_30F3_map);
const static BranchMap NFKD_30DE_map {
    {0x30A4, NFKD_30DE_30A4},
    {0x30C3, NFKD_30DE_30C3},
    {0x30EB, NFKD_30DE_30EB},
    {0x30F3, NFKD_30DE_30F3}};
const static Trie NFKD_30DE(NFKD_30DE_map);
const static Trie NFKD_30DF_30AF_30ED_30F3(0x3348);
const static BranchMap NFKD_30DF_30AF_30ED_map {
    {0x30F3, NFKD_30DF_30AF_30ED_30F3}};
const static Trie NFKD_30DF_30AF_30ED(NFKD_30DF_30AF_30ED_map);
const static BranchMap NFKD_30DF_30AF_map {
    {0x30ED, NFKD_30DF_30AF_30ED}};
const static Trie NFKD_30DF_30AF(NFKD_30DF_30AF_map);
const static Trie NFKD_30DF_30EA_30CF_3099_30FC_30EB(0x334A);
const static BranchMap NFKD_30DF_30EA_30CF_3099_30FC_map {
    {0x30EB, NFKD_30DF_30EA_30CF_3099_30FC_30EB}};
const static Trie NFKD_30DF_30EA_30CF_3099_30FC(NFKD_30DF_30EA_30CF_3099_30FC_map);
const static BranchMap NFKD_30DF_30EA_30CF_3099_map {
    {0x30FC, NFKD_30DF_30EA_30CF_3099_30FC}};
const static Trie NFKD_30DF_30EA_30CF_3099(NFKD_30DF_30EA_30CF_3099_map);
const static BranchMap NFKD_30DF_30EA_30CF_map {
    {0x3099, NFKD_30DF_30EA_30CF_3099}};
const static Trie NFKD_30DF_30EA_30CF(NFKD_30DF_30EA_30CF_map);
const static BranchMap NFKD_30DF_30EA_map {
    {0x30CF, NFKD_30DF_30EA_30CF}};
const static Trie NFKD_30DF_30EA(0x3349, NFKD_30DF_30EA_map);
const static BranchMap NFKD_30DF_map {
    {0x30AF, NFKD_30DF_30AF},
    {0x30EA, NFKD_30DF_30EA}};
const static Trie NFKD_30DF(NFKD_30DF_map);
const static Trie NFKD_30E1_30AB_3099_30C8_30F3(0x334C);
const static BranchMap NFKD_30E1_30AB_3099_30C8_map {
    {0x30F3, NFKD_30E1_30AB_3099_30C8_30F3}};
const static Trie NFKD_30E1_30AB_3099_30C8(NFKD_30E1_30AB_3099_30C8_map);
const static BranchMap NFKD_30E1_30AB_3099_map {
    {0x30C8, NFKD_30E1_30AB_3099_30C8}};
const static Trie NFKD_30E1_30AB_3099(0x334B, NFKD_30E1_30AB_3099_map);
const static BranchMap NFKD_30E1_30AB_map {
    {0x3099, NFKD_30E1_30AB_3099}};
const static Trie NFKD_30E1_30AB(NFKD_30E1_30AB_map);
const static Trie NFKD_30E1_30FC_30C8_30EB(0x334D);
const static BranchMap NFKD_30E1_30FC_30C8_map {
    {0x30EB, NFKD_30E1_30FC_30C8_30EB}};
const static Trie NFKD_30E1_30FC_30C8(NFKD_30E1_30FC_30C8_map);
const static BranchMap NFKD_30E1_30FC_map {
    {0x30C8, NFKD_30E1_30FC_30C8}};
const static Trie NFKD_30E1_30FC(NFKD_30E1_30FC_map);
const static BranchMap NFKD_30E1_map {
    {0x30AB, NFKD_30E1_30AB},
    {0x30FC, NFKD_30E1_30FC}};
const static Trie NFKD_30E1(NFKD_30E1_map);
const static Trie NFKD_30E4_30FC_30C8_3099(0x334E);
const static BranchMap NFKD_30E4_30FC_30C8_map {
    {0x3099, NFKD_30E4_30FC_30C8_3099}};
const static Trie NFKD_30E4_30FC_30C8(NFKD_30E4_30FC_30C8_map);
const static Trie NFKD_30E4_30FC_30EB(0x334F);
const static BranchMap NFKD_30E4_30FC_map {
    {0x30C8, NFKD_30E4_30FC_30C8},
    {0x30EB, NFKD_30E4_30FC_30EB}};
const static Trie NFKD_30E4_30FC(NFKD_30E4_30FC_map);
const static BranchMap NFKD_30E4_map {
    {0x30FC, NFKD_30E4_30FC}};
const static Trie NFKD_30E4(NFKD_30E4_map);
const static Trie NFKD_30E6_30A2_30F3(0x3350);
const static BranchMap NFKD_30E6_30A2_map {
    {0x30F3, NFKD_30E6_30A2_30F3}};
const static Trie NFKD_30E6_30A2(NFKD_30E6_30A2_map);
const static BranchMap NFKD_30E6_map {
    {0x30A2, NFKD_30E6_30A2}};
const static Trie NFKD_30E6(NFKD_30E6_map);
const static Trie NFKD_30EA_30C3_30C8_30EB(0x3351);
const static BranchMap NFKD_30EA_30C3_30C8_map {
    {0x30EB, NFKD_30EA_30C3_30C8_30EB}};
const static Trie NFKD_30EA_30C3_30C8(NFKD_30EA_30C3_30C8_map);
const static BranchMap NFKD_30EA_30C3_map {
    {0x30C8, NFKD_30EA_30C3_30C8}};
const static Trie NFKD_30EA_30C3(NFKD_30EA_30C3_map);
const static Trie NFKD_30EA_30E9(0x3352);
const static BranchMap NFKD_30EA_map {
    {0x30C3, NFKD_30EA_30C3},
    {0x30E9, NFKD_30EA_30E9}};
const static Trie NFKD_30EA(NFKD_30EA_map);
const static Trie NFKD_30EB_30D2_309A_30FC(0x3353);
const static BranchMap NFKD_30EB_30D2_309A_map {
    {0x30FC, NFKD_30EB_30D2_309A_30FC}};
const static Trie NFKD_30EB_30D2_309A(NFKD_30EB_30D2_309A_map);
const static BranchMap NFKD_30EB_30D2_map {
    {0x309A, NFKD_30EB_30D2_309A}};
const static Trie NFKD_30EB_30D2(NFKD_30EB_30D2_map);
const static Trie NFKD_30EB_30FC_30D5_3099_30EB(0x3354);
const static BranchMap NFKD_30EB_30FC_30D5_3099_map {
    {0x30EB, NFKD_30EB_30FC_30D5_3099_30EB}};
const static Trie NFKD_30EB_30FC_30D5_3099(NFKD_30EB_30FC_30D5_3099_map);
const static BranchMap NFKD_30EB_30FC_30D5_map {
    {0x3099, NFKD_30EB_30FC_30D5_3099}};
const static Trie NFKD_30EB_30FC_30D5(NFKD_30EB_30FC_30D5_map);
const static BranchMap NFKD_30EB_30FC_map {
    {0x30D5, NFKD_30EB_30FC_30D5}};
const static Trie NFKD_30EB_30FC(NFKD_30EB_30FC_map);
const static BranchMap NFKD_30EB_map {
    {0x30D2, NFKD_30EB_30D2},
    {0x30FC, NFKD_30EB_30FC}};
const static Trie NFKD_30EB(NFKD_30EB_map);
const static Trie NFKD_30EC_30E0(0x3355);
const static Trie NFKD_30EC_30F3_30C8_30B1_3099_30F3(0x3356);
const static BranchMap NFKD_30EC_30F3_30C8_30B1_3099_map {
    {0x30F3, NFKD_30EC_30F3_30C8_30B1_3099_30F3}};
const static Trie NFKD_30EC_30F3_30C8_30B1_3099(NFKD_30EC_30F3_30C8_30B1_3099_map);
const static BranchMap NFKD_30EC_30F3_30C8_30B1_map {
    {0x3099, NFKD_30EC_30F3_30C8_30B1_3099}};
const static Trie NFKD_30EC_30F3_30C8_30B1(NFKD_30EC_30F3_30C8_30B1_map);
const static BranchMap NFKD_30EC_30F3_30C8_map {
    {0x30B1, NFKD_30EC_30F3_30C8_30B1}};
const static Trie NFKD_30EC_30F3_30C8(NFKD_30EC_30F3_30C8_map);
const static BranchMap NFKD_30EC_30F3_map {
    {0x30C8, NFKD_30EC_30F3_30C8}};
const static Trie NFKD_30EC_30F3(NFKD_30EC_30F3_map);
const static BranchMap NFKD_30EC_map {
    {0x30E0, NFKD_30EC_30E0},
    {0x30F3, NFKD_30EC_30F3}};
const static Trie NFKD_30EC(NFKD_30EC_map);
const static Trie NFKD_30EF_30C3_30C8(0x3357);
const static BranchMap NFKD_30EF_30C3_map {
    {0x30C8, NFKD_30EF_30C3_30C8}};
const static Trie NFKD_30EF_30C3(NFKD_30EF_30C3_map);
const static BranchMap NFKD_30EF_map {
    {0x30C3, NFKD_30EF_30C3}};
const static Trie NFKD_30EF(NFKD_30EF_map);
const static Trie NFKD_5927_6B63(0x337D);
const static BranchMap NFKD_5927_map {
    {0x6B63, NFKD_5927_6B63}};
const static Trie NFKD_5927(NFKD_5927_map);
const static Trie NFKD_5E73_6210(0x337B);
const static BranchMap NFKD_5E73_map {
    {0x6210, NFKD_5E73_6210}};
const static Trie NFKD_5E73(NFKD_5E73_map);
const static Trie NFKD_660E_6CBB(0x337E);
const static BranchMap NFKD_660E_map {
    {0x6CBB, NFKD_660E_6CBB}};
const static Trie NFKD_660E(NFKD_660E_map);
const static Trie NFKD_662D_548C(0x337C);
const static BranchMap NFKD_662D_map {
    {0x548C, NFKD_662D_548C}};
const static Trie NFKD_662D(NFKD_662D_map);
const static Trie NFKD_682A_5F0F_4F1A_793E(0x337F);
const static BranchMap NFKD_682A_5F0F_4F1A_map {
    {0x793E, NFKD_682A_5F0F_4F1A_793E}};
const static Trie NFKD_682A_5F0F_4F1A(NFKD_682A_5F0F_4F1A_map);
const static BranchMap NFKD_682A_5F0F_map {
    {0x4F1A, NFKD_682A_5F0F_4F1A}};
const static Trie NFKD_682A_5F0F(NFKD_682A_5F0F_map);
const static BranchMap NFKD_682A_map {
    {0x5F0F, NFKD_682A_5F0F}};
const static Trie NFKD_682A(NFKD_682A_map);
const static BranchMap NFKD_map {
    {0x20, NFKD_20},
    {0x21, NFKD_21},
    {0x28, NFKD_28},
    {0x2E, NFKD_2E},
    {0x30, NFKD_30},
    {0x31, NFKD_31},
    {0x32, NFKD_32},
    {0x33, NFKD_33},
    {0x34, NFKD_34},
    {0x35, NFKD_35},
    {0x36, NFKD_36},
    {0x37, NFKD_37},
    {0x38, NFKD_38},
    {0x39, NFKD_39},
    {0x3A, NFKD_3A},
    {0x3D, NFKD_3D},
    {0x3F, NFKD_3F},
    {0x41, NFKD_41},
    {0x42, NFKD_42},
    {0x43, NFKD_43},
    {0x44, NFKD_44},
    {0x46, NFKD_46},
    {0x47, NFKD_47},
    {0x48, NFKD_48},
    {0x49, NFKD_49},
    {0x4B, NFKD_4B},
    {0x4C, NFKD_4C},
    {0x4D, NFKD_4D},
    {0x4E, NFKD_4E},
    {0x50, NFKD_50},
    {0x52, NFKD_52},
    {0x53, NFKD_53},
    {0x54, NFKD_54},
    {0x56, NFKD_56},
    {0x57, NFKD_57},
    {0x58, NFKD_58},
    {0x61, NFKD_61},
    {0x62, NFKD_62},
    {0x63, NFKD_63},
    {0x64, NFKD_64},
    {0x65, NFKD_65},
    {0x66, NFKD_66},
    {0x67, NFKD_67},
    {0x68, NFKD_68},
    {0x69, NFKD_69},
    {0x6B, NFKD_6B},
    {0x6C, NFKD_6C},
    {0x6D, NFKD_6D},
    {0x6E, NFKD_6E},
    {0x6F, NFKD_6F},
    {0x70, NFKD_70},
    {0x72, NFKD_72},
    {0x73, NFKD_73},
    {0x76, NFKD_76},
    {0x78, NFKD_78},
    {0xB0, NFKD_B0},
    {0x2BC, NFKD_2BC},
    {0x3A5, NFKD_3A5},
    {0x3BC, NFKD_3BC},
    {0x565, NFKD_565},
    {0x574, NFKD_574},
    {0x57E, NFKD_57E},
    {0x5D0, NFKD_5D0},
    {0x627, NFKD_627},
    {0x628, NFKD_628},
    {0x62A, NFKD_62A},
    {0x62B, NFKD_62B},
    {0x62C, NFKD_62C},
    {0x62D, NFKD_62D},
    {0x62E, NFKD_62E},
    {0x630, NFKD_630},
    {0x631, NFKD_631},
    {0x633, NFKD_633},
    {0x634, NFKD_634},
    {0x635, NFKD_635},
    {0x636, NFKD_636},
    {0x637, NFKD_637},
    {0x638, NFKD_638},
    {0x639, NFKD_639},
    {0x63A, NFKD_63A},
    {0x640, NFKD_640},
    {0x641, NFKD_641},
    {0x642, NFKD_642},
    {0x643, NFKD_643},
    {0x644, NFKD_644},
    {0x645, NFKD_645},
    {0x646, NFKD_646},
    {0x647, NFKD_647},
    {0x648, NFKD_648},
    {0x649, NFKD_649},
    {0x64A, NFKD_64A},
    {0x6C7, NFKD_6C7},
    {0x6D2, NFKD_6D2},
    {0x6D5, NFKD_6D5},
    {0xE4D, NFKD_E4D},
    {0xEAB, NFKD_EAB},
    {0xECD, NFKD_ECD},
    {0xFB2, NFKD_FB2},
    {0xFB3, NFKD_FB3},
    {0x1100, NFKD_1100},
    {0x1102, NFKD_1102},
    {0x1103, NFKD_1103},
    {0x1105, NFKD_1105},
    {0x1106, NFKD_1106},
    {0x1107, NFKD_1107},
    {0x1109, NFKD_1109},
    {0x110B, NFKD_110B},
    {0x110C, NFKD_110C},
    {0x110E, NFKD_110E},
    {0x110F, NFKD_110F},
    {0x1110, NFKD_1110},
    {0x1111, NFKD_1111},
    {0x1112, NFKD_1112},
    {0x2032, NFKD_2032},
    {0x2035, NFKD_2035},
    {0x222B, NFKD_222B},
    {0x222E, NFKD_222E},
    {0x3014, NFKD_3014},
    {0x307B, NFKD_307B},
    {0x3088, NFKD_3088},
    {0x30A2, NFKD_30A2},
    {0x30A4, NFKD_30A4},
    {0x30A6, NFKD_30A6},
    {0x30A8, NFKD_30A8},
    {0x30AA, NFKD_30AA},
    {0x30AB, NFKD_30AB},
    {0x30AD, NFKD_30AD},
    {0x30AF, NFKD_30AF},
    {0x30B1, NFKD_30B1},
    {0x30B3, NFKD_30B3},
    {0x30B5, NFKD_30B5},
    {0x30B7, NFKD_30B7},
    {0x30BB, NFKD_30BB},
    {0x30BF, NFKD_30BF},
    {0x30C6, NFKD_30C6},
    {0x30C8, NFKD_30C8},
    {0x30CA, NFKD_30CA},
    {0x30CE, NFKD_30CE},
    {0x30CF, NFKD_30CF},
    {0x30D2, NFKD_30D2},
    {0x30D5, NFKD_30D5},
    {0x30D8, NFKD_30D8},
    {0x30DB, NFKD_30DB},
    {0x30DE, NFKD_30DE},
    {0x30DF, NFKD_30DF},
    {0x30E1, NFKD_30E1},
    {0x30E4, NFKD_30E4},
    {0x30E6, NFKD_30E6},
    {0x30EA, NFKD_30EA},
    {0x30EB, NFKD_30EB},
    {0x30EC, NFKD_30EC},
    {0x30EF, NFKD_30EF},
    {0x5927, NFKD_5927},
    {0x5E73, NFKD_5E73},
    {0x660E, NFKD_660E},
    {0x662D, NFKD_662D},
    {0x682A, NFKD_682A}};
const static Trie NFKD_Trie(NFKD_map);

}

#endif
